# interface generated by SpecTcl version 1.0 from CopyScale.ui
#   root     is the parent window for this user interface

proc ChangeScaleFactor { i } {
    global CopyMoveInfo GidPriv
    if { $GidPriv(CopyMoveSameFactors)  } {
	foreach item {x y z} {
	    if { $item == $i } continue
	    set CopyMoveInfo($item,scale) $CopyMoveInfo($i,scale)
	}
    }
}

proc CopyScale_ui {root args} {
    global CopyMoveInfo GidPriv
    # this treats "." as a special case

    if {$root == "."} {
	set base ""
    } else {
	set base $root
    }
    set coordw 10
    set idw 8
    labelframe $base.frame#1 -borderwidth 2 -relief ridge -text [_ "Center"]
    labelframe $base.frame#3 -borderwidth 2 -relief ridge -text [_ "Scale factors"]

    #label $base.label#1 -text [_ "Center"]:
    label $base.label#2 -text [_ "Num"]:
    entry $base.entry#1 -textvariable CopyMoveInfo(Num,1) -width $idw

    button $base.button#1 -command {PickPointInMove 1} -image [GetImage "point16x16.gif"]
    #SetWidgetsWidthFromText $base.button#1

    label $base.label#3 -text x:
    entry $base.entry#2 -textvariable CopyMoveInfo(x,1) -width $coordw

    label $base.label#4 -text y:
    entry $base.entry#3 -textvariable CopyMoveInfo(y,1) -width $coordw

    label $base.label#5 -text z:
    entry $base.entry#4 -textvariable CopyMoveInfo(z,1) -width $coordw

    #label $base.label#14 -text [_ "Scale factors"]:
    checkbutton $base.checkbutton#1 -disabledforeground grey60 \
	    -highlightthickness 0 -text [_ "Same factors"] \
	    -variable GidPriv(CopyMoveSameFactors)
    label $base.label#13 -text x:
    entry $base.entry#12 -textvariable CopyMoveInfo(x,scale) -width $coordw

    label $base.label#12 -text y:
    entry $base.entry#9 -textvariable CopyMoveInfo(y,scale) -width $coordw

    label $base.label#11 -text z:
    entry $base.entry#10 -textvariable CopyMoveInfo(z,scale) -width $coordw

    # Geometry management

    grid $base.frame#1 -in $root -row 1 -column 1 -padx 2
    grid $base.frame#3 -in $root -row 3 -column 1 -sticky we -padx 2

    #grid $base.label#1 -in $base.frame#1 -row 1 -column 1 -columnspan 3 -sticky we -padx 2
    grid $base.label#2 -in $base.frame#1 -row 2 -column 1 -sticky w -padx 2
    grid $base.entry#1 -in $base.frame#1 -row 3 -column 1 -sticky w -padx 2

    grid $base.button#1 -in $base.frame#1 -row 4 -column 1 -sticky e -padx 2
    grid $base.label#3 -in $base.frame#1 -row 2 -column 2 -sticky e -padx 2
    grid $base.entry#2 -in $base.frame#1 -row 2 -column 3 -sticky w -padx 2

    grid $base.label#4 -in $base.frame#1 -row 3 -column 2 -sticky e -padx 2
    grid $base.entry#3 -in $base.frame#1 -row 3 -column 3 -sticky w -padx 2

    grid $base.label#5 -in $base.frame#1 -row 4 -column 2 -sticky e -padx 2
    grid $base.entry#4 -in $base.frame#1 -row 4 -column 3 -sticky w -padx 2

    #grid $base.label#14 -in $base.frame#3 -row 1 -column 1 -columnspan 3 -sticky we -padx 2

    grid $base.checkbutton#1 -in $base.frame#3 -row 1 -column 1 -columnspan 3 -sticky w -padx 2
    grid $base.label#13 -in $base.frame#3 -row 2 -column 2 -sticky e -padx 2
    grid $base.entry#12 -in $base.frame#3 -row 2 -column 3 -sticky ew -padx 2

    grid $base.label#12 -in $base.frame#3 -row 3 -column 2 -sticky e -padx 2
    grid $base.entry#9 -in $base.frame#3 -row 3 -column 3 -sticky ew -padx 2

    grid $base.label#11 -in $base.frame#3 -row 4 -column 2 -sticky e -padx 2
    grid $base.entry#10 -in $base.frame#3 -row 4 -column 3 -sticky ew -padx 2

    # Resize behavior management

    grid rowconfigure $base.frame#3 "1" -weight 0 -minsize 1
    grid rowconfigure $base.frame#3 "2 3 4" -weight 1 -minsize 1
    grid columnconfigure $base.frame#3 3 -weight 1 -minsize 1

    grid rowconfigure $root 3 -weight 1 -minsize 1
    grid columnconfigure $root 1 -weight 1 -minsize 1

    grid rowconfigure $base.frame#1 "1 2 3 4 5" -weight 0 -minsize 1
    grid columnconfigure $base.frame#1 "2 3" -weight 1 -minsize 1

    # additional interface code
    bind $base.entry#1 <Return>  "EnterNumInCopy 1"
    bind $base.entry#1 <FocusOut> "EnterNumInCopy 1"

    foreach id {2 3 4} {
	bind $base.entry#$id <Return> "EnterCoordInCopy 1"
	bind $base.entry#$id <FocusOut> "EnterCoordInCopy 1"
    }

    bind $base.entry#12 <Return> "ChangeScaleFactor x"
    bind $base.entry#9 <Return> "ChangeScaleFactor y"
    bind $base.entry#10 <Return> "ChangeScaleFactor z"
    bind $base.entry#12 <FocusOut> "ChangeScaleFactor x"
    bind $base.entry#9 <FocusOut> "ChangeScaleFactor y"
    bind $base.entry#10 <FocusOut> "ChangeScaleFactor z"

    # end additional interface code
}


# Allow interface to be run "stand-alone" for testing

catch {
    if {$argv0 == [info script]} {
	wm title . [_ "Testing CopyScale"]
	CopyScale_ui .
    }
}
