

# tclfile -*- TCL -*- Created: ramsan Aug-1996, Modified: ramsan Dec-1996
# for tk4.0

proc QuitFullScreen {} {
    if { [ info exists ::GidPriv(FullScreen)] && $::GidPriv(FullScreen)} {
	SwitchFullScreen
    }
    GiD_Process escape escape escape escape escape Quit
}

proc SetMenusVariables {} {
    global MenuNames MenuEntries MenuCommands MenuAcceler MenuIcons
    global tcl_platform GIDDEFAULT
    global GidPriv
    
    unset -nocomplain MenuNames MenuEntries MenuCommands MenuAcceler MenuIcons

    if { [ tk windowingsystem] eq "aqua"} {
	     set M Command
    } else {
	     set M Control
    }


    set MenuNames [list [_ "Files#C#menu"] [_ "View#C#menu,verb"] [_ "Geometry#C#menu"] [_ "Utilities#C#menu"] \
		       [_ "Data#C#menu"] [_ "Mesh#C#menu"] \
		       [_ "Calculate#C#menu"] [_ "Help#C#menu"] ]

    #---------------

    set MenuEntries(0) [list [_ "New#C#menu"] [_ "Open#C#menu"]... [_ "Recent projects#C#menu"] [_ "Save#C#menu"] [_ "Save as#C#menu"]... ---\
	    [_ "Import#C#menu"] [_ "Export#C#menu"] --- [_ "Postprocess#C#menu"] [_ "Recent post files#C#menu"] ---\
	    [_ "Print to file#C#menu"] [_ "Page/image setup#C#menu"]... [_ "Print#C#menu"]... \
	    --- [_ "Quit#C#menu"]]

    set MenuCommands(0) {{Files New} {Files Read} {-np- AddEntitiesToMenuRecentProjects %W} \
	    {Files Save} {Files SaveAs} "" "" "" \
	    "" Postprocess {-np- AddEntitiesToMenuRecentPostFiles %W}  "" "" {-np- PageSetup} {-np- HardcopyToPrint {Hardcopy PS}} \
			     "" { -np- QuitFullScreen} }

    set MenuAcceler(0) [list "$M-x $M-n" $M-o "" $M-s "$M-x $M-s" "" "" "" "" "" "" "" "" "" "" "" $M-q]
    set MenuIcons(0) {"new16x16.gif" "open16x16.gif" "" "save16x16.gif" "" "" "" "" "" \
	    "prepost16x16.gif" "" "" "camera16x16.gif" "" "print16x16.gif" "" "" "exit16x16.gif" }

    set MenuEntries(0,2) ""

    set MenuEntries(0,6) [list IGES... DXF... Parasolid... ACIS... \
		              VDA... Rhinoceros... Shapefile... [_ "XYZ points#C#menu"]... "KML..." ---  [_ "NASTRAN mesh#C#menu"]... \
	    [_ "STL mesh#C#menu"]... [_ "VRML mesh#C#menu"]... [_ "3DStudio mesh#C#menu"]... [_ "CGNS mesh#C#menu"]...\
		              [_ "GiD mesh#C#menu"]... [_ "Surface mesh#C#menu"]... [_ "Ply mesh#C#menu"]... [_ "VTK Voxels#C#menu"]... [_ "XYZ nodes#C#menu"]... \
	    ---  [_ "Batch file#C#menu"]... [_ "Insert GiD geometry#C#menu"]... ]

    set MenuCommands(0,6) { {Files IgesRead} {Files DxfRead} {Files ParasolidRead} {Files AcisRead}\
	{Files VDARead} {Files RhinoRead}  {Files ShapefileRead} {Files XYZRead ToPoints} {-np- ImportKMLWin} "" {Files NASTRANRead} \
	{Files STLRead} {Files VrmlRead} {Files 3DStudioRead} {Files CGNSRead} {Files MeshRead} \
	    {Files ReadSurfMeshes ReadFromFile} {Files PlyRead} {Files LoadVTKVoxels} {Files XYZRead ToNodes} "" \
	    {Files BatchFile} {Files InsertGeom} }

    set MenuAcceler(0,6) [list $M-i $M-d "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" $M-b ""]
    set MenuIcons(0,6) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}

    set MenuEntries(0,7) [list IGES... DXF... ACIS... Rhinoceros... \
		              --- [_ "%s mesh#C#menu" $::GidPriv(ProgName)]... --- \
		              [_ "Text data report#C#menu"]...  [_ "ASCII project#C#menu"]... [_ "ON layers#C#menu"]... --- \
		              [_ "Calculation file#C#menu"]... [_ "Using Template .bas (only mesh)#C#menu"]]

    set MenuCommands(0,7) { {Files IgesWrite} {Files DxfWrite} {Files AcisWrite} {Files RhinoWrite} "" {Files WriteMesh} "" \
	    {Files WriteAscii} {Files SaveAsciiProj} {Files SaveLayer} "" \
	    {Files WriteCalcFile} {-np- SetTemplatesMenu %W }}

    set MenuAcceler(0,7) [list "" "" "" "" "" "" "" "" "" "" "" "$M-x $M-c" ""]

    set MenuIcons(0,7) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" }

    set MenuEntries(0,7,12) ""

    set MenuEntries(0,10) ""

    set MenuEntries(0,12) [list [_ "PS/EPS Screen#C#menu"]... [_ "PS/EPS Vectorial#C#menu"]... --- \
	    [_ "BMP#C#menu"]... [_ "GIF#C#menu"]... [_ "JPEG#C#menu"]... [_ "PNG#C#menu"]... [_ "TGA#C#menu"]... [_ "TIFF#C#menu"]... [_ "VRML#C#menu"]...]

    set MenuCommands(0,12) [ list "" "" "" \
		                 { -ne- Hardcopy BMP} \
		                 { -ne- Hardcopy GIF} \
		                 { -ne- Hardcopy JPEG} \
		                 { -ne- Hardcopy PNG} \
		                 { -ne- Hardcopy TGA} \
		                 { -ne- Hardcopy TIFF} \
		                 { -ne- Hardcopy VRML} ]

    set MenuEntries(0,12,0) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommands(0,12,0) { { -ne- Hardcopy Options VectorialPS No Escape Hardcopy PS} \
		                   { -ne- Hardcopy Options VectorialPS No Escape Hardcopy EPS} }
    
    set MenuEntries(0,12,1) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommands(0,12,1) { { -ne- Hardcopy Options VectorialPS Yes Escape Hardcopy PS } \
		                   { -ne- Hardcopy Options VectorialPS Yes Escape Hardcopy EPS} }
    
    #--------------

    #copyclipboard only available for windows
    set what "PRE"
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntries(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		                [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... \
		                [_ "Clip planes#C#menu"]... [_ "Advanced options#C#menu"]... --- \
		                [_ "Label#C#menu"] [_ "Normals#C#menu"] [_ "Higher entities#C#menu"] \
		                [_ "Curvatures#C#menu"] --- \
		                [_ "View#C#menu,noun"] [_ "Recent view files#C#menu"] --- \
		                [_ "Background image#C#menu"] \
		                [_ "Image to clipboard#C#menu"] \
		                [_ "Multiple windows#C#menu"]... \
		                --- [_ "Mode#C#menu"] [_ "Full screen"]]
	set MenuCommands(1) [list "" "" "" "" \
		                 {-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} \
		                 {-np- ClipPlanes} {-np- StereoW} "" \
		                 "" {-np- AddEntitiesToMenuDrawNormals %W} {-np- AddEntitiesToMenuDrawHigher %W} \
		                 {-np- AddEntitiesToMenuDrawCurvatures %W} "" \
		                 "" {-np- AddEntitiesToMenuRecentViewFiles %W} "" \
		                 {-np- AddEntitiesToMenuBackgroundImage %W} {-ne- hardcopy copyclipboard} \
		                 {-np- ViewSeveralWindows} "" [list -np- ViewModeMenu %W $what] {-np- SwitchFullScreen}]
	set MenuAcceler(1) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "F5" }
	set MenuIcons(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" "" "" "" "" "" \
		               "" "" "" "" "" "" "" "FullScreen16.gif" }
    } else {
	set MenuEntries(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		                [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... \
		                [_ "Clip planes#C#menu"]... [_ "Advanced options#C#menu"]... --- \
		                [_ "Label#C#menu"] [_ "Normals#C#menu"] [_ "Higher entities#C#menu"] \
		                [_ "Curvatures#C#menu"] --- \
		                [_ "View#C#menu,noun"] [_ "Recent view files#C#menu"] --- \
		                [_ "Background image#C#menu"] \
		                [_ "Multiple windows#C#menu"]... \
		                --- [_ "Mode#C#menu"] [_ "Full screen"]]
	set MenuCommands(1) [list "" "" "" "" \
		                 {-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} \
		                 {-np- ClipPlanes} {-np- StereoW} "" \
		                 "" {-np- AddEntitiesToMenuDrawNormals %W} {-np- AddEntitiesToMenuDrawHigher %W} \
		                 {-np- AddEntitiesToMenuDrawCurvatures %W} "" "" {-np- AddEntitiesToMenuRecentViewFiles %W} "" \
				 {-np- AddEntitiesToMenuBackgroundImage %W} {-np- ViewSeveralWindows} "" \
				 [list -np- ViewModeMenu %W $what] {-np- SwitchFullScreen}]
	set MenuAcceler(1) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "F5"}
	set MenuIcons(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "FullScreen16.gif" }
    }
    # invoked to set up accelerators
    ViewModeMenu "" PRE

    set MenuEntries(1,0) [list [_ "In#C#menu"] [_ "Out#C#menu"] --- [_ "Dynamic#C#menu"] [_ "Previous#C#menu"] \
	    [_ "Next#C#menu"] --- [_ "Frame#C#menu"]]
    set MenuCommands(1,0) { {-ne- Zoom In} {-ne- Zoom Out} "" \
	    {-ne- Zoom Dynamic} \
	    {-ne- Zoom Previous} {-ne- Zoom Next} "" {-ne- Zoom Frame} }
    set MenuIcons(1,0) { "zoomin16x16.gif" "zoomout16x16.gif" "" "" "" "" "" "zframe16x16.gif" }

    set MenuEntries(1,1) [list [_ "Trackball#C#menu"] [_ "Screen axes#C#menu"] [_ "Object axes#C#menu"] \
	    [_ "Center#C#menu"] --- [_ "Plane XY (Original)#C#menu"] [_ "Plane XZ#C#menu"] [_ "Plane YZ#C#menu"] [_ "Isometric#C#menu"]]
    set MenuCommands(1,1) { {-ne- Rotate Trackball} {-ne- Rotate ScrAxes} \
	    {-ne- Rotate ObjAxes}  {-ne- Rotate Center FJoin} \
	    "" {-ne- Rotate Angle 270 90} {-ne- Rotate Angle 270 0} \
	    {-ne- Rotate Angle 0 0} {-ne- Rotate Angle 45 45} }
    set MenuIcons(1,1) { "rotate16x16.gif" "" "" "" "" "" "" "" "" }

    set MenuEntries(1,2) [list [_ "Two point#C#menu"] [_ "Dynamic#C#menu"]]
    set MenuCommands(1,2) { {-ne- pan} {-ne- DynamicPan} }
    set MenuIcons(1,2) { "" "pan16x16.gif" }

    set MenuEntries(1,5) ""
    set MenuCommands(1,5) ""

    set MenuEntries(1,10) [list [_ "All#C#menu"] [_ "All in#C#menu"] [_ "Select#C#menu"] --- [_ "Off#C#menu"]]
    set MenuCommands(1,10) { {-ne- label All} \
		                 {-np- AddBitmapsToMenu %W {GiD_Process Label  } } \
		                 {-np- AddBitmapsToMenu %W {GiD_Process Label Select } } "" \
		                 {-ne- label Off} }
    set MenuEntries(1,10,1) {}
    set MenuCommands(1,10,1) {}
    set MenuEntries(1,10,2) {}
    set MenuCommands(1,10,2) {}

    set MenuEntries(1,11) ""

    set MenuEntries(1,12) ""
    set MenuEntries(1,13) ""

    set MenuEntries(1,15) [list [_ "Read#C#menu"]... [_ "Save#C#menu"]...]
    set MenuCommands(1,15) { {View ReadView} {View SaveView} }

    set MenuEntries(1,16) ""
    set MenuCommands(1,16) ""

    set MenuEntries(1,18) ""
    set MenuCommands(1,18) ""

    #view mode
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntries(1,22) ""
	set MenuCommands(1,22) ""
    } else {
	set MenuEntries(1,21) ""
	set MenuCommands(1,21) ""
    }

    #-----------

    set MenuEntries(2) [list [_ "View geometry#C#menu"] --- [_ "Create#C#menu"] [_ "Delete#C#menu"] [_ "Edit#C#menu"]]
    set MenuCommands(2) { {-np- GeometryView} "" "" "" ""}
    set MenuAcceler(2) { "" "" "" "" "" }
    set MenuIcons(2) {"" "" "" "erase16x16.gif" "" }

    set MenuEntries(2,2) [list [_ "Point#C#menu"] --- \
	    [_ "Straight line#C#menu"] [_ "NURBS line#C#menu"] [_ "Parametric line#C#menu"]... \
	    [_ "Polyline#C#menu"] [_ "Arc#C#menu"] --- \
	    [_ "NURBS surface#C#menu"] [_ "Parametric surface#C#menu"]... \
	    [_ "Contact surface#C#menu"] [_ "Surface mesh#C#menu"] [_ "Geometry from mesh#C#menu"] --- \
	    [_ "Volume#C#menu"] [_ "Contact#C#menu"] --- [_ "Object#C#menu"]]
    set MenuCommands(2,2) "{Geometry Create Point} {} \
	{Geometry Create Line} {Geometry Create NurbsLine} {-np- ParametricLine} \
	{Geometry Create Polyline} {} {} \
	{} {-np- ParametricSurface} {Geometry Create Contact Surface} \
	{Geometry Create SurfMesh SelectMesh} {Geometry Edit ReConstruction Meshes 1:end Escape Otherwise Yes Escape} \
	{} {} {} {} {}"
    set MenuIcons(2,2) { "point16x16.gif" "" "line16x16.gif" "spline16x16.gif" "" "poly16x16.gif" "arc16x16.gif" "" \
	"surface16x16.gif" "" "" "" "" "volume16x16.gif" "" "" "object16x16.gif" }

    set MenuEntries(2,2,6) [list [_ "By 3 points#C#menu"] [_ "Fillet curves#C#menu"]]
    set MenuCommands(2,2,6) "{Geometry Create Arc} {Geometry Create Arc ByTangents}"

    set MenuEntries(2,2,8) [list [_ "By contour#C#menu"] [_ "Automatic#C#menu"] [_ "Trimmed#C#menu"] [_ "Untrimmed#C#menu"]\
	    [_ "Parallel Lines#C#menu"] [_ "By Points#C#menu"] [_ "By LinePoints#C#menu"] [_ "Search#C#menu"] ]
    set MenuCommands(2,2,8) { {Geometry Create NurbsSurface} \
	{Geometry Create NurbsSurface Automatic} \
	    {Geometry Create TrimmedNurb} {Geometry Create UntrimSurf} \
	{Geometry Create NurbsSurface ParallelLines} \
	    {Geometry Create NurbsSurface ByPoints} \
	{Geometry Create NurbsSurface ByLinePoints} \
	    {Geometry Create NurbsSurface Search} }

    set MenuEntries(2,2,14) [list [_ "By contour#C#menu"] [_ "Automatic 6-sided volumes#C#menu"] \
	    [_ "Search#C#menu"]]
    set MenuCommands(2,2,14) "{Geometry Create Volume} \
	{Geometry Create Volume AutomaticStruct} \
	{Geometry Create Volume Search}"
	
    set MenuEntries(2,2,15) [list [_ "Volume#C#menu"] [_ "Separated volume#C#menu"]]
    set MenuCommands(2,2,15) { {Geometry Create Contact Volume} {Geometry Create Contact SeparatedVolume}}

    set MenuEntries(2,2,17) [list [_ "Rectangle#C#menu"] [_ "Polygon#C#menu"] [_ "Circle#C#menu"] --- \
	    [_ "Sphere#C#menu"] [_ "Cylinder#C#menu"] [_ "Cone#C#menu"] [_ "Prism#C#menu"] [_ "Torus#C#menu"] ]
    set MenuCommands(2,2,17) { {Geometry Create Object Rectangle } \
	{Geometry Create Object PolygonPNR } \
	{Geometry Create Object CirclePNR } "" {Geometry Create Object Sphere } \
	    {Geometry Create Object Cylinder } {Geometry Create Object Cone } \
	    {Geometry Create Object Prism } {Geometry Create Object Torus} }


    set MenuEntries(2,3) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"] \
	    --- [_ "All types#C#menu"]]
    set MenuCommands(2,3) { {Geometry Delete Point} {Geometry Delete Line} \
	    {Geometry Delete Surface} {Geometry Delete Volume} "" \
	    {Geometry Delete AllTypes} }

    set MenuEntries(2,4) [list [_ "Move point#C#menu"] [_ "Divide#C#menu"] [_ "Join#C#menu"] [_ "Lines operations#C#menu"] \
	    [_ "Swap arc#C#menu"] [_ "Polyline#C#menu"] [_ "SurfMesh#C#menu"] \
	    --- [_ "Edit NURBS#C#menu"] [_ "Convert to NURBS#C#menu"] [_ "Simplify NURBS#C#menu"] \
	    [_ "Hole NURBS surface#C#menu"] --- [_ "Hole volume#C#menu"] --- [_ "Collapse#C#menu"] [_ "Uncollapse#C#menu"] --- \
	    [_ "Intersection#C#menu"] [_ "Surface boolean op.#C#menu"] [_ "Volume boolean op.#C#menu"]]
    set MenuCommands(2,4) { {Geometry Edit MovePoint} "" "" "" \
	{Geometry Edit SwapArc} "" {Geometry Edit EditSurfMeshes} "" "" "" "" \
	{Geometry Edit HoleNurb} "" {Geometry Create Volume hole} "" "" "" "" "" "" ""}
	
    set MenuEntries(2,4,1) [list [_ "Lines#C#menu"] [_ "Polylines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(2,4,1) { "" {Geometry Edit DivideLine Multiple PolyLine} "" "" }

    set MenuEntries(2,4,1,0) [list [_ "Num divisions#C#menu"] [_ "Near point#C#menu"] [_ "Parameter#C#menu"] \
	    [_ "Relative Length#C#menu"] [_ "Length#C#menu"]]
    set MenuCommands(2,4,1,0) { {Geometry Edit DivideLine Multiple NumDivisions } \
	    {Geometry Edit DivideLine Multiple Point } \
	    {Geometry Edit DivideLine Multiple Parameter } \
	    {Geometry Edit DivideLine Multiple RelativeLength } \
	    {Geometry Edit DivideLine Multiple Measure } }

    set MenuEntries(2,4,1,2) [list [_ "Num divisions#C#menu"] [_ "Near point#C#menu"] [_ "Parameter#C#menu"] [_ "Split#C#menu"]]
    set MenuCommands(2,4,1,2) { {Geometry Edit DivideSurf NumDivisions } \
	{Geometry Edit DivideSurf Point } {Geometry Edit DivideSurf Parameter } \
	    {Geometry Edit SplitSurf } }

    set MenuEntries(2,4,1,3) [list [_ "Split#C#menu"]]
    set MenuCommands(2,4,1,3) { {Geometry Edit SplitVolume } }

    set MenuEntries(2,4,2) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(2,4,2) { ""  {Geometry Edit JoinVolumes}}

    set MenuEntries(2,4,2,0) [list [_ "Rebuild by boundary#C#menu"] [_ "Join only coplanars#C#menu"]]
    set MenuCommands(2,4,2,0) { {Geometry Edit JoinSurfaces QuickJoin} {Geometry Edit JoinSurfaces JoinCoplanary} }

    set MenuEntries(2,4,3) [list [_ "Join lines end points#C#menu"] [_ "Force to be tangent#C#menu"]]
    set MenuCommands(2,4,3) { {Geometry Edit JoinLinesExt} {Geometry Edit TangentNurbsL } }

    set MenuEntries(2,4,5) [list [_ "Explode polyline#C#menu"] [_ "Edit polyline#C#menu"]]
    set MenuCommands(2,4,5) { {Geometry Edit ExplodePoly} {Geometry Edit EdPoly} }

    set MenuEntries(2,4,8) [list [_ "Line#C#menu"]... [_ "Surface#C#menu"]... ]
    set MenuCommands(2,4,8) { { -np- EditNURBS Line } { -np- EditNURBS Surface } }

    set MenuEntries(2,4,9) [list [_ "Line#C#menu"] [_ "Surface#C#menu"]]
    set MenuCommands(2,4,9) { {Geometry Edit ConvToNurbsL} {Geometry Edit ConvToNurbsS} }

    set MenuEntries(2,4,10) [list [_ "Model#C#menu"] --- [_ "Line#C#menu"] [_ "Surface#C#menu"]]
    set MenuCommands(2,4,10) { {Geometry Edit SimplifyNurbsS All escape escape escape Geometry Edit SimplifyNurbsL All} "" \
		{Geometry Edit SimplifyNurbsL} {Geometry Edit SimplifyNurbsS} }

    set MenuEntries(2,4,15) [list [_ "Model#C#menu"] --- \
	    [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(2,4,15) { {Utilities Collapse model} "" {Utilities Collapse points} \
	{Utilities Collapse Lines} {Utilities Collapse Surfaces} {Utilities Collapse Volumes} }

    set MenuEntries(2,4,16) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(2,4,16) { {Utilities Uncollapse Lines} {Utilities Uncollapse Surfaces} \
	    {Utilities Uncollapse Volumes} }


    set MenuEntries(2,4,18) [list [_ "Lines#C#menu"] --- \
	    [_ "Surface-2 points#C#menu"] [_ "Surface-lines#C#menu"] \
	    [_ "Surfaces#C#menu"] ]

    set MenuCommands(2,4,18) { {Geometry Create IntMultLines} "" {Geometry Create IntSurfPnts} \
	{Geometry Create IntSurfLine} {Geometry Create IntMultSurfs} }

    set MenuEntries(2,4,19) [list [_ "Union#C#menu"] [_ "Intersection#C#menu"] [_ "Substraction#C#menu"] [_ "Substract and intersect#C#menu"]]

    set MenuCommands(2,4,19) "{Geometry Create IntSolid2D Union} \
	{Geometry Create IntSolid2D Intersect} \
	{Geometry Create IntSolid2D Substract} \
	{Geometry Create IntSolid2D SubstractAndIntersect}"

    set MenuEntries(2,4,20) [list [_ "Union#C#menu"] [_ "Intersection#C#menu"] [_ "Substraction#C#menu"] [_ "Substract and intersect#C#menu"]]

    set MenuCommands(2,4,20) "{Geometry Create IntSolid3D Union} \
	{Geometry Create IntSolid3D Intersect} \
	{Geometry Create IntSolid3D Substract} \
	{Geometry Create IntSolid3D SubstractAndIntersect}"
    #--------------

    set MenuEntries(3) [list [_ "Undo#C#menu"]... --- [_ "Preferences#C#menu"]... [_ "Layers#C#menu"]... --- \
		            [_ "Tools#C#menu"] --- [_ "Copy#C#menu"]... [_ "Move#C#menu"]... \
		            --- [_ "Status#C#menu"]... [_ "List#C#menu"] [_  "Mass#C#menu"] [_ "Renumber#C#menu"] [_ "Id#C#menu"] \
		            [_ "Signal#C#menu"] --- [_ "Swap normals#C#menu"] [_ "Distance#C#menu"] \
		            [_ "Dimension#C#menu"] --- [_ "Repair model#C#menu"]]

    set MenuCommands(3) { { -np- UndoCom} "" \
	    {-np- ChangeVariables } { -np- ChangeLayers } "" "" "" {-np- CopyMove Copy} \
			      {-np- CopyMove Move} "" {Utilities List Status } \
			      {-np- AddEntitiesToMenuAfter -1 %W {GiD_Process Mescape Utilities List}} \
			      {-np- AddEntitiesToMenuAfter -1 %W  {GiD_Process Mescape Utilities List MassProp}} \
			      {Utilities Renumber} {Utilities Id} \
			      {-np- AddEntitiesToMenuAfter 0 %W {GiD_Process Mescape Utilities SignalEntities} } \
			      "" {-np- AddEntitiesToMenuSwapNormals %W } {Utilities Dist} "" "" {Utilities Repair}}

    set MenuAcceler(3) [list $M-z "" $M-p $M-l "" "" "" $M-c $M-v "" "" "" "" "" "" "" "" "" "" "" "" ""]
    set MenuIcons(3) {"" "" "prefs16x16.gif" "layers16x16.gif" "" "" "" "copy16x16.gif" "" \
	"" "" "list16x16.gif" "" "" "" "" "" "" "" ""}

    set MenuEntries(3,5) [list [_ "Toolbars#C#menu"]... --- \
	    [_ "Save window conf#C#menu"]... [_ "Move Screen Objects#C#menu"] --- \
	    [_ "Coordinates window#C#menu"]... [_ "Read batch window#C#menu"]... [_ "Comments#C#menu"]... \
	    [_ "Animation controls#C#menu"]... [_ "Animation script#C#menu"]... \
	    [_ "Macros#C#menu"]... [_ "Selection window#C#menu"]... --- [_ "Calculator#C#menu"]... [_ "Report#C#menu"]... \
	    [_ "Notes#C#menu"]...]
    set MenuIcons(3,5) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "Report16x16.gif" ""}

    set MenuCommands(3,5) { {-np- TOBegin} "" \
	    {-np- SaveWinConfiguration} { -ne- MoveScrObj} "" {-np- SetCoord} \
	    {-np- ReadBatch} {-np- CommentsW} \
	    {-np- PostAnimateControls} {-np- ::AutoAnimate::Crear} \
	    {-np- toolbarmacros::MacrosWindow} {-np- make_win_filter} \
	    "" {-np- CalculatorV} {-np- GIDReport::Crear} {-np- OpenNotes}}

    set MenuEntries(3,11) ""

    set MenuEntries(3,12) ""

    set MenuEntries(3,15) [list [_ "New point#C#menu"]]
    set MenuCommands(3,15) { {Utilities SignalEntities Point FNoJoin} }
    set MenuIcons(3,15) { "" }

    set MenuEntries(3,17) ""

    set MenuEntries(3,19) [list [_ "Create#C#menu"] [_ "Delete#C#menu"] [_ "Edit#C#menu"] [_ "ShowBox#C#menu"] ]
    set MenuCommands(3,19) { "" {Utilities Dimension Delete} \
	{Utilities Dimension Edit} "" }

    set MenuEntries(3,19,0) [list [_ "Vertex#C#menu"] [_ "Distance#C#menu"] [_ "Angle#C#menu"] [_ "Radius#C#menu"] [_ "Text#C#menu"] ]
    set MenuCommands(3,19,0) { {Utilities Dimension Create Vertex} {Utilities Dimension Create Distance} \
	{Utilities Dimension Create Angle} {Utilities Dimension Create Radius} \
	    {Utilities Dimension Create Text} }

    set MenuEntries(3,19,3) [list [_ "On#C#menu"] [_ "Off#C#menu"] ]
    set MenuCommands(3,19,3) { {Utilities Dimension ShowBox} {Utilities Dimension HideBox} }


    #---------------

    set MenuEntries(4) ""
    set MenuCommands(4) {-np- PostDataMenu %W}
    set MenuAcceler(4) ""
    set MenuIcons(4) ""

    #---------------

    set MenuEntries(5) [list [_ "Unstructured#C#menu"] [_ "Structured#C#menu"] \
	    [_ "SemiStructured#C#menu"] [_ "Cartesian#C#menu"] --- [_ "Boundary layer#C#menu"] --- \
	    [_ "Element type#C#menu"]\
	    [_ "Mesh criteria#C#menu"] [_ "Reset mesh data#C#menu"] [_ "Draw#C#menu"] --- \
	    [_ "Generate mesh#C#menu"]... [_ "Erase mesh#C#menu"] [_ "Edit mesh#C#menu"] \
	    [_ "Show errors#C#menu"]... --- \
	    [_ "View mesh boundary#C#menu"] [_ "Create boundary mesh#C#menu"] --- [_ "Mesh quality#C#menu"]... \
	    --- [_ "Mesh options from model#C#menu"] ]
    set MenuAcceler(5) [list "" "" "" "" "" "" "" "" "" "" "" "" $M-g "" "" "" "" "" "" "" "" "" ""]
    set MenuIcons(5) { "" "" "" "" "" "" "" "" "" "" "" "" "mesh16x16.gif" "" "" "" "" "" "" "" "" "" ""}

    set MenuCommands(5) { "" "" "" "" "" "" "" "" ""\
	{Meshing reset} "" "" {Meshing Generate} {Meshing CancelMesh PreserveFrozen} "" {-np- MeshErrors} ""\
	{Meshing Boundaries} {Meshing CreateBoundary} "" {-np- MeshQuality} "" {-np- SetMeshOptionsFromStatus} }

    set MenuEntries(5,0) [list [_ "Assign sizes on points#C#menu"] [_ "Assign sizes on lines#C#menu"] \
	    [_ "Assign sizes on surfaces#C#menu"] [_ "Assign sizes on volumes#C#menu"] --- \
	    [_ "Sizes by chordal error#C#menu"]... [_ "Sizes by background mesh#C#menu"]... \
	    [_ "Correct sizes#C#menu"]... --- [_ "Assign entities#C#menu"]]
    set MenuCommands(5,0) { {Meshing AssignSizes Points} \
	    {Meshing AssignSizes Lines} {Meshing AssignSizes Surfaces} \
	    {Meshing AssignSizes Volumes} "" {-np- CEBegin} \
	    {Meshing AssignSizes BackgMesh} {-np- CEBeginCorrectSizes} "" "" }
    set MenuIcons(5,0) { "point16x16.gif" "line16x16.gif" "surface16x16.gif" "volume16x16.gif" \
	"" "" "" "" "" "" }

    set MenuEntries(5,0,9) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,0,9) { {Meshing AssignSizes Lines 0.0} \
	{Meshing AssignSizes Surfaces 0.0} {Meshing AssignSizes Volumes 0.0} }

    set MenuEntries(5,1) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]

    set MenuCommands(5,1) { "" "" "" }
    set MenuIcons(5,1) { line16x16.gif surface16x16.gif volume16x16.gif }

    set MenuEntries(5,1,0) [list [_ "Assign number of cells#C#menu"] [_ "Assign size#C#menu"] \
	    --- [_ "Concentrate elements#C#menu"]]
    set MenuCommands(5,1,0) {{Meshing Structured Lines} {Meshing Structured Lines Size} "" {Meshing StructConcentr} }

    set MenuEntries(5,1,1) [list [_ "Assign number of cells#C#menu"] [_ "Assign size#C#menu"] \
	    --- [_ "Center structured#C#menu"] [_ "Set center#C#menu"]]
    set MenuCommands(5,1,1) { {Meshing Structured Surfaces} {Meshing Structured Surfaces Size} \
	"" {-np- CenterStructured Modeless} {Meshing CenterStruct SetCenter} }

    set MenuEntries(5,1,2) [list [_ "Assign number of cells#C#menu"] [_ "Assign size#C#menu"]]
    set MenuCommands(5,1,2) {{Meshing Structured Volumes} {Meshing Structured Volumes Size} }


    set MenuEntries(5,2) [list [_ "Volumes#C#menu"] [_ "Set#C#menu"]]
    set MenuCommands(5,2) { {Meshing SemiStructured Volumes} "" }
    set MenuIcons(5,2) { volume16x16.gif "" }

    set MenuEntries(5,2,1) [list [_ "Master surface#C#menu"] [_ "Structured direction#C#menu"]]
    set MenuCommands(5,2,1) {{Meshing SemiStructured SetMaster} \
	    {Meshing SemiStructured SetDirection} }

    set MenuEntries(5,3) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] \
	    [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,3) { {Meshing Cartesian Points} {Meshing Cartesian Lines} \
	    {Meshing Cartesian Surfaces} {Meshing Cartesian Volumes} }
    set MenuIcons(5,3) { point16x16.gif line16x16.gif surface16x16.gif volume16x16.gif }

    set MenuEntries(5,5) [list [_ "2D#C#menu"] [_ "3D#C#menu"] \
	    --- [_ "Reset#C#menu"]]
    set MenuCommands(5,5)  { "" "" "" {Meshing BoundaryLayerMesh reset all}}

    set MenuEntries(5,5,0) [list [_ "Assign#C#menu"] [_ "Unassign#C#menu"]]
    set MenuCommands(5,5,0) {{Meshing BoundaryLayerMesh 2d} {Meshing BoundaryLayerMesh reset 2d} }

    set MenuEntries(5,5,1) [list [_ "Assign#C#menu"] [_ "Unassign#C#menu"]]
    set MenuCommands(5,5,1) {{Meshing BoundaryLayerMesh 3d} {Meshing BoundaryLayerMesh reset 3d} }
	
    set MenuEntries(5,7) [list [_ "Default#C#menu"] [_ "Linear#C#menu"] --- \
	    [_ "Triangle#C#menu"] [_ "Quadrilateral#C#menu"] [_ "Circle#C#menu"] --- \
	    [_ "Tetrahedra#C#menu"] [_ "Hexahedra#C#menu"] \
	    [_ "Prism#C#menu"] [_ "Sphere#C#menu"] [_ "Only points#C#menu"]]
    set MenuCommands(5,7) { "" "" "" \
	{-np- ChooseElemType Triangle} {-np- ChooseElemType Quadrilateral} {-np- ChooseElemType Circle Surfaces} "" \
	    {-np- ChooseElemType Tetrahedra} {-np- ChooseElemType Hexahedra} \
	{-np- ChooseElemType Prism} {-np- ChooseElemType Sphere Volumes} {-np- ChooseElemType OnlyPoints} }

    set MenuEntries(5,7,0) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,7,0) {{-np- ChooseElemType Default Surfaces} \
	{-np- ChooseElemType Default Volumes}}

    #set MenuEntries(5,7,1) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    #set MenuCommands(5,7,1) {{-np- ChooseElemType Linear Lines} \
	#        {-np- ChooseElemType Linear Surfaces} \
	    #        {-np- ChooseElemType Linear Volumes}}
    set MenuEntries(5,7,1) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,7,1) {{-np- ChooseElemType Linear Surfaces} \
	{-np- ChooseElemType Linear Volumes}}

    #set MenuEntries(5,7,11) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    #set MenuCommands(5,7,11) {{-np- ChooseElemType Sphere Surfaces} {-np- ChooseElemType Sphere Volumes}}

    set MenuEntries(5,8) [list [_ "Default#C#menu"] --- [_ "Mesh#C#menu,verb"] [_ "No mesh#C#menu,verb"] [_ "Default mesh#C#menu,verb" ] --- \
	    [_ "Skip#C#menu"] [_ "No skip#C#menu"] [_ "Automatic skip#C#menu"] [_ "Skip by...#C#menu"] --- \
	    [_ "Force points to#C#menu"] --- [_ "Duplicate#C#menu"] [_ "No Duplicate#C#menu"]]
    set MenuCommands(5,8) { "" "" "" "" "" "" "" "" "" {-np- RJBegin} "" "" "" "" ""}

    set MenuEntries(5,8,0) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,8,0) {{Meshing MeshCriteria DefaultAll Points} \
	{Meshing MeshCriteria DefaultAll Lines} \
	    {Meshing MeshCriteria DefaultAll Surfaces} \
	{Meshing MeshCriteria DefaultAll Volumes} }

    set MenuEntries(5,8,2) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,8,2) {{Meshing MeshCriteria Mesh Points} \
	{Meshing MeshCriteria Mesh Lines} \
	    {Meshing MeshCriteria Mesh Surfaces} \
	    {Meshing MeshCriteria Mesh Volumes} }

    set MenuEntries(5,8,3) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,8,3) {{Meshing MeshCriteria NoMesh Points} \
	{Meshing MeshCriteria NoMesh Lines} \
	    {Meshing MeshCriteria NoMesh Surfaces} \
	    {Meshing MeshCriteria NoMesh Volumes} }

    set MenuEntries(5,8,4) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,8,4) {{Meshing MeshCriteria DefaultMesh Points} \
	{Meshing MeshCriteria DefaultMesh Lines} \
	    {Meshing MeshCriteria DefaultMesh Surfaces} \
	    {Meshing MeshCriteria DefaultMesh Volumes} }

    set MenuEntries(5,8,6) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
    set MenuCommands(5,8,6) {{Meshing MeshCriteria Skip Points} \
	{Meshing MeshCriteria Skip Lines} }

    set MenuEntries(5,8,7) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
    set MenuCommands(5,8,7) {{Meshing MeshCriteria NoSkip Points} \
	{Meshing MeshCriteria NoSkip Lines} }

    set MenuEntries(5,8,8) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
    set MenuCommands(5,8,8) {{Meshing MeshCriteria DefaultSkip Points} \
	{Meshing MeshCriteria DefaultSkip Lines} }

    set MenuEntries(5,8,11) [list [_ "Surface mesh#C#menu"] [_ "Volume mesh#C#menu"] ]
    set MenuCommands(5,8,11) {{Meshing MeshCriteria ForcePointsTo SurfaceMesh} \
	{Meshing MeshCriteria ForcePointsTo VolumeMesh} }

    set MenuEntries(5,8,13) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]
    set MenuCommands(5,8,13) { {Meshing MeshCriteria DuplicateNodes Lines} \
	{Meshing MeshCriteria DuplicateNodes Surfaces}}

    set MenuEntries(5,8,14) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]
    set MenuCommands(5,8,14) { {Meshing MeshCriteria NoDuplicateNodes Lines} \
	{Meshing MeshCriteria NoDuplicateNodes Surfaces}}

    set MenuEntries(5,10) [list [_ "Sizes#C#menu"] [_ "Num of divisions#C#menu"] \
	    [_ "Element type#C#menu"] [_ "Mesh / No mesh#C#menu,verb"] \
	    [_ "Structured type#C#menu"] [_ "Skip entities (Rjump)#C#menu"] [_ "Duplicate#C#menu"] \
	    [_ "Force points to#C#menu"] [_ "Boundary layer#C#menu"]]
    #     set MenuCommands(5,11) {"-np- DrawSize %W" {Meshing DrawNumOfDivisions Lines} \
	#         "-np- DrawElementType %W" "-np- DrawMeshNoMesh %W" "-np- DrawStructuredType %W" \
	    #         {Meshing DrawRjumpSkip} {Meshing DrawDuplicate} "-np- DrawForcePointsToMesh %W" \
	    #             "-np- DrawBoundaryLayerMesh %W" }
    set MenuCommands(5,10) {"-np- DrawSize %W" {Meshing DrawNumOfDivisions Lines} \
	"-np- DrawElementType %W" "-np- DrawMeshNoMesh %W" "-np- DrawStructuredType %W" \
	{Meshing DrawRjumpSkip} {Meshing DrawDuplicate} "-np- DrawForcePointsToMesh %W" \
	{Meshing DrawBoundaryLayerMesh Automatic}}

    set MenuEntries(5,10,0) ""
    set MenuCommands(5,10,0) ""

    set MenuEntries(5,10,2) ""
    set MenuCommands(5,10,2) ""

    set MenuEntries(5,10,3) ""
    set MenuCommands(5,10,3) ""

    set MenuEntries(5,10,4) ""
    set MenuCommands(5,10,4) ""

    set MenuEntries(5,10,7) ""
    set MenuCommands(5,10,7) ""

#     set MenuEntries(5,10,8) ""
#     set MenuCommands(5,10,8) ""

    set MenuEntries(5,14) [list [_ "Create node#C#menu"] [_ "Move node#C#menu"] ---   \
	    [_ "Create element#C#menu"] [_ "Split elements#C#menu"] [_ "Smooth elements#C#menu"] --- \
	    [_ "Collapse#C#menu"] [_ "Delete#C#menu"]]
    set MenuCommands(5,14) { {Meshing EditMesh CreateNode} {Meshing EditMesh MoveNode} "" \
	{-np- AddEntitiesToMenuCreateElement %W} \
	"" {Meshing EditMesh Smoothing} ""  \
	    ""  "" }

    set MenuEntries(5,14,3) ""
    set MenuEntries(5,14,4) [list \
	    [_ "Triangle#C#menu"]->[_ "Triangle#C#menu"] \
	    [_ "Quadrilateral#C#menu"]->[_ "Triangle#C#menu"] \
	    --- \
	    [_ "Tetrahedra#C#menu"]->[_ "Tetrahedra#C#menu"] \
	    [_ "Hexahedra#C#menu"]->[_ "Tetrahedra#C#menu"] \
	    [_ "Prism#C#menu"]->[_ "Tetrahedra#C#menu"] ]
    set MenuCommands(5,14,4) [list \
	    {Meshing EditMesh SplitElems TriaToTria} \
	    {Meshing EditMesh SplitElems QuadToTriangle} \
	    {} \
	    {Meshing EditMesh SplitElems TetraToTetra} \
	    {Meshing EditMesh SplitElems HexaToTetra} \
	    {Meshing EditMesh SplitElems PrismToTetra} \
	    ]
    set MenuEntries(5,14,7) [ list [_ "Mesh#C#menu"] --- [_ "Edges#C#menu"] [_ "Nodes#C#menu"] [_ "Elements#C#menu"] ]
    set MenuCommands(5,14,7) { {Utilities Collapse mesh} "" {Utilities Collapse edges} \
	{Utilities Collapse nodes} {Utilities Collapse elements} }

    set MenuEntries(5,14,8) [ list [_ "Nodes#C#menu"] [_ "Elements#C#menu"] ]
    set MenuCommands(5,14,8) { {Meshing EditMesh DeleteNodes} {Meshing EditMesh DeleteElems} }


    #---------------

    set MenuEntries(6) [list  [_ "Calculate#C#menu"] [_ "Calculate remote#C#menu"] ---\
	    [_ "Cancel process#C#menu"] [_ "View process info#C#menu"]... [_ "Calculate window#C#menu"]... ]
    set MenuCommands(6) {  {Utilities Calculate} {Utilities RemoteCalc} "" {Utilities CancelProcess} \
	"-np- PWViewOutput" "-np- RunWin " }

    set MenuAcceler(6) { "" "" "" "" "" ""}
    set MenuIcons(6) {"calc16x16.gif" "" "" "" "info16x16.gif" "" }

    #----------------


    set MenuEntries(7) [list [_ "Help#C#menu"]... [_ "Customization Help#C#menu"]... [_ "Tutorials#C#menu"]... \
	    [_ "What is new#C#menu"]... [_ "FAQ#C#menu"]... --- [_ "Register %s#C#menu" $::GidPriv(ProgName)]... [_ "Register Problem type#C#menu"]... \
	    [_ "Register from file#C#menu"]...  --- [_ "Visit %s web" $::GidPriv(ProgName)]... [_ "About#C#menu"]... ]
    set MenuCommands(7) [list {-np- GiDHelpWindow -type REFERENCE -start html-version} \
	    {-np- GiDHelpWindow  -type REFERENCE -start html-customization} \
	    { -np- GiDHelpWindow -type REFERENCE -start html-tutorials} { -np- GiDHelpWindow -type REFERENCE -start html_whatsnew} \
	    {-np- GiDHelpWindow -type REFERENCE -start html-faq} "" {-np- gidregister} \
	    {-np- gidregister module} {-np- RegisterFromFileW} "" "-np- VisitWeb $GidPriv(ProgWeb)" \
	    {-np- CreateWelcomeWin}]
    set MenuAcceler(7) { F1 "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIcons(7) {"help16x16.gif" "" "" "" "" "" "" "" "" "" "" ""}

}
#-----------------------------------------------------------

proc SetBitmapNames {} {
    global BitMapsNames BitMapsCommands BitmapsHelp GidPriv

    unset -nocomplain BitMapsNames BitMapsCommands BitmapsHelp


    set BitMapsNames(0) { zoomin.gif zoomout.gif zframe.gif redraw.gif \
		              rotate.gif pan.gif --- line.gif arc.gif spline.gif \
		              poly.gif --- surface.gif volume.gif object.gif --- erase.gif \
		              list.gif --- view_geom_mesh.gif }

    set BitMapsCommands(0) { {-ne- Zoom In} {-ne- Zoom Out} {-ne- Zoom Frame} \
		                 {-ne- redraw} {-ne- Rotate trackball} {-ne- dynamicpan } "" \
		                 {Geometry Create Line} \
		                 {Geometry Create Arc} {Geometry Create NurbsLine} \
		                 {Geometry Create PolyLine} "" \
		                 {Geometry Create NurbsSurface} {Geometry Create volume} "" "" \
		                 {-np- AddBitmapsDeleteMenu %W } \
		                 {-np- AddBitmapsToMenu %W {GiD_Process Mescape Utilities List } } \
		                 "" {-np- ToggleGeomMesh} }

    set BitMapsNames(0,14) { rectangle.gif polygonPNR.gif CirclePNR.gif \
		                 sphere.gif cylinder.gif cone.gif Prism.gif tori.gif }

    set BitMapsCommands(0,14) { {Geometry Create Object Rectangle } \
		                    {Geometry Create Object PolygonPNR } \
		                    {Geometry Create Object CirclePNR } {Geometry Create Object Sphere } \
		                    {Geometry Create Object Cylinder } {Geometry Create Object Cone } \
		                    {Geometry Create Object Prism } {Geometry Create Object Torus }}

    set BitMapsNames(0,16) {}
    set BitMapsCommands(0,16) {}

    set BitMapsNames(0,17) {}
    set BitMapsCommands(0,17) {}

    set BitmapsHelp(0) [list [_ "Zoom in"] [_ "Zoom out"] [_ "Zoom frame"] [_ "Redraw"] \
		            [_ "Rotate trackball"] [_ "Pan dynamic"] "" [_ "Create line"] [_ "Create arc"] \
		            [_ "Create nurbs line"] [_ "Create polyline"] "" \
		            [_ "Create NURBS surface"] [_ "Create volume"] \
		            [_ "Create Object:\n  Rectangle\n Polygon\n  Circle\n  Sphere\n  Cylinder\n  Cone\n  Prism\n Thorus"]\
		            "" [_ "Delete"] [_ "List entities"] "" [_ "Toggle geometry-mesh view"]]


}


#-----------------------------------------------------------

proc Set3dButtonVariables { { what "PRE"}} {
    global 3dButtonNames 3dButtonDisabled 3dButtonDisabledP 3dButtonCommands 3dButtonChange 3dButtonChangeP
    global tcl_platform
    global 3dButtonIcons

    unset -nocomplain 3dButtonNames 3dButtonDisabled 3dButtonDisabledP 3dButtonCommands 3dButtonIcons

    set lay_txt [_ "Layer#C#menu"]
    if { "$what" == "POST"} {
	set lay_txt [_ "Mesh#C#menu"]
    }

    if { $tcl_platform(platform) != "windows" } {
	set 3dButtonNames(0) [list [_ "Contextual#C#menu"] --- [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] \
		                  [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Label#C#menu"] $lay_txt \
		                  [_ "Switch full screen"] --- [_ "Quit#C#menu"]]
    } else {
	set 3dButtonNames(0) [list [_ "Contextual#C#menu"] --- [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] \
		                  [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Label#C#menu"] $lay_txt \
		                  [_ "Switch full screen"] --- [_ "Image to clipboard#C#menu"] \
		                  --- [_ "Quit#C#menu"]]
    }


    set 3dButtonDisabled ""
    # set 3dButtonDisabledP [list [_ "Layer#C#menu"]]
    set 3dButtonDisabledP ""
    
    if { $tcl_platform(platform) != "windows" } {
	set 3dButtonCommands(0) { {-np- ContextualSubMenu %W} "" "" "" "" {-ne- redraw } \
		                      {-np- AddChangeToRender %W} "" "" {-np- SwitchFullScreen} "" \
				      { -np- QuitFullScreen} }
	set 3dButtonIcons(0) { "" "" "" "" "" "redraw16x16.gif" "" "" \
		                   "" "FullScreen16.gif" "" "exit16x16.gif" }
    } else {
	set 3dButtonCommands(0) { {-np- ContextualSubMenu %W} "" "" "" "" {-ne- redraw } \
		                      {-np- AddChangeToRender %W} "" "" {-np- SwitchFullScreen} "" \
				      {-ne- hardcopy copyclipboard} "" { -np- QuitFullScreen} }
	set 3dButtonIcons(0) { "" "" "" "" "" "redraw16x16.gif" "" "" \
		                   "" "FullScreen16.gif" "" "" "" "exit16x16.gif" }
    }

    set 3dButtonNames(0,0) {}
    set 3dButtonCommands(0,0) {}

    set 3dButtonNames(0,2) [list [_ "In#C#menu"] [_ "Out#C#menu"] --- [_ "Dynamic#C#menu"] [_ "Previous#C#menu"] [_ "Next#C#menu"] \
	    --- [_ "Frame#C#menu"]]
    set 3dButtonCommands(0,2) { {-ne- Zoom In} {-ne- Zoom Out} "" {-ne- Zoom Dynamic} \
	    {-ne- Zoom Previous} {-ne- Zoom Next} "" {-ne- Zoom Frame} }
    set 3dButtonIcons(0,2) { "zoomin16x16.gif" "zoomout16x16.gif" "" "" "" "" "" "zframe16x16.gif" }

    set 3dButtonNames(0,3) [list [_ "Trackball#C#menu"] [_ "Screen axes#C#menu"] [_ "Object axes#C#menu"] \
	    [_ "Center#C#menu"] --- [_ "Plane XY (Original)#C#menu"] [_ "Plane XZ#C#menu"] [_ "Plane YZ#C#menu"] [_ "Isometric#C#menu"]]
    set 3dButtonCommands(0,3) { {-ne- Rotate Trackball} {-ne- Rotate ScrAxes} \
	    {-ne- Rotate ObjAxes}  {-ne- Rotate Center FJoin} \
	    "" {-ne- Rotate Angle 270 90} {-ne- Rotate Angle 270 0} \
	    {-ne- Rotate Angle 0 0} {-ne- Rotate Angle 45 45} }
    set 3dButtonIcons(0,3) { "rotate16x16.gif" "" "" "" "" "" "" "" "" }

    set 3dButtonNames(0,4) [list [_ "Two point#C#menu"] [_ "Dynamic#C#menu"]]
    set 3dButtonCommands(0,4) { {-ne- pan} {-ne- DynamicPan} }
    set 3dButtonIcons(0,4) { "" "pan16x16.gif" }

    set 3dButtonNames(0,6) {}
    set 3dButtonCommands(0,6) {}

    set 3dButtonNames(0,7) [list [_ "All#C#menu"] [_ "All in#C#menu"] [_ "Select#C#menu"] --- [_ "Off#C#menu"]]
    set 3dButtonCommands(0,7) { {-ne- label All} \
	    {-np- AddBitmapsToMenu %W {GiD_Process Label  } } \
	    {-np- AddBitmapsToMenu %W {GiD_Process Label Select } } "" \
	    {-ne- label Off} }
    set 3dButtonNames(0,7,1) {}
    set 3dButtonCommands(0,7,1) {}
    set 3dButtonNames(0,7,2) {}
    set 3dButtonCommands(0,7,2) {}

    if { "$what" == "PRE"} {
	set 3dButtonNames(0,8) [list [_ "New#C#menu"] [_ "On#C#menu"] [_ "Off#C#menu"] [_ "To use#C#menu"] [_ "Send#C#menu"] [_ "Window#C#menu"]]
	set 3dButtonCommands(0,8) { { -np- CreateNewLayer } \
		                        {-np- AddLayerOnOff ON %W {GiD_Process Layers On }} \
		                        {-np- AddLayerOnOff OFF %W {GiD_Process Layers Off }} \
		                        {-np- AddLayerOnOff TOUSE %W {GiD_Process Layers ToUse }} \
		                        {-np- LayerEntities %W} { -np- ChangeLayers } }
	set 3dButtonIcons(0,8) { "" "" "" "" "" "layers16x16.gif" }
	
	set 3dButtonNames(0,8,1) {}
	set 3dButtonNames(0,8,2) {}
	set 3dButtonNames(0,8,3) {}
	set 3dButtonNames(0,8,4) {}
	
	set 3dButtonCommands(0,8,1) {}
	set 3dButtonCommands(0,8,2) {}
	set 3dButtonCommands(0,8,3) {}
	set 3dButtonCommands(0,8,4) {}
    } else {
	# "$what" == POST
	set 3dButtonNames(0,8) [list "" "" "" [_ "Send#C#menu"] [_ "Window#C#menu"]]
	set 3dButtonCommands(0,8) { \
		                        {-np- AddBitmapsToMeshSetCut %W { GiD_Process Mescape Select} volumesets} \
		                        {-np- AddBitmapsToMeshSetCut %W { GiD_Process Mescape Select} surfacesets} \
		                        {-np- AddBitmapsToMeshSetCut %W { GiD_Process Mescape Select} cutsets} \
		                        { Select Elements} { -np- PostDisplay } }
	set 3dButtonIcons(0,8) { "meshes.gif" "sets.gif" "cuts.gif" "" "layers16x16.gif" }
	
	set 3dButtonNames(0,8,0) ""
	set 3dButtonNames(0,8,1) ""
	set 3dButtonNames(0,8,2) ""
	
	set 3dButtonCommands(0,8,0) ""
	set 3dButtonCommands(0,8,1) ""
	set 3dButtonCommands(0,8,2) ""
    }
}

#------------------------------------------------------------------------

proc SetMenusVariablesP {} {
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP MenuIconsP
    global tcl_platform GidPriv GIDDEFAULT

    unset -nocomplain MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP MenuIconsP

    if {[tk windowingsystem] eq "aqua"} {
	set M Command
    } else {
	set M Control
    }


    set MenuNamesP [list [_ "Files#C#menu"] [_ "View#C#menu,verb"] [_ "Utilities#C#menu"] [_ "Do cuts#C#menu"] \
		        [_ "View results#C#menu"] [_ "Options#C#menu"] [_ "Window#C#menu"] [_ "Help#C#menu"]]

    #-----------------

    set MenuEntriesP(0) [list [_ "New#C#menu"] [_ "Open#C#menu"]... [_ "Open multiple#C#menu"]... [_ "Merge#C#menu"]... \
		             [_ "Recent post files#C#menu"] --- \
		             [_ "Import#C#menu"] [_ "Export#C#menu"] --- [_ "Preprocess#C#menu"] [_ "Recent projects#C#menu"] --- \
		             [_ "Print to file#C#menu"] [_ "Page and capture settings#C#menu"]... [_ "Print#C#menu"] --- \
		             [_ "Quit#C#menu"] ]
    set MenuCommandsP(0) { { files new} { files read} { files ReadMultiple} { files add} {-np- AddEntitiesToMenuRecentPostFiles %W} \
		               "" "" "" \
		               "" {preprocess} {-np- AddEntitiesToMenuRecentProjects %W} "" \
		               "" {-np- PageSetup} {-np- HardcopyToPrint {Hardcopy PS}} "" \
			       { -np- QuitFullScreen} }

    set MenuAccelerP(0) [list $M-n $M-o "" "" "" "" "" "" "" "" "" "" "" "" "" "" $M-q]
    set MenuIconsP(0) { "new16x16.gif" "open16x16.gif" "" "" "" "" "" "" "" "prepost16x16.gif" "" "" \
		            "camera16x16.gif" "" "print16x16.gif" "" "exit16x16.gif" }
    
    set MenuEntriesP(0,4) ""
    set MenuEntriesP(0,6) [ list [_ "NASTRAN mesh#C#menu"]... [_ "FEMAP file#C#menu"]... \
		                [_ "TECPLOT ASCII file#C#menu"]... [ _ "3D Studio file#C#menu"]... \
		                [_ "XYZ ascii points#C#menu"]... --- \
		                [_ "Cut#C#menu"]...  [_ "Graph#C#menu"]... --- \
				[_ "Plugins#C#menu"]]

    set MenuCommandsP(0,6) { { files readNASTRAN} { files readFEMAP} \
		                 { files readTECPLOT} { files read3DStudio} \
		                 { files readXYZascii} "" \
		                 { files readcut} { results graphs readgraph} "" \
				 { -np- AddPostImportPluginsToMenuLazy %W} }

    set MenuEntriesP(0,6,9) ""

    set MenuEntriesP(0,7) [list [_ "Post information#C#menu"] [_ "Cut#C#menu"] [_ "Graph#C#menu"] \
		               [_ "Cover mesh#C#menu"]... [_ "Visible surfaces to STL"]... ]

    set MenuCommandsP(0,7) { "" \
		                 {-np- AddCutsToMenu %W { GiD_Process Mescape Files SaveCut}} \
		                 {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs WriteGraph} 1} \
		                 { Files savecovermesh} { Files SaveSTLSurfaces} \
		             }

    set MenuEntriesP(0,7,0) [list [_ "ASCII files#C#menu"]... [_ "Binary (whole model)#C#menu"]... [_ "Binary (only results)#C#menu"] \
		                 [_ "ASCII boundaries#C#menu"]...]

    set MenuCommandsP(0,7,0) { { files saveall allmeshessets} \
		                   { files saveall binMeshesSets} { files saveall binRes} \
		                   { files saveall boundaries} }

    set MenuEntriesP(0,7,1) ""

    set MenuEntriesP(0,7,2) ""

    set MenuEntriesP(0,10) ""

    set MenuEntriesP(0,12) [list [_ "PS/EPS Screen#C#menu"]... [_ "PS/EPS Vectorial#C#menu"]... --- \
		                [_ "BMP#C#menu"]... [_ "GIF#C#menu"]... [_ "JPEG#C#menu"]... [_ "PNG#C#menu"]... \
		                [_ "TGA#C#menu"]... [_ "TIFF#C#menu"]... [_ "VRML#C#menu"]...]

    set MenuCommandsP(0,12) { "" "" "" \
		                  { -ne- Hardcopy BMP} \
		                  { -ne- Hardcopy GIF} \
		                  { -ne- Hardcopy JPEG} \
		                  { -ne- Hardcopy PNG} \
		                  { -ne- Hardcopy TGA} \
		                  { -ne- Hardcopy TIFF} \
		                  { -ne- Hardcopy VRML} }

    set MenuEntriesP(0,12,0) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommandsP(0,12,0) { { -ne- Hardcopy Options VectorialPS no escape Hardcopy PS} \
		                    { -ne- Hardcopy Options VectorialPS no escape Hardcopy EPS} }

    set MenuEntriesP(0,12,1) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommandsP(0,12,1) { { -ne- Hardcopy Options VectorialPS yes escape Hardcopy PS } \
		                    { -ne- Hardcopy Options VectorialPS yes escape Hardcopy EPS} }
       

    #-----------------

    #copyclipboard only available for windows
    set what "POST"
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntriesP(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		                 [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... \
		                 [_ "Clip planes#C#menu"]... [_ "Advanced options#C#menu"]... \
		                 --- [_ "Label#C#menu"] [_ "View#C#menu,noun"] \
		                 [_ "Recent view files#C#menu"] --- [_ "Background image#C#menu"] \
		                 [_ "Image to clipboard#C#menu"] [_ "Multiple windows#C#menu"]... --- \
		                 [_ "Mode#C#menu"] [_ "Full screen"]]
	set MenuCommandsP(1) [list "" "" "" "" \
		                  {-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} \
		                  {-np- ClipPlanes} {-np- StereoW} "" \
		                  "" "" {-np- AddEntitiesToMenuRecentViewFiles %W} "" \
		                  {-np- AddEntitiesToMenuBackgroundImage %W} {-ne- hardcopy copyclipboard} \
		                  {-np- ViewSeveralWindows}  "" [list -np- ViewModeMenu %W $what] {-np- SwitchFullScreen}]
	set MenuAccelerP(1) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "F5"}
	set MenuIconsP(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" ""\
		                "" "" "" "" "" "" "" "FullScreen16.gif"}
    } else {
	set MenuEntriesP(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		                 [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... \
		                 [_ "Clip planes#C#menu"]... [_ "Advanced options#C#menu"]... \
		                 --- [_ "Label#C#menu"] [_ "View#C#menu,noun"] \
		                 [_ "Recent view files#C#menu"] --- [_ "Background image#C#menu"] \
		                 [_ "Multiple windows#C#menu"]... --- [_ "Mode#C#menu"] [_ "Full screen"]]
	set MenuCommandsP(1) [list "" "" "" "" \
		                  {-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} \
		                  {-np- ClipPlanes} {-np- StereoW} "" \
		                  "" "" {-np- AddEntitiesToMenuRecentViewFiles %W} "" \
		                  {-np- AddEntitiesToMenuBackgroundImage %W} {-np- ViewSeveralWindows} "" \
				  [list -np- ViewModeMenu %W $what] {-np- SwitchFullScreen}]
	set MenuAccelerP(1) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "F5"}
	set MenuIconsP(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "FullScreen16.gif"}
    }

    set MenuEntriesP(1,0) [list [_ "In#C#menu"] [_ "Out#C#menu"] --- [_ "Dynamic#C#menu"] [_ "Previous#C#menu"] \
		               [_ "Next#C#menu"] --- [_ "Frame#C#menu"]]
    set MenuCommandsP(1,0) { {-ne- Zoom In} {-ne- Zoom Out} "" \
		                 {-ne- Zoom Dynamic} \
		                 {-ne- Zoom Previous} {-ne- Zoom Next} "" {-ne- Zoom Frame} }
    set MenuIconsP(1,0) { "zoomin16x16.gif" "zoomout16x16.gif" "" "" "" "" "" "zframe16x16.gif" }

    set MenuEntriesP(1,1) [list [_ "Trackball#C#menu"] [_ "Screen axes#C#menu"] [_ "Object axes#C#menu"] \
		               [_ "Center#C#menu"] --- [_ "Plane XY (Original)#C#menu"] [_ "Plane XZ#C#menu"] \
		               [_ "Plane YZ#C#menu"] [_ "Isometric#C#menu"]]
    set MenuCommandsP(1,1) { {-ne- Rotate Trackball} {-ne- Rotate ScrAxes} \
		                 {-ne- Rotate ObjAxes}  {-ne- Rotate Center FJoin} \
		                 "" {-ne- Rotate Angle 270 90} {-ne- Rotate Angle 270 0} \
		                 {-ne- Rotate Angle 0 0} {-ne- Rotate Angle 45 45} }
    set MenuIconsP(1,1) { "rotate16x16.gif" "" "" "" "" "" "" "" "" }

    set MenuEntriesP(1,2) [list [_ "Two point#C#menu"] [_ "Dynamic#C#menu"]]
    set MenuCommandsP(1,2) { {-ne- pan} {-ne- DynamicPan} }
    set MenuIconsP(1,2) { "" "pan16x16.gif" }

    set MenuEntriesP(1,5) ""
    set MenuCommandsP(1,5) ""

    set MenuEntriesP(1,10) [list [_ "All#C#menu"] [_ "All in#C#menu"] [_ "Select#C#menu"] --- [_ "Off#C#menu"]]
    set MenuCommandsP(1,10) { {-ne- label All} \
		                  {-np- AddBitmapsToMenu %W {GiD_Process Label  } } \
		                  {-np- AddBitmapsToMenu %W {GiD_Process Label Select } } "" \
		                  {-ne- label Off} }
    set MenuEntriesP(1,10,1) {}
    set MenuCommandsP(1,10,1) {}

    set MenuEntriesP(1,10,2) {}
    set MenuCommandsP(1,10,2) {}

    set MenuEntriesP(1,11) [list [_ "Read#C#menu"]... [_ "Save#C#menu"]...]
    set MenuCommandsP(1,11) { {View ReadView} {View SaveView} }

    set MenuEntriesP(1,12) {}
    set MenuCommandsP(1,12) {}

    set MenuEntriesP(1,14) [list [_ "Fit screen#C#menu"]... [_ "Real size#C#menu"]... [_ "Default#C#menu"] ]
    set MenuCommandsP(1,14) { { Utilities BackgroundImg BackgroundImg} \
		                  { Utilities BackgroundImg RealSizeImg} { Utilities BackgroundImg Default} }
    # view mode
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntriesP(1,18) ""
	set MenuCommandsP(1,18) ""
    } else {
	set MenuEntriesP(1,17) ""
	set MenuCommandsP(1,17) ""
    }

    #-----------------

    if { $GidPriv(Texturas)} {
	set MenuEntriesP(2) [list  [_ "Preferences#C#menu"]... [_ "View style#C#menu"]... --- \
		                 [_ "Tools#C#menu"] --- [_ "Copy#C#menu"] [_ "Status#C#menu"]... [_ "List#C#menu"] \
		                 [_ "Id#C#menu"] [_ "Signal#C#menu"] [_ "Distance#C#menu"] [_ "Dimension#C#menu"] --- \
		                 [_ "Collapse nodes#C#menu"] [_ "Join#C#menu"] [_ "Delete#C#menu"] [_ "Texture#C#menu"] ]
	set MenuCommandsP(2) { {-np- ChangeVariables} { -np- PostDisplay } "" "" "" {-np- CopyMove "Copy" } \
		                   {Utilities List status } "" {Utilities Id}  \
		                   {-np- AddEntitiesToMenu %W {GiD_Process Mescape Utilities SignalEntities }} \
		                   {Utilities dist} "" "" {Utilities collapse} "" "" "" }
	set MenuAccelerP(2) [list $M-p $M-l "" "" "" $M-c "" "" "" "" "" "" "" "" "" "" "" "" ""]
	set MenuIconsP(2) { "prefs16x16.gif" "layers16x16.gif" "" "" "" "copy16x16.gif" "" \
		                "list16x16.gif" "" "" "" "" "" "" "" "" "" "" "" }
    } else {
	set MenuEntriesP(2) [list  [_ "Preferences#C#menu"]... [_ "View style#C#menu"]... --- \
		                 [_ "Tools#C#menu"] --- [_ "Copy#C#menu"] [_ "Status#C#menu"]... [_ "List#C#menu"] \
		                 [_ "Id#C#menu"] [_ "Signal#C#menu"] [_ "Distance#C#menu"] [_ "Dimension#C#menu"] --- \
		                 [_ "Collapse nodes#C#menu"] [_ "Join#C#menu"] [_ "Delete#C#menu"] ]
	set MenuCommandsP(2) { {-np- ChangeVariables} { -np- PostDisplay } "" "" "" {-np- CopyMove "Copy" } \
		                   {Utilities List status } "" {Utilities Id} \
		                   {-np- AddEntitiesToMenu %W {GiD_Process Mescape Utilities SignalEntities }} \
		                   {Utilities dist} "" "" {Utilities collapse} "" "" }
	set MenuAccelerP(2) [list $M-p $M-l "" "" "" $M-c "" "" "" "" "" "" "" "" "" "" "" ""]
	set MenuIconsP(2) { "prefs16x16.gif" "layers16x16.gif" "" "" "" "copy16x16.gif" "" \
		                "list16x16.gif" "" "" "" "" "" "" "" "" "" "" }
    }

    set MenuEntriesP(2,3) [list [_ "Toolbars#C#menu"]... ---  \
		               [_ "Save window conf#C#menu"]...  [_ "Move Screen Objects#C#menu"] --- \
		               [_ "Read batch window#C#menu"]... \
		               [_ "Perspective#C#menu"]... [_ "Advanced options#C#menu"]... [_ "Comments#C#menu"]... \
		               [_ "Animation controls#C#menu"]... [_ "Animation script#C#menu"]... \
		               [_ "Macros#C#menu"]... --- [_ "Calculator#C#menu"]... [_ "Report#C#menu"]... \
		               [_ "Notes#C#menu"]...]
    set MenuCommandsP(2,3) { {-np- TOBegin} \
		                 "" {-np- SaveWinConfiguration} { -ne- MoveScrObj} "" \
		                 {-np- ReadBatch} {-np- PerspectiveW} {-np- StereoW} {-np- CommentsW} \
		                 {-np- PostAnimateControls} {-np- ::AutoAnimate::Crear} {-np- toolbarmacros::MacrosWindow} \
		                 "" {-np- CalculatorV} { -np- GIDReport::Crear} { -np- OpenNotes}}
    set MenuAccelerP(2,3) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIconsP(2,3) {"" ""  "" "" "" "" "" "" "" "" "" "" "" "" "Report16x16.gif" ""}

    set MenuEntriesP(2,7)  [list [_ "Nodes#C#menu"] [_ "Elements#C#menu"]]
    set MenuCommandsP(2,7) { { Utilities List Nodes} { Utilities List Elements} }

    set MenuEntriesP(2,9) ""
    set MenuCommandsP(2,9) ""

    #set MenuEntriesP(2,4) [list [_ "Nodes in Sets#C#menu"] ]
    #set MenuCommandsP(2,4) { { Utilities collapse nodesinsets} }

    set MenuEntriesP(2,11) [list [_ "Create#C#menu"] [_ "Delete#C#menu"] [_ "Edit#C#menu"] [_ "ShowBox#C#menu"] ]
    set MenuCommandsP(2,11) { "" {Utilities Dimension Delete} \
		                  {Utilities Dimension Edit} "" }

    set MenuEntriesP(2,11,0) [list [_ "Vertex#C#menu"] [_ "Distance#C#menu"] [_ "Angle#C#menu"] [_ "Radius#C#menu"] [_ "Text#C#menu"] ]
    set MenuCommandsP(2,11,0) { {Utilities Dimension Create Vertex} {Utilities Dimension Create Distance} \
		                    {Utilities Dimension Create Angle} {Utilities Dimension Create Radius} \
		                    {Utilities Dimension Create Text} }

    set MenuEntriesP(2,11,3) [list [_ "On#C#menu"] [_ "Off#C#menu"] ]
    set MenuCommandsP(2,11,3) { {Utilities Dimension ShowBox} {Utilities Dimension HideBox} }

    set MenuEntriesP(2,14) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] ]
    set MenuCommandsP(2,14) { { Utilities join meshes} { Utilities join sets} }

    set MenuEntriesP(2,15) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] [_ "Cut sets#C#menu"] ]
    set MenuCommandsP(2,15) { {-np- AddMeshSetCutMenu %W { GiD_Process Mescape Utilities Delete } volumes} \
		                  {-np- AddMeshSetCutMenu %W { GiD_Process Mescape Utilities Delete } surfaces} \
		                  {-np- AddMeshSetCutMenu %W { GiD_Process Mescape Utilities Delete } cuts} \
		              }

    set MenuEntriesP(2,15,0) ""
    set MenuEntriesP(2,15,1) ""
    set MenuEntriesP(2,15,2) ""

    if { $GidPriv(Texturas)} {
	set MenuEntriesP(2,16) [list [_ "View#C#menu"] [_ "Add#C#menu"] [_ "Change#C#menu"] ]
	set MenuCommandsP(2,16) { "" "" ""}
	
	set MenuEntriesP(2,16,0) [list [_ "No#C#menu,nothing, None#C#menu"] [_ "Fast#C#menu"] [_ "Nice#C#menu"] ]
	set MenuCommandsP(2,16,0) { { Utilities texture lit} { Utilities texture fast} { Utilities texture nice}}
	
	set MenuEntriesP(2,16,1) [list [_ "Screen map#C#menu"]... [_ "To 4 sided set#C#menu"]... [_ "BoundImg to BoundSet#C#menu"]... ]
	set MenuCommandsP(2,16,1) { { Utilities texture addtexture} { Utilities texture addto4sided} { Utilities texture addbtob}}
	
	set MenuEntriesP(2,16,2) [list [_ "Flip horiz.#C#menu"] [_ "Flip vert.#C#menu"] ]
	set MenuCommandsP(2,16,2) { { Utilities texture flips} { Utilities texture flipt}}
    }

    #-----------------

    set MenuEntriesP(3) [list [_ "Cut Plane#C#menu"] [_ "Divide by selection#C#menu"] \
		             [_ "Divide volume sets#C#menu"] [_ "Divide surface sets#C#menu"] \
		             [_ "Divide lines#C#menu"] [_ "Cut Wire#C#menu"] [_ "Cut Sphere#C#menu"] \
		             [_ "Convert cuts to surface sets#C#menu"] \
		             [_ "Automatically convert cut to set"] ]
    set MenuCommandsP(3) {  ""  { Select Elements} "" "" "" { DoCut CutWire} \
		                { DoCut CutShape Sphere} { DoCut TurnIntoMeshes} \
		                {-np- AutomaticConvertCutToMesh %W 8} }
    set MenuAccelerP(3) {"" "" "" "" "" "" "" "" ""}
    set MenuIconsP(3) {"docut16x16.gif" "" "" "" "" "" "" "" {-np- IconoAutomaticConvertCutToMesh}}

    set MenuEntriesP(3,0) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] [_ "Succesion#C#menu"]]
    set MenuCommandsP(3,0) { { DoCut CutPlane} { DoCut CutPlane ThreePoints} { DoCut Succesion}}
    set MenuIconsP(3,0) {"cut2p16x16.gif" "cut3p16x16.gif" "cut_succesion16x16.gif"}

    set MenuEntriesP(3,2) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] ]
    set MenuCommandsP(3,2) { { DoCut DivideMesh} { DoCut DivideMesh ThreePoints} }

    set MenuEntriesP(3,3) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] ]
    set MenuCommandsP(3,3) { { DoCut DivideSets} { DoCut DivideSets ThreePoints} }

    set MenuEntriesP(3,4) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] ]
    set MenuCommandsP(3,4) { { DoCut DivideLines} { DoCut DivideLines ThreePoints} }

    #----------------

    set MenuEntriesP(4) [list [_ "No Results#C#menu"] [_ "No Graphs#C#menu"] --- [_ "Default Analysis/Step#C#menu"] --- \
		             [_ "Contour Fill#C#menu"] [_ "Smooth Contour Fill#C#menu"] \
		             [_ "Contour Lines#C#menu"] [_ "Contour Ranges#C#menu"] [_ "Show Min Max#C#menu"] \
		             [_ "Display Vectors#C#menu"] [_ "Iso Surfaces#C#menu"] [_ "Stream Lines#C#menu"] \
		             [_ "Graphs#C#menu"] [_ "Result Surface#C#menu"] \
		             [_ "Deformation#C#menu"] [_ "Line Diagram#C#menu"] [_ "Integrate"]]
    set MenuCommandsP(4) { { Results Geometry NoResults \
		                 Geometry Original \
		                 Geometry HideTheShow \
		                 escape escape escape escape \
		                 View Label Off} \
		               { Results Graphs OptionsGraph ShowGraphs No} \
		               ""  {-npm- AddAnalysisStepsToMenu %W} "" \
		               {-npm- AddResultsToMenu %W \
		                    {GiD_Process Mescape Results ContourFill } "Contour_Fill"} \
		               {-npm- AddResultsToMenu %W \
		                    {GiD_Process Mescape Results SmoothContourFill } "Smooth_Contour_Fill"} \
		               {-npm- AddResultsToMenu %W \
		                    {GiD_Process Mescape Results ContourLines } "Contour_Lines"} \
		               {-npm- AddResultsToMenu %W \
		                    {GiD_Process Mescape Results ContourRanges } "Contour_Ranges"} \
		               ""
		               {-npm- AddResultsToMenu %W \
		                    {GiD_Process Mescape Results DisplayVectors } "Display_Vectors"} \
		               "" \
		               "" \
		               "" \
		               {-npm- AddResultsToMenu %W \
		                    {GiD_Process Mescape Results ResultSurface } "Result_Surface"} \
		               {-npm- AddResultsToMenu %W \
		                    {GiD_Process Mescape Results Geometry Deformation } \
		                    "Deformation"} \
		               "" "" }

    set MenuAccelerP(4) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIconsP(4) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}

    set MenuEntriesP(4,3) { "" }
    set MenuCommandsP(4,3) { "" }

    set MenuEntriesP(4,5) { "" }
    set MenuCommandsP(4,5) { "" }

    set MenuEntriesP(4,6) { "" }
    set MenuCommandsP(4,6) { "" }

    set MenuEntriesP(4,7) { "" }
    set MenuCommandsP(4,7) { "" }

    set MenuEntriesP(4,8) { "" }
    set MenuCommandsP(4,8) { "" }

    set MenuEntriesP(4,9) [ list [_ "Show minimum#C#menu"] [_ "Show maximum#C#menu"] [_ "Show both#C#menu"]]
    set MenuCommandsP(4,9) { \
				 {-npm- AddResultsToMenu %W \
				      {GiD_Process Mescape Results ShMin } "Sh_Min_Max"} \
				 {-npm- AddResultsToMenu %W \
				      {GiD_Process Mescape Results ShMax } "Sh_Min_Max"} \
				 {-npm- AddResultsToMenu %W \
				      {GiD_Process Mescape Results ShMinMax } "Sh_Min_Max"} \
			     }

    set MenuEntriesP(4,9,0) { "" }
    set MenuCommandsP(4,9,0) { "" }

    set MenuEntriesP(4,9,1) { "" }
    set MenuCommandsP(4,9,1) { "" }

    set MenuEntriesP(4,9,2) { "" }
    set MenuCommandsP(4,9,2) { "" }

    set MenuEntriesP(4,10) { "" }
    set MenuCommandsP(4,10) { "" }

    set MenuEntriesP(4,11) [ list [_ "Exact#C#menu"] [_ "Automatic#C#menu"] [_ "Automatic Width#C#menu"] ]
    set MenuCommandsP(4,11) { \
		                  {-npm- AddResultsToMenu %W \
		                       {GiD_Process Mescape Results IsoSurfaces Exact} "Iso_Surfaces" 1} \
		                  {-npm- AddResultsToMenu %W \
		                       {GiD_Process Mescape Results IsoSurfaces Automatic} "Iso_Surfaces" 2} \
		                  {-npm- AddResultsToMenu %W \
		                       {GiD_Process Mescape Results IsoSurfaces AutomaticWidth} "Iso_Surfaces" 3}}

    set MenuEntriesP(4,11,0) { "" }
    set MenuCommandsP(4,11,0) { "" }

    set MenuEntriesP(4,11,1) { "" }
    set MenuCommandsP(4,11,1) { "" }

    set MenuEntriesP(4,11,2) { "" }
    set MenuCommandsP(4,11,2) { "" }

    set MenuEntriesP(4,12) [ list [_ "Single point#C#menu"] [_ "Along line#C#menu"] [_ "In a quad#C#menu"] ]
    set MenuCommandsP(4,12) { \
				  {-npm- AddResultsToMenu %W \
				       {GiD_Process Mescape Results StreamLines } "Stream_Lines" 1} \
				  {-npm- AddResultsToMenu %W \
				       {GiD_Process Mescape Results StreamLines AlongLine } "Stream_Lines" 2} \
				  {-npm- AddResultsToMenu %W \
				       {GiD_Process Mescape Results StreamLines InAQuad } "Stream_Lines" 3} \
			      }

    set MenuEntriesP(4,12,0) { "" }
    set MenuCommandsP(4,12,0) { "" }

    set MenuEntriesP(4,12,1) { "" }
    set MenuCommandsP(4,12,1) { "" }

    set MenuEntriesP(4,12,2) { "" }
    set MenuCommandsP(4,12,2) { "" }

    set MenuEntriesP(4,13) [list [_ "Clear#C#menu"] [_ "Point evolution#C#menu"] [_ "Point graph#C#menu"] \
		                [_ "Border graph#C#menu"] [_ "Line graph#C#menu"] [_ "Integrate#C#menu"] \
				[_ "Point complex evolution#C#menu"] ]
    set MenuCommandsP(4,13) { \
		                  { Results Graphs OptionsGraph ClearGraphs} \
		                  {-npm- AddGraphsResultsToMenu %W \
		                       {GiD_Process Mescape Results Graphs PointEvolution} "Point_Evolution" } \
		                  {-npm- AddGraphsXYResultsToMenu %W \
		                       {GiD_Process Mescape Results Graphs PointGraph} "Point_Graph" } \
		                  {-npm- AddGraphsXYResultsToMenu %W \
		                       {GiD_Process Mescape Results Graphs BorderGraph} "Border_Graph" } \
		                  {-npm- AddGraphsResultsToMenu %W \
		                       {GiD_Process Mescape Results Graphs LineGraph} "Line_Graph" } \
		                  "" \
		                  {-npm- AddGraphsResultsToMenu %W \
		                       {GiD_Process Mescape Results Graphs PointComplexEvolution} "Point_Complex_Evolution" } \
		              }

    set MenuEntriesP(4,13,1) { ""}
    set MenuCommandsP(4,13,1) { ""}

    set MenuEntriesP(4,13,2) { ""}
    set MenuCommandsP(4,13,2) { ""}

    set MenuEntriesP(4,13,3) { ""}
    set MenuCommandsP(4,13,3) { ""}

    set MenuEntriesP(4,13,4) { ""}
    set MenuCommandsP(4,13,4) { ""}

    # set MenuEntriesP(4,13,5) { ""}
    # set MenuCommandsP(4,13,5) { ""}
    
    if { ![info exist ::GidPriv(PostSpaceDimension)] } {
	set ::GidPriv(PostSpaceDimension) "3D"
	#used for example if 2D do to integrals on lines in  the XY space 
	#e.g for triangle meshes with z but results XY only like IBER, to do
	#  -integral along cutting line 
	#  -streamlines in z=0 (else the streamline go outside the triangle/quads 3D domain)
    }
    
    if { $::GidPriv(PostSpaceDimension) == "3D"} {
	set MenuEntriesP(4,13,5) [ list [_ "Scalar result"] [_ "Vector result"] [_ "Vector result ( 2D lines)"]]
	set MenuCommandsP(4,13,5) { \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "3D" \
		                                  AllSteps ScalarResult} Integrate_Scalar } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "3D" \
		                                  AllSteps VectorResult} Integrate_Vector } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  AllSteps VectorResult} Integrate_Vector } \
		                    }
	set MenuEntriesP(4,13,5,0) { ""}
	set MenuCommandsP(4,13,5,0) { ""}
	set MenuEntriesP(4,13,5,1) { ""}
	set MenuCommandsP(4,13,5,1) { ""}
	set MenuEntriesP(4,13,5,2) { ""}
	set MenuCommandsP(4,13,5,2) { ""}
    } else { # 2D
	set MenuEntriesP(4,13,5) [ list [_ "Scalar result"] [_ "Vector result"]]
	set MenuCommandsP(4,13,5) { \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  AllSteps ScalarResult} Integrate_Scalar } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  AllSteps VectorResult} Integrate_Vector } \
		                    }
	set MenuEntriesP(4,13,5,0) { ""}
	set MenuCommandsP(4,13,5,0) { ""}
	set MenuEntriesP(4,13,5,1) { ""}
	set MenuCommandsP(4,13,5,1) { ""}
    }

    set MenuEntriesP(4,13,6) { ""}
    set MenuCommandsP(4,13,6) { ""}
    
    set MenuEntriesP(4,14) { "" }
    set MenuCommandsP(4,14) { "" }
    
    set MenuEntriesP(4,15) { "" }
    set MenuCommandsP(4,15) { "" }
    
    set MenuEntriesP(4,16) [list [_ "Scalar#C#menu"] [_ "Vector#C#menu"] ]
    set MenuCommandsP(4,16) { \
		                  {-npm- AddResultsToMenu %W \
		                       {GiD_Process Mescape Results LineDiagram ScalarDiagram } "Scalar_Line_Diagram"} \
		                  {-npm- AddResultsToMenu %W \
		                       {GiD_Process Mescape Results LineDiagram VectorDiagram } "Vector_Line_Diagram"} \
		              }
    
    set MenuEntriesP(4,16,0) { ""}
    set MenuCommandsP(4,16,0) { ""}
    
    set MenuEntriesP(4,16,1) { ""}
    set MenuCommandsP(4,16,1) { ""}

    set MenuEntriesP(4,17) [ list [_ "This step#C#menu"] [_ "All steps#C#menu"]]
    set MenuCommandsP(4,17) { "" ""}

    if { $::GidPriv(PostSpaceDimension) == "3D"} {
	set MenuEntriesP(4,17,0) [ list [_ "Scalar result"] [_ "Vector result"] [_ "Vector result ( 2D lines)"]]
	set MenuCommandsP(4,17,0) { \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "3D" \
		                                  ThisStep ScalarResult} Integrate_Scalar } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "3D" \
		                                  ThisStep VectorResult} Integrate_Vector } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  ThisStep VectorResult} Integrate_Vector } \
		                    }
	set MenuEntriesP(4,17,0,0) { ""}
	set MenuCommandsP(4,17,0,0) { ""}
	set MenuEntriesP(4,17,0,1) { ""}
	set MenuCommandsP(4,17,0,1) { ""}
	set MenuEntriesP(4,17,0,2) { ""}
	set MenuCommandsP(4,17,0,2) { ""}

	set MenuEntriesP(4,17,1) [ list [_ "Scalar result"] [_ "Vector result"] [_ "Vector result ( 2D lines)"]]
	set MenuCommandsP(4,17,1) { \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "3D" \
		                                  AllSteps ScalarResult} Integrate_Scalar } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "3D" \
		                                  AllSteps VectorResult} Integrate_Vector } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  AllSteps VectorResult} Integrate_Vector } \
		                    }
	set MenuEntriesP(4,17,1,0) { ""}
	set MenuCommandsP(4,17,1,0) { ""}
	set MenuEntriesP(4,17,1,1) { ""}
	set MenuCommandsP(4,17,1,1) { ""}
	set MenuEntriesP(4,17,1,2) { ""}
	set MenuCommandsP(4,17,1,2) { ""}

    } else { # 2D

	set MenuEntriesP(4,17,0) [ list [_ "Scalar result"] [_ "Vector result"]]
	set MenuCommandsP(4,17,0) { \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  ThisStep ScalarResult} Integrate_Scalar } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  ThisStep VectorResult} Integrate_Vector } \
		                    }
	set MenuEntriesP(4,17,0,0) { ""}
	set MenuCommandsP(4,17,0,0) { ""}
	set MenuEntriesP(4,17,0,1) { ""}
	set MenuCommandsP(4,17,0,1) { ""}

	set MenuEntriesP(4,17,1) [ list [_ "Scalar result"] [_ "Vector result"]]
	set MenuCommandsP(4,17,1) { \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  AllSteps ScalarResult} Integrate_Scalar } \
		                        {-npm- AddGraphsResultsToMenu %W \
		                             {GiD_Process Mescape Results Graphs Integrate "2D" \
		                                  AllSteps VectorResult} Integrate_Vector } \
		                    }
	set MenuEntriesP(4,17,1,0) { ""}
	set MenuCommandsP(4,17,1,0) { ""}
	set MenuEntriesP(4,17,1,1) { ""}
	set MenuCommandsP(4,17,1,1) { ""}
    }

    #----------------

    set MenuEntriesP(5) [list [_ "Legends#C#menu"] --- [_ "Reference axes#C#menu"]... --- [_ "Geometry#C#menu"] [_ "Change Color#C#menu"] \
		             [_ "Change Name#C#menu"] --- [_ "Contour#C#menu"] [_ "Vectors#C#menu"] [_ "Iso Surfaces#C#menu"] [_ "Stream Lines#C#menu"] \
		             [_ "Graphs#C#menu"] [_ "Result Surface#C#menu"] [_ "Line Diagrams#C#menu"] ]
    set MenuCommandsP(5) { \
		               {-np- PostLegendOptionsMenu %W } \
		               "" {-np- GlobalAxis::ChangeAxis} "" "" "" "" "" "" "" \
		               {-np- PostIsosurfaceMenuPrincipal %W } \
		               {-np- PostStreamLinesMenuPrincipal %W} \
		               "" "" "" }
    set MenuAccelerP(5) {"" "" "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIconsP(5) {"" "" "" "" "" "" "" "" "" "" "" "" ""}

    set MenuEntriesP(5,0) ""
    set MenuCommandsP(5,0) ""

    set MenuEntriesP(5,4) [list [_ "Border Angle#C#menu"] [_ "Massive Body#C#menu"] \
		               [_ "Transparent#C#menu"] [_ "Opaque#C#menu"] \
		               [_ "Point options#C#menu"]... [_ "Line options#C#menu"]... \
		               [_ "Covering mesh#C#menu"] [_ "Create delaunay meshes#C#menu"] \
		               [_ "Extract boundaries"] \
		               [_ "Separate connected components"]]

    set MenuCommandsP(5,4) [list \
		                {Results Options BorderAngle} \
		                {Results Options MassiveBody} \
		                {Utilities Render transparent} \
		                {Utilities Render opaque} \
		                {-np- PostPointOptions} \
		                [list -np- PostLineOptions LineSize LineDetail info_line_size [_ "Line options#C#menu"]] \
		                {Results Options ShowCoverMesh} \
		                "" \
		                {Results Options ExtractBoundaries}\
		                {Results Options SeparateConnectedComponents}]

    set MenuEntriesP(5,4,7) [ list [_ "One for each visible mesh"] \
		                  [_ "Single mesh for all visible meshes"] \
		                  [_ "Single mesh for all points"] \
		                  [_ "Force triangles"]]

    set MenuCommandsP(5,4,7) [ list {Results Options ShowDelaunayMesh VisibleMeshes} \
		                   {Results Options ShowDelaunayMesh AllVisibleMeshes} \
		                   {Results Options ShowDelaunayMesh AllPoints} ""]

    set MenuEntriesP(5,4,7,3) [ list [_ "One for each visible mesh"] \
		                    [_ "Single mesh for all visible meshes"] \
		                    [_ "Single mesh for all points"]]

    set MenuCommandsP(5,4,7,3) [ list {Results Options ShowDelaunayMesh ForceTriangles VisibleMeshes} \
		                     {Results Options ShowDelaunayMesh ForceTriangles AllVisibleMeshes} \
		                     {Results Options ShowDelaunayMesh ForceTriangles AllPoints}]

    set MenuEntriesP(5,5) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] [_ "Cut sets#C#menu"] ]
    set MenuCommandsP(5,5) [list \
		                [list -np- AddPostGeomToMenu %W \
		                     {GiD_Process Mescape Utilities ChangeColor Volumes} volumes \
		                     {Ambient Diffuse Specular Shininess Transparency Default} \
		                     [list [_ "Ambient#C#menu"] [_ "Diffuse#C#menu"] [_ "Specular#C#menu"] [_ "Shininess#C#menu"] \
		                          [_ "Transparency#C#menu"] [_ "Default#C#menu"]] \
		                    ]\
		                [list -np- AddPostGeomToMenu %W \
		                     {GiD_Process Mescape Utilities ChangeColor Surfaces} surfaces \
		                     {Ambient Diffuse Specular Shininess Transparency Default} \
		                     [list [_ "Ambient#C#menu"] [_ "Diffuse#C#menu"] [_ "Specular#C#menu"] [_ "Shininess#C#menu"] \
		                          [_ "Transparency#C#menu"] [_ "Default#C#menu"]] \
		                    ]\
		                [list -np- AddPostGeomToMenu %W \
		                     {GiD_Process Mescape Utilities ChangeColor Cuts} cuts \
		                     {Ambient Diffuse Specular Shininess Transparency Default} \
		                     [list [_ "Ambient#C#menu"] [_ "Diffuse#C#menu"] [_ "Specular#C#menu"] [_ "Shininess#C#menu"] \
		                          [_ "Transparency#C#menu"] [_ "Default#C#menu"]] \
		                    ]]

    set MenuEntriesP(5,5,0) { ""}
    set MenuCommandsP(5,5,0) { ""}

    set MenuEntriesP(5,5,1) { ""}
    set MenuCommandsP(5,5,1) { ""}

    set MenuEntriesP(5,5,2) { ""}
    set MenuCommandsP(5,5,2) { ""}

    set MenuEntriesP(5,6) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] [_ "Cut sets#C#menu"] ]
    set MenuCommandsP(5,6) { \
		                 {-np- AddPostGeomToMenu %W \
		                      {GiD_Process Mescape Utilities ChangeName Volumes} volumes "" "" } \
		                 {-np- AddPostGeomToMenu %W \
		                      {GiD_Process Mescape Utilities ChangeName Surfaces} surfaces "" "" } \
		                 {-np- AddPostGeomToMenu %W \
		                      {GiD_Process Mescape Utilities ChangeName Cuts} cuts "" "" } \
		             }
    
    set MenuEntriesP(5,6,0) { ""}
    set MenuCommandsP(5,6,0) { ""}

    set MenuEntriesP(5,6,1) { ""}
    set MenuCommandsP(5,6,1) { ""}

    set MenuEntriesP(5,6,2) { ""}
    set MenuCommandsP(5,6,2) { ""}

    set MenuEntriesP(5,8) [list [_ "Number of Colors#C#menu"] [_ "Width Intervals#C#menu"] \
		               [_ "Set Limits#C#menu"] [_ "Define Limits#C#menu"]... \
		               [_ "Reset Limit Values#C#menu"] [_ "Reset All#C#menu"] \
		               [_ "Max Options#C#menu"] [_ "Min Options#C#menu"] \
		               [_ "Color Scale#C#menu"] [_ "Smoothing type#C#menu"] \
		               [_ "Bright color#C#menu"] [_ "Color window#C#menu"]... \
		               [_ "Scale result"]]
    set MenuCommandsP(5,8) [ list \
		                 { Results ContOptions NumberOfColor} \
		                 { Results ContOptions FixIntervals} \
		                 "" \
		                 { -np- PostContLimitsWin} \
		                 { Results ContOptions SetMaxOptions ResetValue escape escape escape escape \
		                       Results ContOptions SetMinOptions ResetValue escape escape escape escape \
		                       Utilities Redisplay} \
		                 [ list Results ContOptions \
		                       SetMaxOptions ResetValue escape \
		                       SetMinOptions ResetValue escape \
		                       NumberOfColors 50 \
		                       escape escape escape escape \
		                       Results ContOptions \
		                       SetMinOptions MinColor Standard escape \
		                       SetMaxOptions MaxColor Standard escape \
		                       ColorRamp Tangent escape \
		                       Options ScaleResult ScaleMultiplier 1.0 \
		                       Options ScaleResult ScaleAdder 0.0 \
		                       Options ScaleResult UseLogScale No \
		                       escape escape escape escape \
		                       Utilities Redisplay \
		                       escape escape escape escape ] \
		                 "" "" {-np- PostContourWhichScaleMenu %W} {-np- PostSmoothContourTypeMenu %W} \
		                 { -np- PostContourBrightColorMenu %W} {-np- PostContourColors} \
		                 {-np- PostScaleResultMenu %W } \
		                ]
    set MenuIconsP(5,8) { "" "" "" "" "resetminmax16x16.gif" "" "" "" "" "" "" "" ""}

    set MenuEntriesP(5,8,2) [list [_ "Visible Sets for This Step#C#menu"] [_ "All Sets for This Step#C#menu"] \
		                 [_ "Visible Sets for All Steps#C#menu"] [_ "All Sets for All Steps#C#menu"] ]
    set MenuCommandsP(5,8,2) { \
		                   { Results ContOptions WhichContLimit ShownSets \
		                         escape escape escape escape Utilities Redisplay } \
		                   { Results ContOptions WhichContLimit AllSets\
		                         escape escape escape escape Utilities Redisplay } \
		                   { Results ContOptions FixAnalysisLim \
		                         escape escape escape escape Utilities Redisplay } \
		                   { Results ContOptions FixAbsLimits \
		                         escape escape escape escape Utilities Redisplay } }


    set MenuEntriesP(5,8,6) [list [_ "Reset Value#C#menu"] [_ "Out Max Color#C#menu"] [_ "Def. Max Color#C#menu"] [_ "Set Value#C#menu"] ]
    set MenuCommandsP(5,8,6) { \
		                   { Results ContOptions SetMaxOptions ResetValue\
		                         escape escape escape escape Utilities Redisplay } \
		                   { -np- PostOutMinMaxColourMenu %W Max} \
		                   { Results ContOptions SetMaxOptions MaxColor User} \
		                   { Results ContOptions SetMaxOptions SetValue} }
    set MenuIconsP(5,8,6) {"" "" "" "usermax16x16.gif"}

    set MenuEntriesP(5,8,6,1) ""
    set MenuCommandsP(5,8,6,1) ""


    set MenuEntriesP(5,8,7) [list [_ "Reset Value#C#menu"] [_ "Out Min Color#C#menu"] [_ "Def. Min Color#C#menu"] [_ "Set Value#C#menu"] ]
    set MenuCommandsP(5,8,7) { \
		                   { Results ContOptions SetMinOptions ResetValue\
		                         escape escape escape escape Utilities Redisplay } \
		                   { -np- PostOutMinMaxColourMenu %W Min} \
		                   { Results ContOptions SetMinOptions MinColor User} \
		                   { Results ContOptions SetMinOptions SetValue} }
    set MenuIconsP(5,8,7) {"" "" "" "usermin16x16.gif"}

    set MenuEntriesP(5,8,7,1) ""
    set MenuCommandsP(5,8,7,1) ""

    set MenuEntriesP(5,8,8) ""
    set MenuCommandsP(5,8,8) ""

    set MenuEntriesP(5,8,9) ""
    set MenuCommandsP(5,8,9) ""

    set MenuEntriesP(5,8,10) ""
    set MenuCommandsP(5,8,10) ""

    #set MenuEntriesP(5,6,12) [ list [_ "Scale factor"] [_ "Use logarithmic scale"]]
    #set MenuCommandsP(5,6,12) { \
	#                                    { Results Options ScaleResult ScaleFactor} \
	#                                    { Results Options ScaleResult UseLogScale} \
	#                                }

    set MenuEntriesP(5,8,12) ""
    set MenuCommandsP(5,8,12) ""

    #     set MenuEntriesP(5,7) [list [_ "Display Style#C#menu"] [_ "Render#C#menu"] [_ "Transparency#C#menu"] [_ "Convert to cuts#C#menu"] ]
    #     set MenuCommandsP(5,7) { \
	#             {-np- PostIsoSurfaceOptionsMenu %W DisplayStyle} \
	#             {-np- PostIsoSurfaceOptionsMenu %W Render} \
	#             {-np- PostIsoSurfaceOptionsMenu %W Transparency} \
	#             { Results isosurfaces TurnIntoCuts } }

    set MenuEntriesP(5,9) [list [_ "Interior/All vectors#C#menu"] [_ "Number of Colors#C#menu"] \
		               [_ "Color Mode#C#menu"] [_ "Offset#C#menu"] \
		               [_ "Change Color (mono)#C#menu"] [_ "Detail#C#menu"] \
		               [_ "Size#C#menu"] [_ "Filter factor"] ]
    set MenuCommandsP(5,9) { \
		                 { Results Options AllVectors} \
		                 { Results Options VectorNumCols} \
		                 { Results Options VectorColour} \
		                 { Results Options VectorOffset} \
		                 { Results Options VMonoColor} \
		                 {-np- PostVectorsDetailMenu %W } \
		                 {-np- PostVectorsSizeMenu %W } \
		                 { Results Options VectorFilterFactor} \
		             }

    set MenuEntriesP(5,9,5) ""
    set MenuCommandsP(5,9,5) ""

    set MenuEntriesP(5,9,6) ""
    set MenuCommandsP(5,9,6) ""

    set MenuEntriesP(5,10) ""
    set MenuCommandsP(5,10) ""

    #     set MenuEntriesP(5,8) [list [_ "Display Style#C#menu"] [_ "Transparency#C#menu"] \
	#                                [_ "Color Mode#C#menu"] [_ "Change color#C#menu"] \
	#                                [_ "Convert to cuts#C#menu"] [_ "Draw always#C#menu"] \
	#                                [_ "Show isolines#C#menu"]]
    #     set MenuCommandsP(5,8) { \
	#             {-np- PostIsoSurfaceOptionsMenu %W DisplayStyle} \
	#             {-np- PostIsoSurfaceOptionsMenu %W Transparency} \
	#             {-np- PostIsoSurfaceOptionsMenu %W Color} \
	#             { Results isosurfaces DisplayStyle ChangeMonoColour } \
	#             { Results isosurfaces TurnIntoCuts } \
	#             {-np- PostIsoSurfaceAlwaysDrawn %W 5}\
	#             {-np- PostIsoSurfaceDrawIsolines %W 6}}
    #
    #     set MenuEntriesP(5,8,0) ""
    #     set MenuCommandsP(5,8,0) ""
    #
    #     set MenuEntriesP(5,8,1) ""
    #     set MenuCommandsP(5,8,1) ""
    #
    #      set MenuEntriesP(5,8,2) ""
    #      set MenuCommandsP(5,8,2) ""

    set MenuEntriesP(5,11) ""
    set MenuCommandsP(5,11) ""

    #set MenuEntriesP(5,9) [ list [_ "Change color#C#menu"] [_ "Color Mode#C#menu"] [_ "Delete#C#menu"] \
	#                           [_ "Label#C#menu"] [_ "Size & detail#C#menu"]... \
	#                           [_ "Set initial step#C#menu"] \
	#                           [_ "Set max length#C#menu"] [_ "Set max points#C#menu"] [_ "Set initial rotation#C#menu"] [_ "Show arrows#C#Menu"]]
    #set MenuCommandsP(5,9) {
    #   { Results Options StreamColor ChangeMonoColour}
    #   {-np- PostStreamLinesColorOptionsMenu %W }
    #   { Results Options StreamDelete }
    #   { Results Options StreamLabel }
    #   {-np- PostStreamLineOptions }
    #   { Results Options StreamIniStep}
    #   { Result Options StreamLength}
    #   { Results Options StreamMaxPoints}
    #   { Results Options StLineIniRotation}
    #   {-np- PostStreamLinesArrows %W}

    #}

    #set MenuEntriesP(5,9,1) ""
    #set MenuCommandsP(5,9,1) ""

    #set MenuEntriesP(5,9,9) ""
    #set MenuCommandsP(5,9,9) ""

    set MenuEntriesP(5,12) [list [_ "Coordinates type#C#menu"] [_ "Model view#C#menu"] [_ "Outline on model#C#menu"] [_ "Grids#C#menu"] [_ "Current style#C#menu"] [_ "Change style graph#C#menu"] \
		                [_ "Change color graph#C#menu"] [_ "Set contour fill color#C#menu"] [_ "Change line width#C#menu"] [_ "Change line pattern#C#menu"] \
		                [_ "Change pattern factor#C#menu"] [_ "Change point size#C#menu"] [_ "Change title graph#C#menu"] [_ "View results table#C#menu"] \
		                [_ "Invert graph sense#C#menu"] [_ "Delete graph#C#menu"] [_ "Title#C#menu"] \
		                [_ "Reset axis values#C#menu"] [_ "X axis#C#menu"] [_ "Y axis#C#menu"] [_ "Clear graphs#C#menu"]]
    set MenuCommandsP(5,12)  { \
		                   {-np- PostGraphCoordinates %W}
	{-np- PostGraphModelView %W}
	{ Results Graphs OptionsGraph GraphOutlineOnModel } \
		                   { Results Graphs OptionsGraph Grids} \
		                   { Results Graphs OptionsGraph CurrentStyle} \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph StyleGraphs} 1 } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph ColorGraphs} 1 } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph ColorAsCFill} 1 } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph LineWidthGraphs} 1 } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph PatternGraphs} 1 } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph PatternFactor} 1 } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph PointSize} 1 } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph TitleGraphs} } \
		                   {-np- AddGraphsToMenu %W { GraphResults::Create} } \
		                   {-np- AddLineGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph InvertLineGraph} } \
		                   {-np- AddGraphsToMenu %W { GiD_Process Mescape Results Graphs OptionsGraph DeleteGraph} } \
		                   "" \
		                   { Results Graphs OptionsGraph X_Axis Reset Y_Axis Reset} \
		                   {-np- PostGraphXAxis %W}
	{-np- PostGraphYAxis %W}
	{ Results Graphs OptionsGraph Clear} \
		               }

    set MenuEntriesP(5,12,0) [list [_ "Cartesian#C#menu"] [_ "Polar#C#menu"]]
    set MenuCommandsP(5,12,0) { { Results Graphs OptionsGraph CoordType Cartesian} { Results Graphs OptionsGraph CoordType Polar}}

    set MenuEntriesP(5,12,1) [list [_ "Show#C#menu"] [_ "Size#C#menu"]]
    set MenuCommandsP(5,12,1) { { Results Graphs OptionsGraph ShowModelView Show} { Results Graphs OptionsGraph ShowModelView ModelViewSize}}

    set MenuEntriesP(5,12,5) { ""}
    set MenuCommandsP(5,12,5) { ""}

    set MenuEntriesP(5,12,6) { ""}
    set MenuCommandsP(5,12,6) { ""}

    set MenuEntriesP(5,12,7) { ""}
    set MenuCommandsP(5,12,7) { ""}

    set MenuEntriesP(5,12,8) { ""}
    set MenuCommandsP(5,12,8) { ""}

    set MenuEntriesP(5,12,9) { ""}
    set MenuCommandsP(5,12,9) { ""}

    set MenuEntriesP(5,12,10) { ""}
    set MenuCommandsP(5,12,10) { ""}

    set MenuEntriesP(5,12,11) { ""}
    set MenuCommandsP(5,12,11) { ""}

    set MenuEntriesP(5,12,12) { ""}
    set MenuCommandsP(5,12,12) { ""}

    set MenuEntriesP(5,12,13) { ""}
    set MenuCommandsP(5,12,13) { ""}

    set MenuEntriesP(5,12,14) { ""}
    set MenuCommandsP(5,12,14) { ""}

    set MenuEntriesP(5,12,15) { ""}
    set MenuCommandsP(5,12,15) { ""}
    
    set MenuEntriesP(5,12,16) [list [_ "Change text#C#menu"] [_ "Change position#C#menu"] [_ "Reset#C#menu"] ]
    set MenuCommandsP(5,12,16) { { Results Graphs OptionsGraph MainTitle} \
		                     { Results Graphs OptionsGraph Legend2Title}  \
		                     { Results Graphs OptionsGraph MainTitle "''"}}

    set MenuEntriesP(5,12,18) [list [_ "Reset#C#menu"] [_ "Set min value#C#menu"] [_ "Set max value#C#menu"] [_ "Set divisions#C#menu"] [_ "Set label#C#menu"] [_ "Set logarithmic scale#C#menu"]]
    set MenuCommandsP(5,12,18) { { Results Graphs OptionsGraph X_Axis Reset } \
		                     { Results Graphs OptionsGraph X_Axis SetMin} \
		                     { Results Graphs OptionsGraph X_Axis SetMax} \
		                     { Results Graphs OptionsGraph X_Axis SetDivisions} \
		                     { Results Graphs OptionsGraph X_Axis SetLog}}


    set MenuEntriesP(5,12,19) [list [_ "Reset#C#menu"] [_ "Set min value#C#menu"] [_ "Set max value#C#menu"] [_ "Set divisions#C#menu"] [_ "Set label#C#menu"] [_ "Set logarithmic scale#C#menu"]]
    set MenuCommandsP(5,12,19) { { Results Graphs OptionsGraph Y_Axis Reset } \
		                     { Results Graphs OptionsGraph Y_Axis SetMin} \
		                     { Results Graphs OptionsGraph Y_Axis SetMax} \
		                     { Results Graphs OptionsGraph Y_Axis SetDivisions} \
		                     { Results Graphs OptionsGraph Y_Axis SetLog}}


    set MenuEntriesP(5,13) [list [_ "Show elevations#C#menu"] ]
    set MenuCommandsP(5,13) { { -np- PostResultSurfaceOptionsMenu %W } }

    set MenuEntriesP(5,13,0) ""
    set MenuCommandsP(5,13,0) ""

    set MenuEntriesP(5,14) [list [_ "Show elevations#C#menu"] ]
    set MenuCommandsP(5,14) { { -np- PostDiagramOptionsMenu %W } }

    set MenuEntriesP(5,14,0) ""
    set MenuCommandsP(5,14,0) ""
    
    #----------------

    set MenuEntriesP(6) [list [_ "View style#C#menu"]... [_ "View results#C#menu"]... [_ "Animate#C#menu"]... \
		             --- [_ "View graphs#C#menu"]... [_ "Several Results#C#menu"]... \
		             [_ "Results ranges table#C#menu"]... [_ "Create Result"]...  ]
    #[_ "Create Result 2"]...
    set MenuCommandsP(6) { {-np- PostDisplay} {-np- PostGeom::Create}
	{-np- PostAnimateM} {} {-np- PostGraphs::Create} {-np- PostVariosResultados}
	{-np- PostRangesTable::Create} {-np- PostCreateResult}}
    # {-np- PCreateResult::Crear}
    #PostGraphs::Create instead PostGraphResultsWindow

    set MenuAccelerP(6) [list $M-s $M-d $M-m "" "" "" "" ""]
    # ""
    set MenuIconsP(6) { "" "" "" "" "" "" "" ""}
    # ""

    #----------------

    set MenuEntriesP(7) [list [_ "Help#C#menu"]... [_ "Customization Help#C#menu"]... [_ "Tutorials#C#menu"]... \
		             [_ "What is new#C#menu"]... [_ "FAQ#C#menu"]... --- [_ "Register %s#C#menu" $::GidPriv(ProgName)]... [_ "Register Problem type#C#menu"]... \
		             --- [_ "Visit %s web" $::GidPriv(ProgName)]... [_ "About#C#menu"]... ]
    set MenuCommandsP(7) [list {-np- GiDHelpWindow -type REFERENCE -start html-version} \
		              {-np- GiDHelpWindow  -type REFERENCE -start html-customization} \
		              { -np- CreateTutorial_win} { -np- GiDHelpWindow -type REFERENCE -start html_whatsnew} \
		              {-np- GiDHelpWindow -type REFERENCE -start html-faq} "" {-np- gidregister} \
		              {-np- gidregister module} "" "-np- VisitWeb $GidPriv(ProgWeb)" {-np- CreateWelcomeWin} ]
    set MenuAccelerP(7) {F1 "" "" "" "" "" "" "" ""}
    set MenuIconsP(7) {"help16x16.gif" "" "" "" "" "" "" "" ""}
}

#-----------------------------------------------------------

proc SetBitmapNamesP {} {
    global BitMapsNamesP BitMapsCommandsP BitmapsHelpP GidPriv

    unset -nocomplain BitMapsNamesP BitMapsCommandsP BitmapsHelpP


    set BitMapsNamesP(0) { zoomin.gif zoomout.gif zframe.gif redraw.gif \
		               rotate.gif pan.gif --- lightpos.gif \
		               displaystyle.gif cullstyle.gif --- meshes.gif \
			       sets.gif cuts.gif --- docut.gif \
			       --- usermax.gif usermin.gif ContOptions.gif \
			       list.gif}

    #dividemesh dividesets


    set BitMapsCommandsP(0) { {-ne- Zoom In} {-ne- Zoom Out} {-ne- Zoom Frame} \
		                  {-ne- Redraw} {-ne- Rotate Trackball} {-ne- Dynamicpan } "" \
		                  { Utilities Render ChangeLightvec} \
		                  {-np- AddBitmapsToDisplayStyle %W { GiD_Process Mescape DisplayStyle}} \
		                  {-np- AddBitmapsToCullStyle %W { GiD_Process Mescape Utilities Render Culling}} \
		                  "" {-np- AddBitmapsToMeshSetCut %W { GiD_Process Mescape Select} volumesets} \
		                  {-np- AddBitmapsToMeshSetCut %W { GiD_Process Mescape Select} surfacesets} \
		                  {-np- AddBitmapsToMeshSetCut %W { GiD_Process Mescape Select} cutsets} \
		                  "" {-np- AddBitmapsToCutDivide %W { GiD_Process Mescape DoCut} CutPlane} \
		                  "" {-np- PostContLimitsMaxEntry %W } \
		                  {-np- PostContLimitsMinEntry %W }\
		                  "" \
		                  {-np- AddBitmapsToMenu %W {GiD_Process Mescape Utilities List } "list" }
    }

    #             {-np- AddBitmapsToCutDivide %W \
	#             { GiD_Process Mescape DoCut} DivideMesh} \
	#             {-np- AddBitmapsToCutDivide %W \
	#             { GiD_Process Mescape DoCut} DivideSets}

    set BitmapsHelpP(0) [list [_ "Zoom in#C#menu"] [_ "Zoom out#C#menu"] [_ "Zoom frame#C#menu"] [_ "Redraw#C#menu"] \
		             [_ "Rotate trackball#C#menu"] [_ "Pan#C#menu"] "" [_ "Change light vector direction#C#menu"] \
		             [_ "Display Style#C#menu"] [_ "Culling Style#C#menu"] \
		             "" [_ "Switch Volume sets On/Off#C#menu"] \
		             [_ "Switch Surface set On/Off#C#menu"] [_ "Switch Cut set On/Off#C#menu"] \
		             "" [_ "Cut Volume/Surface sets with 2/3 points, succesion#C#menu"] "" \
		             [_ "Set maximum value#C#menu"] [_ "Set minimum value#C#menu"] \
		             [_ "Contour options#C#menu" ] \
			     [_ "List Entities#C#menu"] ]
    #"Divide Mesh with 2/3 points" \
	#            "Divide Sets with 2/3 points"

    set BitMapsNamesP(0,8) { boundaries.gif hiddenbound.gif alllines.gif hiddenlines.gif body.gif bodybound.gif \
		                 bodylines.gif points.gif pointsbound.gif}
    set BitMapsCommandsP(0,8) { boundaries hiddenbound alllines hiddenlines body bodybound bodylines points pointsbound}

    set BitMapsNamesP(0,9) { cullnone.gif cullfrontfaces.gif cullbackfaces.gif}
    set BitMapsCommandsP(0,9) { none frontfaces backfaces}

    set BitMapsNamesP(0,11) { volumesets.gif}
    set BitMapsCommandsP(0,11) { volumesets}

    set BitMapsNamesP(0,12) { surfacesets.gif}
    set BitMapsCommandsP(0,12) { surfacesets}

    set BitMapsNamesP(0,13) { cutsets.gif}
    set BitMapsCommandsP(0,13) { cutsets}

    set BitMapsNamesP(0,15) { cut2p.gif cut3p.gif}
    set BitMapsCommandsP(0,15) { cut2p cut3p}

    #set BitMapsNamesP(0,15) { cut2p.gif cut3p.gif}
    #set BitMapsCommandsP(0,15) { cut2p cut3p}
    #
    #set BitMapsNamesP(0,16) { cut2p.gif cut3p.gif}
    #set BitMapsCommandsP(0,16) { cut2p cut3p}
    set BitMapsNamesP(0,19) { ContLog.gif ContMultFactor.gif ContAddFactor.gif resetminmax.gif}

    set BitMapsCommandsP(0,19) { {-np- PostContLogSwitch %W %I } \
				     {-np- PostContFactorEntry %W ScaleMultiplier} \
				     {-np- PostContFactorEntry %W ScaleAdder} \
				     { Results ContOptions SetMaxOptions ResetValue Mescape \
					   Results ContOptions SetMinOptions ResetValue Mescape \
					   Utilities Redisplay }  \
				 }
    # set BitmapsHelpP(0,19) [ list [_ "Set logarithmic view#C#menu" ] [_ "Set multiplier factor#C#menu" ] \
    # 			      [_ "Set adder factor#C#menu" ] [_ "Reset Contour Limit Values#C#menu"] \
    # 			     ]
    
    set BitMapsNamesP(0,20) { }
    set BitMapsCommandsP(0,20) { }
}

#user procedures that modify menu variables could be registered to be automatically called
#procname is a procedure without any argument
#GiD_RegisterPluginAddedMenuProc <procname>
#GiD_UnRegisterPluginAddedMenuProc <procname> 

proc GiD_RegisterPluginAddedMenuProc { procname } {
    if { [info procs $procname] != "" && [llength [info args $procname]] != 0 } {
	return -code error [_ "Wrong procedure prototype, must be '%s'." "proc procname {} body"]
    }

    if { ![info exists ::GidPriv(RegisteredPluginMenuProcs)] } {
	set pos -1
    } else {
	set pos [lsearch $::GidPriv(RegisteredPluginMenuProcs) $procname] 
    }
    if { $pos == -1 } {
	lappend ::GidPriv(RegisteredPluginMenuProcs) $procname
    }
}

proc GiD_UnRegisterPluginAddedMenuProc { procname } {
    if { ![info exists ::GidPriv(RegisteredPluginMenuProcs)] } {
	return 1
    } 
    set pos [lsearch $::GidPriv(RegisteredPluginMenuProcs) $procname]     
    if { $pos == -1 } {
	set ::GidPriv(RegisteredPluginMenuProcs) [lreplace $::GidPriv(RegisteredPluginMenuProcs) $pos $pos]
    }
}

proc EvalPluginAddedMenuProcs { } {
    if { ![info exists ::GidPriv(RegisteredPluginMenuProcs)] } {
	return
    }
    foreach procname $::GidPriv(RegisteredPluginMenuProcs) {
	if { [info procs $procname] != "" } {
	    $procname
	}
    }
}


proc SetAllMenusVariables {} {
    global GidPriv

    set err [catch { package present Tk }]
    if { $err } { return }

    SetMenusVariables
    SetBitmapNames
    Set3dButtonVariables
    SetMenusVariablesP
    SetBitmapNamesP
    #DWInitUserDataOptions

    if { $::GidPriv(HideVolumeLevel)==1 } {
	HideVolumeFromMenus
	HideVolumeFromToolbars
    }

    #to modify menus with plugin defined procedures
    EvalPluginAddedMenuProcs
}

proc ClearMenu { w } {
    set lastentry [$w index last]
    if { $lastentry == "none" } {
	return
    }
    for { set i 0 } { $i <= $lastentry } { incr i } {
	if { [$w type $i] == "cascade" } {
	    set wchild [$w entrycget $i -menu]
	    ClearMenu $wchild
	    destroy $wchild
	}
    }
    $w delete 0 last
}


proc SwapCopyMove { {mode "Copy"} } {
    set w .gid.wcopymove
    if { [winfo exists $w] } {
       destroy $w
    } else {
       CopyMove $mode
    }
}

proc SwapChangeVariables { } {
    set w .gid.wvar
    if { [winfo exists $w] } {
       destroy $w
    } else {
	ChangeVariables
    }
}

proc SwapChangeLayers { } {
    if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	set whatuse GEOMETRYUSE
    }
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	#preprocess
	set w .gid.central.wlay
	if { [winfo exists $w] } {
	    GidUtils::CloseWindow LAYER
	} else {
	    ChangeLayers
	}
    } else {
	#postprocess
	set w .gid.wPostDisplay
	if { [winfo exists $w] } {
	   destroy $w
	} else {
	  PostDisplay
	}
    }
}

proc SwapHelpWindow { {help_type "REFERENCE"} {dir "" } } {
    set w .gid.help_win
    if { [winfo exists $w] } {
       destroy $w
    } else {
       HelpWindow $help_type $dir
    }
}


proc StdBitmaps { { what "DEFAULT" }} {
    #WarnWinText "StdBitmaps"
    global StdBitmapsNames StdBitmapsCommands StdBitmapsHelp GIDDEFAULT
    global GidPriv
    set StdBitmapsNames(0) [ list new.gif open2.gif save.gif --- \
				 viewprev.gif viewnext.gif viewlist.gif FullScreen.gif --- \
				 camera.gif print.gif --- \
		                 prepost.gif copy.gif layer.gif --- \
				 prefs.gif help.gif --- \
				 exit.gif $::GidPriv(InfoGiDPreIcon) $GidPriv(InfoGiDBitmapName) ]
#  --- [ list -np- putStatusLabel %W ::GiDStatus(ProblemTypeName) [_ "problem type"]] 
    set GidPriv(InfoGiDBitmapsWidth) 77
    set GidPriv(InfoGiDBitmapsHeight) 24


    if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	set whatuse GEOMETRYUSE
    }
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	#preprocess
	set StdBitmapsCommands(0) [list { files new} { files read} { files save} "" \
		                       {-ne- Zoom Previous} {-ne- Zoom Next} {-np- AddRecentViewFiles2IconBar %W } \
				       {-np- SwitchFullScreen} "" \
		                       {-np- AddBitmapsToCamera %W { GiD_Process HardCopy } } \
		                       {-np- HardcopyToPrint {Hardcopy PS}} "" {-np- TogglePrePost} \
		                       {-np- SwapCopyMove "Copy"} {-np- SwapChangeLayers} "" \
		                       {-np- SwapChangeVariables } {-np- GiDHelpWindow -type REFERENCE -start html-version} \
				       "" { -np- QuitFullScreen} "" \
		                       "-np- $GidPriv(InfoGiDProc)"]
#                                       "" {-np- ShowDataMenu %W %X %Y }
	
	set StdBitmapsHelp(0) [list [_ "New %s project" $::GidPriv(ProgName)] [_ "Open %s project" $::GidPriv(ProgName)] \
				   [_ "Save %s project" $::GidPriv(ProgName)] \
		                   "" [_ "Previous view"] [_ "Next view"] [_ "List of views"] [_ "Full screen mode"] "" \
		                   [_ "Take a snapshot"] [_ "Print current view"] "" \
		                   [_ "Toggle between pre and postprocess"] [_ "Copy/Transform"] \
		                   [_ "Layers"] "" [_ "Preferences"] [_ "Help"] "" [_ "Exit program"] \
		                   [_ "Program mode:\ngeometry colours - preprocess"] \
				   [_ "Current loaded problem type for actual projects"] \
				   [_ "GiD mode: preprocess or postprocess"] \
		                   [_ "Information about the current program"] ]
	
	set idxViews 6
	set idxHardcopy 9
       } else {
	#postprocess
	   set StdBitmapsNames(0) [ list new.gif open2.gif openMultiple.gif save.gif --- \
		                        viewprev.gif viewnext.gif viewlist.gif FullScreen.gif \
		                        --- camera.gif print.gif --- \
		                        prepost.gif copy.gif layer.gif --- \
					prefs.gif help.gif \
					--- exit.gif \
		                        --- \
		                        [ list -np- putStatusLabel %W ::GiDStatus(NumberOfNodes) [_ "n#C#Nodes"]] \
		                        [ list -np- putStatusLabel %W ::GiDStatus(NumberOfElements) [_ "e#C#Elements"]] \
		                        --- \
		                        [ list -np- putStatusLabel %W ::GiDStatus(RenderMode) [_ "r#C#Render"]] \
		                        [ list -np- putStatusLabel %W ::GiDStatus(Transparencies) [_ "t#C#Transp"]] \
		                        --- \
		                        [ list -np- putStatusLabel %W ::GiDStatus(Units) [_ "Units"]] \
					$::GidPriv(InfoGiDPostIcon) \
		                        $GidPriv(InfoGiDBitmapName)]
#            $GidPriv(InfoGiDBitmapName)"
	   set StdBitmapsCommands(0) [list { files new} { files read} { files readMultiple} { files saveall binmeshessets} "" \
		                          {-ne- Zoom Previous} {-ne- Zoom Next} {-np- AddRecentViewFiles2IconBar %W } {-np- SwitchFullScreen} \
					  "" {-np- AddBitmapsToCamera %W {  GiD_Process HardCopy } } {-np- HardcopyToPrint {Hardcopy PS}} "" \
					  {-np- TogglePrePost} {-np- SwapCopyMove "Copy"} {-np- SwapChangeLayers} "" \
		                          {-np- SwapChangeVariables } {-np- GiDHelpWindow -type REFERENCE -start html-version} \
		                          "" { -np- QuitFullScreen} "" \
		                          {-np- ShowHideListStatusWindow} \
		                          {-np- ShowHideListStatusWindow} \
		                          "" \
		                          {-np- RenderRing} \
		                          {-np- SwitchTransparency} \
		                          "" \
		                          {-np- ChangeResultUnits} \
					  "" \
		                          "-np- $GidPriv(InfoGiDProc)"]

#                                          [ list -np- menuStatusLabel %W ::GiDStatus(Transparencies) [_ Transp]]
#                                          [ list -np- menuStatusLabel %W ::GiDStatus(RenderMode) [_ Render]]
#                                          [ list -np- menuStatusLabel %W ::GiDStatus(NumberOfNodes) [_ Nodes]]
#                                          [ list -np- menuStatusLabel %W ::GiDStatus(NumberOfElements) [_ Elements]]
#                                          "-np- $GidPriv(InfoGiDProc)"]
	
	   set StdBitmapsHelp(0) [list [_ "Clean postprocess"] [_ "Open Postprocess file"] [_ "Open Postprocess multiple files"] \
		                      [_ "Export binary postprocess"] "" \
		                      [_ "Previous view"] [_ "Next view"] [_ "List of views"] [_ "Full screen mode"] \
				      "" [_ "Take a snapshot"] [_ "Print current view"] "" \
		                      [_ "Toggle between pre and postprocess"] [_ "Copy/Transform"] [_ "View style"] "" \
				      [_ "Preferences"] [_ "Help"] \
		                      "" [_ "Exit current program"] \
				      "" \
		                      [_ "Number of total nodes\n(Click for status list)"] \
		                      [_ "Number of total elements\n(Click for status list)"] \
		                      "" \
		                      [_ "Render status\n(Click to change)"] \
		                      [_ "Transparencies status\n(Click to swith change transparency)"] \
		                      "" \
		                      [_ "Mesh units used\n(Click to change result units)"] \
				      [_ "Program mode:\nrainbow colours - postprocess"] \
				      [_ "Information about the current program"] ]

	   set idxViews 7
	   set idxHardcopy 10
       }

    set StdBitmapsNames(0,$idxViews) {}
    set StdBitmapsCommands(0,$idxViews) {}

    set StdBitmapsNames(0,$idxHardcopy) { eps.gif ps.gif bmp.gif gif.gif jpeg.gif png.gif tga.gif tiff.gif vrml.gif}
    set StdBitmapsCommands(0,$idxHardcopy) { eps ps bmp gif jpeg png tga tiff vrml}

    CreateOtherBitmaps StdBar [_ "Standard Bar"] StdBitmapsNames StdBitmapsCommands \
	    StdBitmapsHelp $GIDDEFAULT/bitmaps StdBitmaps $what PrePost
    AddNewToolbar "Standard bar" PrePostStdBarWindowGeom StdBitmaps [_ "Standard bar"]

}

proc ViewResultsBarBitmaps { { what "DEFAULT"}} {
    global ViewResultsBarBitmapsNames ViewResultsBarBitmapsCommands ViewResultsBarBitmapsHelp GIDDEFAULT
    global GidPriv
    set ViewResultsBarBitmapsNames(0) [ list \
					    PostBarNoResult.gif postgraf.gif --- PostBarAnalysisStep.gif \
					    --- PostBarContourFill.gif PostBarContourLines.gif PostBarShMinMaxOpts.gif \
		                            PostBarVectors.gif PostBarIsoSurfaces.gif PostBarStreamLines.gif PostBarResultSurface.gif \
					    PostBarDeformation.gif --- PostBarGraphs.gif \
		                       ]
    set GidPriv(InfoGiDBitmapsWidth) 24
    set GidPriv(InfoGiDBitmapsHeight) 24

    if { [catch { set whatuse [GiD_Info Project ViewMode] }] } {
	set whatuse GEOMETRYUSE
    }
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
    } else {
	
	set ::ViewResultsBarShMinMaxImages [ list \
						 PostBarShMin.gif \
						 PostBarShMax.gif \
						 PostBarShMinMax.gif \
						 ]
	set ::ViewResultsBarShMinMaxCommands [ list \
						   {-npm- AddResultsToMenu %W { GiD_Process Mescape Results ShMin } "Sh_Min_Max"} \
						   {-npm- AddResultsToMenu %W { GiD_Process Mescape Results ShMax } "Sh_Min_Max"} \
						   {-npm- AddResultsToMenu %W { GiD_Process Mescape Results ShMinMax } "Sh_Min_Max"} \
						   ]
	
	#postprocess
	set ::ViewResultsBarGraphsImages [ list \
					       PostBarGraphPointEvolution.gif PostBarGraphLine.gif \
					       PostBarGraphPointGraph.gif PostBarGraphBorder.gif \
					       PostBarGraphIntegrate.gif PostBarGraphPointComplexEvolution.gif \
					       PostBarGraphClear.gif \
					      ]

	# -npm- --> means there is a cascaded submenu
	# -np- --> is only a tcl command
	set ::ViewResultsBarGraphsCommands [ list \
						 {-npm- AddGraphsResultsToMenu %W {GiD_Process Mescape Results Graphs PointEvolution} \
						      "Point_Evolution" } \
						 {-npm- AddGraphsResultsToMenu %W {GiD_Process Mescape Results Graphs LineGraph} \
						      "Line_Graph" } \
						 {-npm- AddGraphsXYResultsToMenu %W {GiD_Process Mescape Results Graphs PointGraph} \
						      "Point_Graph" } \
						 {-npm- AddGraphsXYResultsToMenu %W {GiD_Process Mescape Results Graphs BorderGraph} \
						      "Border_Graph" } \
						 {-npm- AddIntegrateGraphOptions %W} \
						 {-npm- AddGraphsResultsToMenu %W {GiD_Process Mescape Results Graphs PointComplexEvolution} \
						      "Point_Complex_Evolution" } \
						 { Results Graphs OptionsGraph ClearGraphs} \
						]

	set ViewResultsBarBitmapsCommands(0) [list \
						  { Results Geometry NoResults \
							Geometry Original \
							Geometry HideTheShow \
							Mescape View Label Off} \
						  {-np- TogglePostGraph} \
						  {} \
						  {-np- AddAnalysisStepsToMenu %W} \
						  {} \
						  {-np- AddResultsToMenu %W {  GiD_Process Mescape Results ContourFill } \
						       "Contour_Fill"} \
						  {-np- AddResultsToMenu %W { GiD_Process Mescape Results ContourLines } \
						       "Contour_Lines"} \
						  [ list -np- AddImageSubmenu %W ::ViewResultsBarShMinMaxImages ::ViewResultsBarShMinMaxCommands] \
						  {-np- AddResultsToMenu %W { GiD_Process Mescape Results DisplayVectors } \
						       "Display_Vectors"} \
						  {-np- AddResultsToMenu %W { GiD_Process Mescape Results IsoSurfaces Exact} \
						       "Iso_Surfaces" 1} \
						  {-np- AddResultsToMenu %W { GiD_Process Mescape Results StreamLines } \
						       "Stream_Lines"} \
						  {-np- AddResultsToMenu %W { GiD_Process Mescape Results ResultSurface } \
						       "Result_Surface"} \
						  {-np- AddResultsToMenu %W { GiD_Process Mescape Results Geometry Deformation } \
						       "Deformation"} \
						  {} \
						  [ list -np- AddImageSubmenu %W ::ViewResultsBarGraphsImages ::ViewResultsBarGraphsCommands] \
						 ]
	
	set ViewResultsBarBitmapsHelp(0) [ list [_ "No results#C#menu"] [_ "Toggle mesh and graphs view#C#menu"] {} \
					       [_ "Default Analysis/Step#C#menu"] {} \
					       [_ "Contour fill#C#menu"] [_ "Contour lines#C#menu"] [_ "Show min max#C#menu"] \
					       [_ "Display vectors#C#menu"] [_ "Iso surfaces#C#menu"] [_ "Stream lines#C#menu"] \
					       [_ "Result surface#C#menu"] [_ "Deformation#C#menu"] {} \
					       [_ "Several graphs#C#menu"] \
					      ]

	set ViewResultsBarBitmapsNames(0,3) ""
	set ViewResultsBarBitmapsCommands(0,3) ""
	set ViewResultsBarBitmapsNames(0,5) ""
	set ViewResultsBarBitmapsCommands(0,5) ""
	set ViewResultsBarBitmapsNames(0,6) ""
	set ViewResultsBarBitmapsCommands(0,6) ""

	# shminmax
	set ViewResultsBarBitmapsNames(0,7) ""
	set ViewResultsBarBitmapsCommands(0,7) ""
	set ViewResultsBarBitmapsNames(0,7,0) ""
	set ViewResultsBarBitmapsCommands(0,7,0) ""
	set ViewResultsBarBitmapsNames(0,7,1) ""
	set ViewResultsBarBitmapsCommands(0,7,1) ""
	set ViewResultsBarBitmapsNames(0,7,2) ""
	set ViewResultsBarBitmapsCommands(0,7,2) ""

	set ViewResultsBarBitmapsNames(0,8) ""
	set ViewResultsBarBitmapsCommands(0,8) ""
	set ViewResultsBarBitmapsNames(0,9) ""
	set ViewResultsBarBitmapsCommands(0,9) ""
	set ViewResultsBarBitmapsNames(0,10) ""
	set ViewResultsBarBitmapsCommands(0,10) ""
	set ViewResultsBarBitmapsNames(0,11) ""
	set ViewResultsBarBitmapsCommands(0,11) ""
	set ViewResultsBarBitmapsNames(0,12) ""
	set ViewResultsBarBitmapsCommands(0,12) ""

	set ViewResultsBarBitmapsNames(0,14) ""
	set ViewResultsBarBitmapsCommands(0,14) ""

	
	# set ViewResultsBarBitmapsHelp(0,14) [ list [_ "Point evolution#C#menu"] [_ "Line graph#C#menu"] \
	# 					  [_ "Point graph#C#menu"] [_ "Border graph#C#menu"] \
	# 					  [_ "Graph of an integrated result over a mesh"] \
	# 					  [_ "Point evolution of a complex result#C#menu"] \
	# 					  [_ "Clear graphs#C#menu"] \
	# 					 ]
	# 					      

	set ViewResultsBarBitmapsNames(0,14,0) ""
	set ViewResultsBarBitmapsCommands(0,14,0) ""
	set ViewResultsBarBitmapsNames(0,14,1) ""
	set ViewResultsBarBitmapsCommands(0,14,1) ""
	set ViewResultsBarBitmapsNames(0,14,2) ""
	set ViewResultsBarBitmapsCommands(0,14,2) ""
	set ViewResultsBarBitmapsNames(0,14,3) ""
	set ViewResultsBarBitmapsCommands(0,14,3) ""
	set ViewResultsBarBitmapsNames(0,14,4) ""
	set ViewResultsBarBitmapsCommands(0,14,4) ""
	set ViewResultsBarBitmapsNames(0,14,5) ""
	set ViewResultsBarBitmapsCommands(0,14,5) ""
	set ViewResultsBarBitmapsNames(0,14,6) ""
	set ViewResultsBarBitmapsCommands(0,14,6) ""
    }

    CreateOtherBitmaps ViewResultsBar [_ "View Results bar"] ViewResultsBarBitmapsNames \
	ViewResultsBarBitmapsCommands ViewResultsBarBitmapsHelp $GIDDEFAULT/bitmaps ViewResultsBarBitmaps $what Post
    AddNewToolbar "View results bar" ViewResultsBarWindowGeom ViewResultsBarBitmaps [_ "View results bar"]
}

#invoked in SetAllMenusVariables to remove from menus all relative to volumes
proc HideVolumeFromMenus { } {
    GiDMenu::RemoveOption "Geometry" [list "Create" "Volume"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Create" "---2"] PRE
    GiDMenu::RemoveOption "Geometry" [list "Create" "Contact"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Create" "Object" "---0"] PRE
    GiDMenu::RemoveOption "Geometry" [list "Create" "Object" "Sphere"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Create" "Object" "Cylinder"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Create" "Object" "Cone"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Create" "Object" "Prism"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Create" "Object" "Torus"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Delete" "Volumes"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Edit" "Divide" "Volumes"] PRE  
    GiDMenu::RemoveOption "Geometry" [list "Edit" "Join" "Volumes"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Edit" "Hole volume"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Edit" "---1"] PRE

    GiDMenu::RemoveOption "Geometry" [list "Edit" "Collapse" "Volumes"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Edit" "Uncollapse" "Volumes"] PRE 
    GiDMenu::RemoveOption "Geometry" [list "Edit" "Volume boolean op."] PRE   
    
    GiDMenu::RemoveOption "Utilities" [list "Signal" "Volumes"] PRE 
    
    GiDMenu::RemoveOption "Mesh" [list "Unstructured" "Assign sizes on volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Unstructured" "Assign entities" "Volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Structured" "Volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "SemiStructured"] PRE
    GiDMenu::RemoveOption "Mesh" [list "Cartesian" "Volumes"] PRE
    GiDMenu::RemoveOption "Mesh" [list "Boundary layer" "3D"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" "Default" "Volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" "Linear" "Volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" ---1] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" "Tetrahedra"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" "Hexahedra"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" "Prism"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" "Sphere"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Element type" "Only points"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Mesh criteria" "Default" "Volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Mesh criteria" "Mesh" "Volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Mesh criteria" "No mesh" "Volumes"] PRE   
    GiDMenu::RemoveOption "Mesh" [list "Mesh criteria" "Default mesh" "Volumes"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Mesh criteria" "Force points to" "Volume mesh"] PRE 
    GiDMenu::RemoveOption "Mesh" [list "Mesh criteria" "Duplicate" "Surfaces"] PRE ;#is for surfaces embedded in volume
    GiDMenu::RemoveOption "Mesh" [list "Mesh criteria" "No Duplicate" "Surfaces"] PRE ;#is for surfaces embedded in volume
    
    GiDMenu::RemoveOption "Mesh" [list "Draw" "Sizes" "Volumes"] PRE  
    GiDMenu::RemoveOption "Mesh" [list "Draw" "Element types" "Volumes"] PRE  
    GiDMenu::RemoveOption "Mesh" [list "Draw" "Mesh/No mesh" "Volumes"] PRE  
    GiDMenu::RemoveOption "Mesh" [list "Draw" "Structured type" "Volumes"] PRE   
    GiDMenu::RemoveOption "Mesh" [list "Draw" "Force points to" "Volume mesh"] PRE  
  
    #GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Create element" "Tetrahedra"] PRE
    #GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Create element" "Hexahedra"] PRE
    #GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Create element" "Prism"] PRE
    #GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Create element" "Sphere"] PRE

    GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Split elements" "---0"] PRE  
    GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Split elements" "Tetrahedra->Tetrahedra"] PRE
    GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Split elements" "Hexahedra->Tetrahedra"] PRE  
    GiDMenu::RemoveOption "Mesh" [list "Edit mesh" "Split elements" "Prism->Tetrahedra"] PRE      
}

proc HideVolumeFromToolbars {} {
    #hacer esto bien, no tan a saco...

    set button volume.gif
    set p [lsearch $::BitMapsNames(0) $button]
    if { $p != -1 } {
	set ::BitMapsNames(0)  [lreplace $::BitMapsNames(0) $p $p]
	set ::BitMapsCommands(0) [lreplace $::BitMapsCommands(0) $p $p]
	set ::BitmapsHelp(0) [lreplace $::BitmapsHelp(0) $p $p]
	foreach index [lsort [array names ::BitMapsNames 0,*]] {
	    set position [lindex [split $index ,] end]
	    if { $position > $p } {
		set position_prev [expr $position-1]
		set ::BitMapsNames(0,$position_prev) $::BitMapsNames(0,$position)
		set ::BitMapsCommands(0,$position_prev) $::BitMapsCommands(0,$position)
		if { [info exists ::BitmapsHelp(0,$position_prev)] } {
		    set ::BitmapsHelp(0,$position_prev) $::BitmapsHelp(0,$position)
		}
		unset ::BitMapsNames(0,$position)
		unset ::BitMapsCommands(0,$position)
		unset -nocomplain ::BitmapsHelp(0,$position)
	    }
	}
    }

    set button object.gif
    set subbuttons {sphere.gif cylinder.gif cone.gif Prism.gif tori.gif}
    set p [lsearch $::BitMapsNames(0) $button]
    if { $p != -1 } {
	lset ::BitmapsHelp(0) $p [_ "Create Object:\n Rectangle\n Polygon\n Circle"]
	set index 0,$p
	foreach item $subbuttons {
	    set position [lsearch $::BitMapsNames($index) $item]
	    if { $position != -1 } {
		set ::BitMapsNames($index)  [lreplace $::BitMapsNames($index) $position $position]
		set ::BitMapsCommands($index)  [lreplace $::BitMapsCommands($index) $position $position]
		if { [info exists ::BitmapsHelp($index)] } {
		     set ::BitmapsHelp($index) [lreplace $::BitmapsHelp($index) $position $position]
		 }
	    }
	}
    }

    #erase.gif {volume.gif}
    #and
    #list.gif {volume.gif}
    #are created at runtime
}

proc UpdateMenusAndToolbars {} {
    SetAllMenusVariables
    GiDMenu::UpdateMenus
    UpdateToolbarGeometryAndView
}

trace add variable ::GidPriv(HideVolumeLevel) write "UpdateMenusAndToolbars ;#" ;#to update menus and toolbars variables
