
#PostResults -*- TCL -*- Created: ramsan&miguel Jan-1997, Modified: ramsan Jan-1997

set PRDebug 0

proc PRToNode { node } {
    if { $::PRDebug} {
	WarnWinText "     ----> PRTONODE converting $node"
    }
    regsub -all {[^a-zA-Z0-9()_/-]} $node {_} node
    if { $::PRDebug} {
	WarnWinText "     ----> TO $node"
    }
    return $node
}

proc PRArbolNoResultado { arbol que_res} {
    global GidPriv

    set txt [_ "<No usable results found>"]
    if { $que_res == "No_Result"} {
	set txt [_ "<No result is drawn>"]
    } elseif { $que_res == "Contour_Ranges"} {
	set txt [_ "<No results with Result Range Table associated>"]
    }

    $arbol delete [ $arbol nodes root]
    $arbol insert end root "" -text $txt -data ""
    set GidPriv($arbol,cache) ""
}

proc PRConstruyeArbol { arbol lista_res} {
    global GidPriv

    if { $::PRDebug} {
	WarnWinText "PRconstruyeArbol $arbol $lista_res"
    }

    if { ![ info exists GidPriv($arbol,cache)]} {
	set GidPriv($arbol,cache) ""
    }

    # miramos si tenemos que recostruir el arbol
    if { $GidPriv($arbol,cache) != ""} {
	if { [ llength $lista_res] == [ llength $GidPriv($arbol,cache)]} {
	    set iguales 1
	    for { set i 0 } { $i < [ llength $lista_res]} { incr i} {
		if { ![ string equal [ lindex $lista_res $i] [ lindex $GidPriv($arbol,cache)]] } {
		    set iguales 0
		    break
		}
	    }
	    if { $iguales} { return}
	}
    }
    $arbol delete [ $arbol nodes root]

    set res_view $GidPriv(PostResultsView)
    set res_anal $GidPriv(PostResultsAnal)
    set res_step $GidPriv(PostResultsStep)

    if { $::PRDebug} {
	WarnWinText "   arbol delete"
    }
    $arbol delete [ $arbol nodes root]

    #set l_res [ lsort $lista_res]
    set l_res $lista_res

    foreach i_res $l_res {
	if { ![ regexp {^/?/?(.*)//(.*?)$} $i_res dum path res_name]} {
	    set path root
	    set res_name $i_res
	}
	set pp ""
	regsub -all {//} $path { } lst_niveles
	foreach iniv $lst_niveles {
	    set padre $pp
	    if { $pp != ""} { 
		append pp //
	    } else {
		set padre root
	    }
	    append pp $iniv
	    regsub -all {_} $iniv { } txt
	    set txt [= $txt]
	    set pp [PRToNode $pp]
	    if { ![ $arbol exists $pp] } {
		if { $::PRDebug} {
		    WarnWinText "   1:arbol insert end $padre $pp -text $txt -image {GetImage folder.gif} -data nodo"
		}
		$arbol insert end $padre $pp -text $txt -image [ GetImage folder.gif] -data nodo
	    }
	}
	regsub -all {_} $res_name { } txt
	set txt [= $txt]
	#$arbol insert end $path "$path->$res_name" -text $txt -image [ GetImage point16x16.gif]
	if { $i_res != ""} {
	    set l_comp [ GiD_Info postprocess get components_list $res_view $i_res $res_anal $res_step]
	} else {
	    set l_comp {}
	}
	set n_comp [ llength $l_comp]
	if { $n_comp > 1} {
	    if { $::PRDebug} {
		WarnWinText "   2:arbol [ PRToNode $path] [PRToNode $i_res] -text $txt -data nodoinsert end"
	    }
	    $arbol insert end [ PRToNode $path] [ PRToNode $i_res] -text $txt -image [ GetImage prof1.gif] -data nodo
	    if { $i_res != ""} {
		set tmp_comp [ GiD_Info postprocess get components_list $res_view $i_res $res_anal $res_step]
	    } else {
		set tmp_comp {}
	    }
	    foreach comp $tmp_comp {
		regsub -all {_} $comp { } txt
		set txt [= $txt]
		if { $::PRDebug} {
		    WarnWinText "   3:arbol insert end [PRToNode $i_res] [PRToNode \"$i_res->$comp\"] -text $txt -image {GetImage point16x16.gif]} -data [ list hoja $i_res $comp]"
		}
		$arbol insert end [PRToNode $i_res] [PRToNode "$i_res->$comp"] \
		    -text $txt -image [ GetImage point16x16.gif] \
		    -data [ list hoja $i_res $comp]
	    }
	} else {
	    regsub -all {_} $l_comp { } txt
	    set txt [= $txt]
	    if { $::PRDebug} {
		WarnWinText "   4:arbol insert end [ PRToNode $path] [PRToNode \"$i_res->$l_comp\"] -text $txt -image { GetImage point16x16.gif} -data [ list hoja $i_res $l_comp]"
	    }
	    $arbol insert end [ PRToNode $path] [PRToNode "$i_res->$l_comp"] \
		-text $txt -image [ GetImage point16x16.gif] \
		-data [ list hoja $i_res $l_comp]
	}
    }
    if { $::PRDebug} {
	WarnWinText "     done."
    }
}


# for translation:
# to be found by ramtranslator parser to be translated:
# [_ "No Result"]
# [_ "Display Vectors"]
# [_ "Contour Fill"]
# [_ "Smooth Contour Fill"]
# [_ "Contour Lines"]
# [_ "Contour Ranges"]
# [_ "Sh Min Max"]
# [_ "Show Min Max"]
# [_ "Result Surface"]
# [_ "Scalar Line Diagram"]
# [_ "Vector Line Diagram"]


proc FillPRInfo {} {
    global GidPriv

    if { $::PRDebug} {
	WarnWinText FillPRInfo----------------------------
    }

    if { ![info exists GidPriv(PostResultsWindow)] || \
	    ![winfo exists $GidPriv(PostResultsWindow)] } { return }

    if { ![ info exists GidPriv(PRDoingAccept)]} {
	set GidPriv(PRDoingAccept) 0
    }

    if { $GidPriv(PRDoingAccept)} { return}

    set w $GidPriv(PostResultsWindow)

    if { $::PRDebug} {
	WarnWinText "FillPRInfo: getting info"
    }
    set all_analysis_values [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    set curr [ GiD_Info postprocess get cur_analysis]
    if { $all_analysis_values == ""} {
	if { $::PRDebug} {
	    WarnWinText "FillPRInfo: no analysis found."
	}
	$w.rv.m1 configure -values ""
	$w.rv.m2 configure -values ""
	$GidPriv(Result_wid) delete [ $GidPriv(Result_wid) nodes root]
	set GidPriv($GidPriv(Result_wid),cache) ""
	return
    }
    # if { [ lsearch $all_analysis_values $curr] == -1} {
    #         ser curr [ lindex $all_analysis_values end]
    # }
    
    set max_len 0
    $w.rv.m1 configure -values ""   
    set all_analysis_labels {}
    foreach i $all_analysis_values {
	regsub -all {_} $i { } var
	set var [= $var]
	lappend all_analysis_labels $var
	set l [ string length $var]
	if { $l > $max_len} {
	    set max_len $l
	}
    }

    $w.rv.m1 configure -values $all_analysis_values -labels $all_analysis_labels
    if { $max_len > 20} {
	grid configure $w.rv.m1 -sticky ew
    }
    if { $curr == "" } {
	set curr [lindex $all_analysis_values 0]
    }
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: set GidPriv(PostResultsAnal) -$curr-"
    }
    set GidPriv(PostResultsAnal) $curr
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: done"
    }

    # Ahora los Steps:
    set analisis $GidPriv(PostResultsAnal)
    if { $analisis != ""} {
	set current [ GiD_Info postprocess get cur_step $analisis]
	set currentidx 0
	if { [ catch { set all_steps [ GiD_Info postprocess get all_steps $analisis]}]} {
	    set all_steps {}
	}
	set mxw 0
	foreach st $all_steps {
	    if { [ string length $st] > $mxw} {
		set mxw [ string length $st]
	    }
	}
	if { $mxw < 6} { set mxw 6}
	$w.rv.cbstep configure -values $all_steps -width $mxw
	set GidPriv(PostResultsStep) $current
    } else {
	$w.rv.cbstep configure -values ""
    }

    if { [ catch { set all [ GiD_Info postprocess get all_steps $analisis]}]} {
	set all {}
    }
    set curr [ GiD_Info postprocess get cur_step]
    # if { ( $curr == "") || ( [ lsearch $all $curr] == -1)} {
    #         set curr [lindex $all end]
    # }
    if { $curr == ""} {
	set curr [lindex $all end]
    }
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: set GidPriv(PostResultsStep) -$curr-"
    }
    set GidPriv(PostResultsStep) $curr
    if { $::PRDebug} {
	WarnWinText "FillPRInfo: done"
    }


    # Ahora la vista de resultados
    set all_views_values [ GiD_Info postprocess get all_results_views]
    set all_views_labels {}
    foreach j $all_views_values {
	regsub -all {_} $j { } var
	lappend all_views_labels [_ $var]
    }
    $w.rv.m2 configure -values $all_views_values -labels $all_views_labels
    
    set curr [ GiD_Info postprocess get cur_results_view]
    if { $curr == "Iso_Surfaces"} { set curr "No_Result"}
    if { $curr == "" } {
	set curr [ lindex $all_views_values 2]
    }
    set GidPriv(PostResultsView) $curr

    # Ahora los resultados
    set all [ GiD_Info postprocess get cur_results_list $curr ]

    set all [ lsort -dictionary $all]

    if { $all != "" } {        
	PRConstruyeArbol $GidPriv(Result_wid) $all
	set curr [ GiD_Info postprocess get cur_result]
	if { $curr == "" || [lsearch $all $curr] == -1 } {
	    set curr [lindex $all 0] 
	}
	set GidPriv(PostResultsRes) $curr

    } else {
	set GidPriv(PostResultsRes) ""
	PRArbolNoResultado $GidPriv(Result_wid) $GidPriv(PostResultsView)
    }
    focus $GidPriv(Result_wid)

    # y sus componentes
    if { $GidPriv(PostResultsRes) != "" } {
	set curr $GidPriv(PostResultsRes)
	set all [ GiD_Info postprocess get cur_components_list $curr]
	if { $all != "" } {        
	    set curr [ GiD_Info postprocess get cur_component]
	    if { $curr == "" } {
		set curr [lindex $all 0]
	    }
	    set GidPriv(PostResultsComp) $curr
	}
    } else {
	set GidPriv(PostResultsComp) ""
    }

    if { $GidPriv(PostResultsRes) != "" && $GidPriv(PostResultsComp) != ""} {
	set nodo "$GidPriv(PostResultsRes)->$GidPriv(PostResultsComp)"
	regsub -all { } $nodo {_} nodo
	set nodo [PRToNode $nodo]
	set arbol $GidPriv(Result_wid)
	if { $::PRDebug} {
	    WarnWinText "     1:arbol selection set $nodo"
	}
	set err [ catch {
	    $arbol selection set $nodo
	} errTxt ]
	if { !$err} {
	    for { set p $nodo} { $p != "root"} { set p [ $arbol parent $p]} {
		if { $::PRDebug} {
		    WarnWinText "     1:arbol opentree $p"
		}
		$arbol opentree $p
	    }
	} else {
	    if { $::PRDebug} {
		WarnWinText "ERROR ( $arbol selection set $nodo) \n\t--> $errTxt"
	    }
	}
	focus $arbol
    }

    if { ( $GidPriv(PostResultsView) != "Display_Vectors") && \
	    ( $GidPriv(PostResultsView) != "Result_Surface") && \
	    ( $GidPriv(PostResultsView) != "Scalar_Line_Diagram") && \
	    ( $GidPriv(PostResultsView) != "Vector_Line_Diagram") } {
	#$w.rv.f.e2 del 0 end
	$w.rv.f.e2 configure -foreground grey60
	$w.rv.f.e2 configure -state disabled
	$w.rv.f.l6 configure -foreground grey60
    }
}

proc FillPRSteps {name1 name2 op} {
    global GidPriv

    if { $::PRDebug} {
	WarnWinText "FillPRSteps---------------------- $name1 $name2"
    }
    set w $GidPriv(PostResultsWindow)
    set analisis $GidPriv(PostResultsAnal)
    if { $::PRDebug} {
	WarnWinText "FillPRSteps: analisis = '$analisis'"
    }
    if { $analisis != ""} {
	if { [ catch { set all [ GiD_Info postprocess get all_steps $analisis]}]} {
	    set all {}
	}
	set current [ GiD_Info postprocess get cur_step $analisis]

	if { $current == "" || [ lsearch $all $current] == -1 } {
	    set current [lindex $all 0]
	}
	set mxw 0
	foreach st $all {
	    if { [ string length $st] > $mxw} {
		set mxw [ string length $st]
	    }
	}
	if { $mxw < 6} { set mxw 6}
	$w.rv.cbstep configure -values $all -width $mxw
	if { $::PRDebug} {
	    WarnWinText "FillPRSteps: set GidPriv(PostResultsStep) -$current-"
	}
	set GidPriv(PostResultsStep) $current
    } else {
	$w.rv.cbstep configure -values ""
    }
}

proc PRChangedStep {name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostResultsWindow)
    if { $::PRDebug} {
      WarnWinText "paso cambiado: '$GidPriv(PostResultsStep)'"
    }
    if {  $GidPriv(PostResultsStep) == ""} { return }
    # # para que rehaga el menu
    # set GidPriv(PostResultsRes) ""
    FillPROtherMenusLazy $name1 $name2 $op
    #PRAccept
    return
}

proc FillPROtherMenus {name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostResultsWindow)
    
    #puts FillPROtherMenus-----------------------------
    if { $::PRDebug} {
	WarnWinText "FillPROtherMenus----------------- $name1 $name2 $op"
    }
    set vn {PostResultsStep PostResultsView PostResultsRes PostResultsComp}
    set i [lsearch $vn $name2]   
    
    switch $i {
	0 {
	    set all [ GiD_Info postprocess get all_results_views]
	    set curr [ GiD_Info postprocess get cur_results_view]
	    if { $curr == "Iso_Surfaces"} { set curr "No_Result"}
	}
	1 {
	    if { $::PRDebug} {
		WarnWinText "1 FillPROtherMenus: $GidPriv(PostResultsView)"
	    }
	    if { $GidPriv(PostResultsView) == "" } {
		set all ""
		set curr ""
	    } else {
		set res_view $GidPriv(PostResultsView)                
		set res_anal $GidPriv(PostResultsAnal)
		if { ( $res_view == "" ) || ( $res_anal == "") } {
		    set all ""
		    set curr ""
		} else {
		    if { [catch { set all [ GiD_Info postprocess get results_list $res_view $res_anal $GidPriv(PostResultsStep)] } err] } {
		        set all ""
		    }
	      
		    
		    set all [ lsort -dictionary $all]
		    
		    if { $::PRDebug} {
		        WarnWinText "$res_view -> $all"
		    }
		    
		    set curr [ GiD_Info postprocess get cur_result]
		    if { $curr == "" || [ lsearch -exact $all $curr] == -1 } {
		        set curr [lindex $all 0]
		    }
		    set res_res $GidPriv(PostResultsRes)
		    set res_comp $GidPriv(PostResultsComp)
		    if { [ lsearch -exact $all $res_res] == -1} {
		        set res_res [ lindex $all 0]
		        if { $res_res != ""} {
		            set all_comp [ GiD_Info postprocess get components_list \
		                    $res_view $res_res $res_anal $GidPriv(PostResultsStep)]
		            set res_comp [ lindex $all_comp 0]
		        } else {
		            set all_comp {}
		            set res_comp {}
		        }
		    }
		    if { $res_view == "Display_Vectors" } {
		        $w.rv.f.e2 configure -state normal
		        $w.rv.f.e2 configure -foreground black
		        $w.rv.f.l6 configure -foreground black
		        if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		            #WarnWin "1 - -$res_view-$res_res-$res_anal-$GidPriv(PostResultsStep)-"
		            set kk  [ GiD_Info postprocess get cur_vector_factor \
		                    $res_view $res_res $res_anal $GidPriv(PostResultsStep) ]
		            if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact)} {
		                set kk $GidPriv(PostResultsVfact)
		            }
		            if { $::PRDebug} {
		                WarnWinText "1: -$kk-$GidPriv(PostResultsVfact)"
		            }		          
		            if { $kk != 0} {
		                $w.rv.f.e2 del 0 end
		                $w.rv.f.e2 ins end $kk
		                if { $::PRDebug} {
		                    WarnWinText "      entry = [ $w.rv.f.e2 get]"
		                }
		            }
		            focus $w.rv.f.e2
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		            focus $w.rv.f.e2
		        }
		    } elseif { ( $res_view == "Scalar_Line_Diagram") || \
		        ( $res_view == "Vector_Line_Diagram") } {
		        $w.rv.f.e2 configure -state normal
		        $w.rv.f.e2 configure -foreground black
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.l6 configure -foreground black
		        if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		            if { ( $res_view == "Scalar_Line_Diagram") && ( $res_comp != "")} {
		                set kk  [ GiD_Info postprocess get cur_diagram_factor $res_res $res_comp $res_anal $GidPriv(PostResultsStep)]
		            } else {
		                set kk  [ GiD_Info postprocess get cur_diagram_factor $res_res $res_anal $GidPriv(PostResultsStep)]
		            }
		            if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact)} {
		                set kk $GidPriv(PostResultsVfact)
		            }
		            if { $kk != 0 } {
		                $w.rv.f.e2 del 0 end
		                $w.rv.f.e2 ins end $kk
		            }
		            focus $w.rv.f.e2
		        } else {
		            $w.rv.f.e2 ins end "1.0"
		            focus $w.rv.f.e2
		        }
		    } elseif { $res_view == "Result_Surface" } {
		        $w.rv.f.e2 configure -state normal
		        $w.rv.f.e2 configure -foreground black
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.l6 configure -foreground black
		        if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		            ( $GidPriv(PostResultsStep) != "") } {
		            if { $::PRDebug} {
		                WarnWinText "1 - -$res_view-$res_res-$res_comp-$res_anal-$GidPriv(PostResultsStep)-"
		            }
		            set kk  [ GiD_Info postprocess get cur_result_surface_factor \
		                    $res_view $res_res $res_comp $res_anal $GidPriv(PostResultsStep) ]
		            if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact)} {
		                set kk $GidPriv(PostResultsVfact)
		            }
		            if { $kk != 0 } {
		                $w.rv.f.e2 del 0 end
		                $w.rv.f.e2 ins end $kk
		            }
		            focus $w.rv.f.e2
		        } else {
		            $w.rv.f.e2 ins end "1.0"
		            focus $w.rv.f.e2
		        }
		    } else {
		        #$w.rv.f.e2 del 0 end
		        $w.rv.f.e2 configure -foreground grey60 -state disabled
		        $w.rv.f.l6 configure -foreground grey60
		    }
		}
	    }
	}
	2 {
	    if { $GidPriv(PostResultsView) == "" } {
		set all ""
		set curr ""
	    } else {
		
		set res_view $GidPriv(PostResultsView)
		set res_res $GidPriv(PostResultsRes)
		set res_anal $GidPriv(PostResultsAnal)
		if { $res_res != ""} {
		    if { [catch { set all [ GiD_Info postprocess get components_list $res_view $res_res $res_anal $GidPriv(PostResultsStep)] } err] } {
		        set all ""
		    }
		    set curr [ GiD_Info postprocess get cur_component]
		} else {
		    set all {}
		    set curr {}
		}

		if { $curr == "" || [ lsearch -exact $all $curr] == -1 } {
		    set curr [lindex $all 0]
		}
		if { $res_view == "Display_Vectors" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		        ( $GidPriv(PostResultsStep) != "") } {
		        if { $::PRDebug} {
		            WarnWinText "2 --$res_view-$res_res-$curr-$res_anal-$GidPriv(PostResultsStep)-"
		        }
		        set kk  [ GiD_Info postprocess get cur_vector_factor \
		                $res_view $res_res $curr $res_anal $GidPriv(PostResultsStep) ]
		        if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact) } {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $::PRDebug} {
		            WarnWinText "2: -$kk-$GidPriv(PostResultsVfact)"
		        }                       
		        if { $kk != 0} {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end $kk
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
		if { ( $res_view == "Scalar_Line_Diagram") || \
		    ( $res_view == "Vector_Line_Diagram") } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		        ( $GidPriv(PostResultsStep) != "") } {
		        if { ( $res_view == "Scalar_Line_Diagram") && ( $curr != "")} {
		            set kk  [ GiD_Info postprocess get cur_diagram_factor $res_res $curr $res_anal $GidPriv(PostResultsStep)]
		        } else {
		            set kk  [ GiD_Info postprocess get cur_diagram_factor $res_res $res_anal $GidPriv(PostResultsStep)]
		        }
		        #WarnWin "'$res_res' '$curr' '$res_anal' '$GidPriv(PostResultsStep)' -> '$kk'"
		        if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact) } {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end $kk
		        }
		    } else {
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.e2 ins end "1.0"
		    }
		}
		if { $res_view == "Result_Surface" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		        ( $GidPriv(PostResultsStep) != "") } {
		        if { $::PRDebug} {
		            WarnWinText "2 --$res_view-$res_res-$curr-$res_anal-$GidPriv(PostResultsStep)-$GidPriv(PostResultsComp)"
		        }
		        set kk  [ GiD_Info postprocess get cur_result_surface_factor \
		                $res_view $res_res $curr $res_anal $GidPriv(PostResultsStep) ]
		        if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact) } {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end $kk
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
	    }
	}
	3 {
	    if { $GidPriv(PostResultsView) == "" } {
		set all ""
		set curr ""
	    } else {                
		set res_view $GidPriv(PostResultsView)               
		set res_res $GidPriv(PostResultsRes)
		set res_comp $GidPriv(PostResultsComp)
		set res_anal $GidPriv(PostResultsAnal)
		if { $res_res != ""} {                    
		    if { [catch { set all [ GiD_Info postprocess get components_list $res_view $res_res $res_anal $GidPriv(PostResultsStep)] } err] } {
		        set all ""
		    }                                       
		    set curr [ GiD_Info postprocess get cur_component]
		} else {
		    set all {}
		    set curr {}
		}

		if { $curr == "" || [ lsearch -exact $all $curr] == -1 } {
		    set curr [lindex $all 0]
		}
		if { $res_view == "Display_Vectors" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		        ( $GidPriv(PostResultsStep) != "") } {
		        #WarnWin "3 -$res_view-$res_res-$res_comp-$res_anal-$GidPriv(PostResultsStep)-"
		        set kk  [ GiD_Info postprocess get cur_vector_factor \
		                $res_view $res_res $res_comp $res_anal $GidPriv(PostResultsStep) ]
		        if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact) } {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $::PRDebug} {
		            WarnWinText "3: -$kk-$GidPriv(PostResultsVfact)"
		        }
		        if { $kk != 0} {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end $kk
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
		if { ( $res_view == "Scalar_Line_Diagram") || \
		    ( $res_view == "Vector_Line_Diagram") } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		        ( $GidPriv(PostResultsStep) != "") } {
		        if { ( $res_view == "Scalar_Line_Diagram") && ( $res_comp != "")} {
		            set kk  [ GiD_Info postprocess get cur_diagram_factor $res_res $res_comp $res_anal $GidPriv(PostResultsStep)]
		        } else {
		            set kk  [ GiD_Info postprocess get cur_diagram_factor $res_res $res_anal $GidPriv(PostResultsStep)]
		        }
		        #WarnWin "'$res_res' '$res_comp' '$res_anal' '$GidPriv(PostResultsStep)' -> '$kk'"
		        if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact) } {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end $kk
		        }
		    } else {
		        $w.rv.f.e2 del 0 end
		        $w.rv.f.e2 ins end "1.0"
		    }
		}
		if { $res_view == "Result_Surface" } {
		    if { ( $res_res != "") && ( $res_anal != "") && ( $res_view != "") && \
		        ( $GidPriv(PostResultsStep) != "") } {
		        #WarnWin "3 -$res_view-$res_res-$res_comp-$res_anal-$GidPriv(PostResultsStep)-"
		        set kk  [ GiD_Info postprocess get cur_result_surface_factor \
		                $res_view $res_res $res_comp $res_anal $GidPriv(PostResultsStep) ]
		        if { $GidPriv(PostResultsVfact) != "" && $kk == $GidPriv(PostResultsVfact) } {
		            set kk $GidPriv(PostResultsVfact)
		        }
		        if { $kk != 0 } {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end $kk
		        } else {
		            $w.rv.f.e2 del 0 end
		            $w.rv.f.e2 ins end "1.0"
		        }
		    }
		}
	    }
	}
    }

    if { [lindex $vn [expr $i+1]] != ""} {
	if { $::PRDebug} {
	    WarnWinText "[lindex $vn [expr $i+1]] - $curr - -->"
	    # WarnWinText "[lindex $vn [expr $i+1]] - $curr - $GidPriv([lindex $vn [expr $i+1]])"
	}
	       
	#PostResultsStep PostResultsView PostResultsRes PostResultsComp

	if { $name2 == "PostResultsStep" } {            
	    set labels {}
	    foreach j $all {
		regsub -all {_} $j { } var
		lappend labels $var
	    }
	    $w.rv.m2 configure -values $all -labels $labels
	} elseif { $name2 == "PostResultsView" } {
	    if { $::PRDebug} {
		WarnWinText "Contruyendo arbol $GidPriv(Result_wid) -> $all"
	    }
	    #$GidPriv(Result_wid) delete [ $GidPriv(Result_wid) nodes root]            
	    if { $all != ""} {
		PRConstruyeArbol $GidPriv(Result_wid) $all
	    } else {
		PRArbolNoResultado $GidPriv(Result_wid) $GidPriv(PostResultsView)
	    }         
	    set arbol $GidPriv(Result_wid)
	} else {
#             if { $::PRDebug} {
#                 WarnWinText "Contruyendo resto $m -> $all"
#             }
	}
	if { $::PRDebug} {
	    WarnWinText "construyendo -> done"
	}
	if { [lindex $vn [expr $i+1]] == "PostResultsView"} {
	    # set curr $GidPriv(PostResultsViewTrad,$curr)
	}
	if { $::PRDebug} {
	    WarnWinText "set GidPriv([lindex $vn [expr $i+1]]) $curr"
	}
	set GidPriv([lindex $vn [expr $i+1]]) $curr
	
	if { $GidPriv(Result_actualizar)  && \
	    $GidPriv(PostResultsRes) != "" && $GidPriv(PostResultsComp) != ""} {
	    set nodo "$GidPriv(PostResultsRes)->$GidPriv(PostResultsComp)"
	    regsub -all { } $nodo {_} nodo
	    catch {
		set arbol $GidPriv(Result_wid)
		if { $::PRDebug} {
		    WarnWinText "     2:arbol selection set $nodo"
		}
		$arbol selection set $nodo
		for { set p $nodo} { $p != "root"} { set p [ $arbol parent $p]} {
		    if { $::PRDebug} {
		        WarnWinText "     2:arbol opentree $p"
		    }
		    $arbol opentree $p
		}
	    }
	}
	
    }
    
    after idle "focus $GidPriv(Result_wid)"
}

proc FillPROtherMenusLazy { name1 name2 op} {
    global GidPriv
    set w $GidPriv(PostResultsWindow)
	
    set res_view $GidPriv(PostResultsView)
    set res_anal $GidPriv(PostResultsAnal)
    if { $::PRDebug} {
	WarnWinText "Lazy 1: '$res_view' $res_anal"
    }
    if { $res_view == "" } {
	FillPROtherMenus $name1 $name2 $op
	return
    }

    if { [catch { set all [ GiD_Info postprocess get results_list $res_view $res_anal $GidPriv(PostResultsStep)] } err] } {
	set all ""
    }
    set res_res $GidPriv(PostResultsRes)

    if { $::PRDebug} {
	WarnWinText "Lazy 2: $res_view $res_anal $GidPriv(PostResultsStep) '$res_res'"
    }
    if { $res_res == "" } {
	#FillPROtherMenus $name1 $name2 $op
	FillPROtherMenus  GidPriv PostResultsView $op
	return
    }

    if { [ lsearch $all $res_res] == -1 } {
	if { $::PRDebug} {
	    WarnWinText "Lazy 3: $res_view $res_anal $GidPriv(PostResultsStep) $res_res"
	}
	# FillPROtherMenus $name1 $name2 $op
	# decimos que queremos otra vez el c.fill para que nos escoja el primero de la lista
	FillPROtherMenus GidPriv PostResultsView $op
	return
    } else {
	if { $res_res != ""} {
	    set all [ GiD_Info postprocess get components_list $res_view $res_res $res_anal $GidPriv(PostResultsStep)]
	} else {
	    set all {}
	}
	set res_comp $GidPriv(PostResultsComp)
	if { $::PRDebug} {
	    WarnWinText "Lazy 4: $res_view $res_anal $GidPriv(PostResultsStep) $res_res $res_comp"
	}
	if { [ lsearch $all $res_comp] == -1 } {
	    if { $::PRDebug} {
		WarnWinText "Lazy 5: $res_view $res_anal $GidPriv(PostResultsStep) $res_res $res_comp"
	    }
	    #FillPROtherMenus $name1 $name2 $op
	    # decimos que queremos otra vez el c.fill para que nos escoja el primero de la lista
	    FillPROtherMenus GidPriv PostResultsView $op
	    return
	}
    }
}

proc PRAccept {} {
    global GidPriv

    set w $GidPriv(PostResultsWindow)

    if { ![ VerificaReal [_ "Vector factor"]: $GidPriv(PostResultsVfact) $w]} {
	set res_anal $GidPriv(PostResultsAnal)
	set res_step $GidPriv(PostResultsStep)
	set res_res $GidPriv(PostResultsRes)
	set res_comp $GidPriv(PostResultsComp)
	set GidPriv(PostResultsVfact) [ GiD_Info postprocess get cur_vector_factor \
		Display_Vectors $res_res $res_anal $GidPriv(PostResultsStep) ]
	return
    }
    

    set res_view $GidPriv(PostResultsView)
    
    set quitar_resultado 0
    if { $res_view == "No_Result"} {
	set quitar_resultado 1
    }
    if { !$quitar_resultado && [$GidPriv(Result_wid) selection get] == "" } {
	return
    }

    set GidPriv(PRDoingAccept) 1
    if { !$quitar_resultado} {
	set entry_fact $GidPriv(PostResultsVfact)
	PRSeleccionResultado [$GidPriv(Result_wid) selection get]
	set GidPriv(PostResultsVfact) $entry_fact
    }

    #puts PRAccept---------------------------
    set oldAutomaticRedraw [ GiD_Set AutomaticRedraw]
    GiD_Set AutomaticRedraw -1

    set res_anal $GidPriv(PostResultsAnal) 
    set res_step $GidPriv(PostResultsStep)
    set postcmd "escape escape escape escape escape escape results analysissel $res_anal $res_step"
    regsub -all {_} $GidPriv(PostResultsView) {} resviewcmd 
    
    if { $res_view == "No_Result"} {
	set postcmd "$postcmd geometry $resviewcmd"
    } else {
	set res_res $GidPriv(PostResultsRes)
	set res_comp $GidPriv(PostResultsComp)
	if { ( $res_view != "Scalar_Line_Diagram") && \
		( $res_view != "Vector_Line_Diagram") } {
	    set postcmd "$postcmd $resviewcmd"
	    set postcmd "$postcmd $res_res"
	    set postcmd "$postcmd $res_comp"
	    if { $res_view == "Display_Vectors" } {
		if { $GidPriv(PostResultsVfact) != ""} {
		    set postcmd "$postcmd $GidPriv(PostResultsVfact)"
		}
	    }
	    if { $res_view == "Result_Surface" } {
		if { $GidPriv(PostResultsVfact) != ""} {
		    set postcmd "$postcmd $GidPriv(PostResultsVfact)"
		}
	    }
	} else {
	    if { $res_view == "Scalar_Line_Diagram"} {
		set postcmd "$postcmd linediagram scalardiagram $res_res $res_comp $GidPriv(PostResultsVfact)"
	    } else {
		set postcmd "$postcmd linediagram vectordiagram $res_res $GidPriv(PostResultsVfact)"
	    }
	}
    }
    GiD_Process {*}$postcmd

    # lo separamos por si lo de arriba da un error
    GiD_Set AutomaticRedraw $oldAutomaticRedraw

    .central.s render


    set GidPriv(PRDoingAccept) 0
}

proc PRSeleccionResultado { nodo} {
    global GidPriv

    if { $nodo == ""} { return}
    set arbol $GidPriv(Result_wid)
    set datos [ $arbol itemcget $nodo -data]
    if { $::PRDebug} {
	WarnWinText "$nodo - [ $arbol itemcget $nodo -data]"
    }
    if { [lindex $datos 0] == "hoja"} {
	set res_name [ lindex $datos 1]
	set res_comp [ lindex $datos 2]
	$arbol selection set $nodo
	set GidPriv(Result_actualizar) 0
	set GidPriv(PostResultsRes) $res_name
	set GidPriv(PostResultsComp) $res_comp
	set GidPriv(Result_actualizar) 1
    } else {
	if { [ $arbol itemcget $nodo -open] } {
	    $arbol closetree $nodo
	} else {
	    for { set p $nodo} { $p != "root"} { set p [ $arbol parent $p]} {
		$arbol opentree $p
	    }
	}
    }
    $arbol see $nodo
}

proc PRDoApply { nodo} {
    global GidPriv
    if { $nodo == ""} { return}
    set arbol $GidPriv(Result_wid)
    set datos [ $arbol itemcget $nodo -data]
    if { $::PRDebug} {
	WarnWinText "$nodo - [ $arbol itemcget $nodo -data]"
    }
    if { "[ lindex $datos 0]" == "hoja"} {
	PRAccept
    }
}

#proc PRAbrirCerrarArbol { nodo} {
#    global GidPriv
#
#    set arbol $GidPriv(Result_wid)
#    if { [ $arbol itemcget $nodo -open] } {
#         $arbol closetree $nodo
#    } else {
#         for { set p $nodo} { $p != "root"} { set p [ $arbol parent $p]} {
#             $arbol opentree $p
#         }
#    }
#}

proc PostResultsDeleteTraceVariables { w_evento w_padre} {
    if { $w_evento == $w_padre} {
	trace remove variable ::GidPriv(PostResultsAnal) write FillPRSteps
	####trace remove variable ::GidPriv(PostResultsStep) write PRChangedEntry
	trace remove variable ::GidPriv(PostResultsStep) write PRChangedStep
	trace remove variable ::GidPriv(PostResultsView) write FillPROtherMenus
	trace remove variable ::GidPriv(PostResultsRes) write FillPROtherMenus
	trace remove variable ::GidPriv(PostResultsComp) write FillPROtherMenus
	if { $::PRDebug} {
	    WarnWinText "PRDeleteTraceVariables"
	}
    }
}

proc PostResultsSetTraceVariables { } {
    trace add variable ::GidPriv(PostResultsAnal) write FillPRSteps
    ####trace add variable ::GidPriv(PostResultsStep) write PRChangedEntry
    trace add variable ::GidPriv(PostResultsStep) write PRChangedStep
    trace add variable ::GidPriv(PostResultsView) write FillPROtherMenus
    trace add variable ::GidPriv(PostResultsRes) write FillPROtherMenus
    trace add variable ::GidPriv(PostResultsComp) write FillPROtherMenus
    if { $::PRDebug} {
	WarnWinText "PRSetTraceVariables"
    }
}


proc PostResultsSetResultsView { nueva_vista} {
    global GidPriv
    if { $nueva_vista != ""} {
	set GidPriv(PostResultsView) $nueva_vista
    }
}

proc PostResults { { w .gid.wPostResults } { inside 0} } {
    global GidPriv

    #puts PostResults----------------------------
    if { !$inside} {
	InitWindow $w [_ "View Results"] PostResultsWindowGeom PostResults
	if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    } else {
	set GidPriv(PostResultsWindow) $w
    }

    set color_fondo [ CCGetRGB $w [ $w cget -background]]
    set color_sel [ CCColorSombra $color_fondo 65]

    if { !$inside} {
	frame $w.rv -relief ridge -bd 2
    } else {
	frame $w.rv -bd 0
    }

    label $w.rv.l2 -text [_ "View"]:
    TTKComboBox $w.rv.m2 -textvariable ::GidPriv(PostResultsView) \
	-width 20 -state readonly

    label $w.rv.l1 -text [_ "Analysis"]:
    TTKComboBox $w.rv.m1 -textvariable ::GidPriv(PostResultsAnal) \
	-width 20 -state readonly

    label $w.rv.lstep -text [_ "Step"]:
    TTKComboBox $w.rv.cbstep -textvariable ::GidPriv(PostResultsStep) \
	-width 8 -state readonly

    label $w.rv.lres -text [_ "Results"]:

    set sw1 [ ScrolledWindow $w.rv.rtsw -relief sunken -bd 1 -auto both]
    set tree1 [ Tree $sw1.tree -relief flat -borderwidth 0 \
		    -highlightthickness 0 -selectbackground "darkblue" \
		    -selectforeground yellow \
		    -highlightbackground yellow -width 30 -redraw 1]

    set GidPriv(Result_wid) $tree1
    set GidPriv(Result_actualizar) 1

    $tree1 bindImage <Control-1> {}
    $tree1 bindText <Control-1> {}
    $tree1 bindText <Double-Button-1> PRDoApply
    $tree1 bindImage <1> "focus $sw1.tree; PRSeleccionResultado"
    $tree1 bindText <1> "focus $sw1.tree; PRSeleccionResultado"

    $sw1 setwidget $tree1


    frame $w.rv.f
    label $w.rv.f.l6 -text [_ "factor"]:
    entry $w.rv.f.e2 -relief sunken -width 12 -bd 1 -textvariable GidPriv(PostResultsVfact)
    pack $w.rv.f.l6 $w.rv.f.e2 -side left

    if { !$inside} {
	frame $w.but -bd 0 -background [ CCColorActivo $color_fondo]
	button $w.but.accept -text [_ "Apply"] -command PRAccept -takefocus 0 -bd 1
	button $w.but.close -text [_ "Close"] -command "destroy $w" -takefocus 0 -bd 1
	SetWidgetsWidthFromText $w.but.accept $w.but.close
	grid $w.but.accept $w.but.close -pady 6 -padx 5 -sticky ews
    }

    grid $w.rv.l2 -sticky e -row 0 -column 0 -padx 2 -pady 1
    grid $w.rv.m2 -sticky w -row 0 -column 1 -padx 2 -pady 1
    grid $w.rv.l1 -sticky e -row 1 -column 0 -padx 2 -pady 1
    grid $w.rv.m1 -sticky w -row 1 -column 1 -padx 2 -pady 1
    grid $w.rv.lstep -sticky w -row 0 -column 2 -padx 2 -pady 1
    grid $w.rv.cbstep -sticky e -row 1 -column 2 -padx 2 -pady 1
    grid $sw1 -sticky news -row 2 -column 0 -columnspan 3 -padx 2 -pady 1
    grid $w.rv.f -sticky w -row 4 -column 0 -columnspan 3 -padx 2 -pady 1
    grid columnconfigure $w.rv 1 -weight 1
    grid rowconfigure $w.rv 2 -weight 1

    if { !$inside} {
	grid $w.rv -sticky nsew
	grid $w.but -sticky sew
	if { $::tcl_version >= 8.5 } { grid anchor $w.but center }
    } else {
	grid $w.rv -sticky nsew -padx 4 -pady 8
    }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1


    FillPRInfo

    if { !$inside} {
	#bind $w <Return> "tkButtonInvoke $w.but.accept"
	bind $w <Alt-c> "tkButtonInvoke $w.but.close"
	bind $w <Escape> "tkButtonInvoke $w.but.close"
    }
    bind $w <Destroy> "+ PostResultsDeleteTraceVariables %W $w"
    
    PostResultsSetTraceVariables    
}

proc FillPostLegendInfo { } {
    global GIDDEFAULT PLegendPriv GidPriv

    if { ![ info exists GidPriv(PostLegendWindow)] || ![ winfo exists $GidPriv(PostLegendWindow)]} {
	return
    }
    set w $GidPriv(PostLegendWindow)
    #$PLegendPriv(w)

    set lst_colores [ GiD_Info postprocess get current_color_scale]
	
    set lst_info [ GiD_Info postprocess get info_legend]

    if { $lst_colores == "" || $lst_info == "" } {
	$PLegendPriv(CanvasLabel) configure -text {}
	$PLegendPriv(Canvas) del all
	return
    }

    #WarnWin $lst_info

    set cv $PLegendPriv(Canvas)

    $PLegendPriv(CanvasLabel) configure -text {}
    $cv del all

    set que_res [ lindex $lst_info 0]

    if { $que_res == "" || $que_res == "NOTHING" } {
	$PLegendPriv(CanvasLabel) configure -text {}
	$PLegendPriv(Canvas) del all
	return
    }

    if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" || \
	     $que_res == "CONTOUR_LINES" || $que_res == "CONTOUR_RANGES" || \
	     $que_res == "VECTORS" || $que_res == "ISO_SURFACES" } {
	#set label_txt [ lindex $lst_info 1]
	regsub -all {_} [ lindex $lst_info 1] { } label_txt
	$PLegendPriv(CanvasLabel) configure -text [= $label_txt]
	
	if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" } {
	    set n_info [ expr [ lindex $lst_info 2] + 1]
	} else {
	    set n_info [ lindex $lst_info 2]
	}
	set entradas [ lindex $lst_info 3]
	
	set n_col [ lindex $lst_colores 0]
	if {  ( $n_col > 0) && ( $n_info > 0)} {
	    # ajustamos parametros escala de color
	    set margen_h 12.0
	    set margen_w 8.0
	    set max_v [ expr $PLegendPriv(CanvasHeight) - 2.0 * $margen_h]
	    set incr_col 1.0
	
	    if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" || \
		     $que_res == "ISO_SURFACES" || $que_res == "CONTOUR_RANGES" } {
		set npix [ expr $max_v / $n_col]
	    } else {
		set npix [ expr $max_v / [ expr $n_col - 1]]
	    }
	    if { $npix < 1.0} {
		set npix 1.0
		if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" || \
			 $que_res == "ISO_SURFACES" || $que_res == "CONTOUR_RANGES"} {
		    set incr_col [ expr $n_col / $max_v]
		} else {
		    set incr_col [ expr [ expr $n_col - 1] / $max_v]
		}
	    }

	    set xi $margen_w
	    set xo [ expr $xi + 16.0]
	    set yi $margen_h
	    if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" || \
		     $que_res == "ISO_SURFACES" || $que_res == "CONTOUR_RANGES"} {
		set yo [ expr $yi + $npix]
	    } else {
		set yo $yi
	    }

	    if { $que_res != "CONTOUR_RANGES" } {
		set alto_linea [ font metrics FixedFont -linespace]
		set num_lin [ expr round( $max_v / $alto_linea)]
	    } else {
		set num_lin $n_info
	    }
	    if { $num_lin < 1.0} { set num_lin 1.0}
	    #ajustamos parametros entradas de texto
	    set incr_idx_txt 1.0
	    if { $n_info > [ expr $num_lin + 1]} {
		if { $num_lin < 2.0} { set num_lin 2.0}
		set incr_idx_txt [ expr ( $n_info - 1.0) / ( $num_lin - 1.0)]
		set n_txt [ expr $num_lin - 1]
		set tmp ""
		lappend tmp [ format %.5g [ lindex $entradas 0]]
		set div [ expr ( [ lindex $entradas [ expr $n_info - 1]] - [ lindex $entradas 0]) / ( $num_lin - 1.0)]
		for { set i 1} { $i < $n_txt} { incr i} {
		    lappend tmp [ format %.5g [ expr [ lindex $tmp [ expr $i - 1]] + $div]]
		}
		lappend tmp [ format %.5g [ lindex $entradas [ expr $n_info - 1]]]
		set entradas $tmp
		#WarnWin "[ llength $entradas] - $entradas"
	    } else {
		#WarnWin "$n_info - $entradas"
		set n_txt [ expr $n_info - 1]
		if { $que_res != "CONTOUR_RANGES" } {
		    set tmp ""
		    for { set i 0} { $i <= $n_txt} { incr i} {
		        lappend tmp [ format %.5g [ lindex $entradas $i]]
		    }
		    set entradas $tmp
		}
	    }

	    # chapuza para alinear for la izquierda
	    set ll 0
	    set px 0.0
	    foreach i $entradas {
		set il [ string length $i]
		if { $il > $ll} { set ll $il}
		set ix [ font measure FixedFont $i]
		if { $ix > $px} { set px $ix}
	    }
	    set tmp ""
	    foreach i $entradas {
		lappend tmp [ format %-${ll}s $i]
	    }
	    set entradas $tmp

	    if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" || \
		     $que_res == "CONTOUR_LINES" || $que_res == "VECTORS" } {
		set ntpix [ expr $max_v / $n_txt]
	    } else {
		set ntpix [ expr $max_v / ( $n_txt + 1.0)]
	    }
	    set txi_linea $xo
	    set txo_linea [ expr $txi_linea + 4.0]
	    # fallo del canvas, el texto lo alinea centrado, ponga lo que se ponga
	    #set txi_texto [ expr $txo_linea + 4.0]
	    #set txi_texto [ expr ( $PLegendPriv(CanvasWidth) - $txo_linea) / 3.0 + $txo_linea]
	    set txi_texto [ expr $txo_linea + 2.0 + $px / 2.0]
	    set tyi_linea $yi
	    set tyo_linea $yi
	    # como es centered, no hace falta esto:
	    #set tyi_texto [ expr $yi + 3.0]
	    if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" || \
		    $que_res == "CONTOUR_LINES" || $que_res == "VECTORS" } {
		set tyi_texto $yi
	    } else {
		set tyi_texto [ expr $yi + $ntpix * 0.5]
	    }


	    set x_sep [ expr $PLegendPriv(CanvasWidth) / 3.0]
	    $cv create line [ expr round( $x_sep)] 1 [ expr round( $x_sep + $x_sep)] 1 -fill black
	    if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" || \
		     $que_res == "CONTOUR_RANGES" || $que_res == "ISO_SURFACES"} {
		for { set i 1.0} { [ expr round( $i)] <= $n_col} { set i [ expr $i + $incr_col]} {
		    $cv create rectangle [ expr round( $xi)] [ expr $PLegendPriv(CanvasHeight) - round( $yi)] \
		            [ expr round( $xo)] [ expr $PLegendPriv(CanvasHeight) - round( $yo)] \
		            -fill [ lindex $lst_colores [ expr round( $i)]] -outline ""
		    set yi [ expr $yi + $npix]
		    set yo [ expr $yo + $npix]
		}
	    } else {
		for { set i 1.0} { [ expr round( $i)] <= $n_col} { set i [ expr $i + $incr_col]} {
		    $cv create line [ expr round( $xi)] [ expr $PLegendPriv(CanvasHeight) - round( $yi)] \
		            [ expr round( $xo)] [ expr $PLegendPriv(CanvasHeight) - round( $yo)] \
		            -fill [ lindex $lst_colores [ expr round( $i)]]
		    set yi [ expr $yi + $npix]
		    set yo [ expr $yo + $npix]
		}
	    }

	    #set itexto 0.0
	    for { set i 0} { $i <= $n_txt} { incr i} {
		#WarnWin "$i - $itexto - $n_txt"
		if { $que_res == "CONTOUR_FILL" || $que_res == "SMOOTH_CONTOUR_FILL" } {
		    $cv create line [ expr round( $txi_linea)] \
		            [ expr $PLegendPriv(CanvasHeight) - round( $tyi_linea)] \
		            [ expr round( $txo_linea)] \
		            [ expr $PLegendPriv(CanvasHeight) - round( $tyo_linea)] -fill black
		}
		$cv create text [ expr round( $txi_texto)] \
		        [ expr $PLegendPriv(CanvasHeight) - round( $tyi_texto)] \
		        -fill black -text [ lindex $entradas $i] -font FixedFont
		#[ lindex $entradas [ expr round( $itexto)]]
		set tyi_linea [ expr $tyi_linea + $ntpix]
		set tyo_linea [ expr $tyo_linea + $ntpix]
		set tyi_texto [ expr $tyi_texto + $ntpix]
		#set itexto [ expr $itexto + $incr_idx_txt]
	    }
	}
    } else {
	# no es contour_fill ni contour_lines ni iso_surfaces
	if { $que_res == "LOCAL_AXES" } {
	    set label_txt [ lindex $lst_info 1]
	    $PLegendPriv(CanvasLabel) configure -text $label_txt

	    if { ![ info exists PLegendPriv(ImagenEjesLocales)]} {
		set PLegendPriv(ImagenEjesLocales) [ image create photo -file $GIDDEFAULT/bitmaps/localaxes.gif]
	    }

	    $cv create image [ expr $PLegendPriv(CanvasWidth) / 2] [ expr $PLegendPriv(CanvasHeight) / 2]\
		    -anchor center -image $PLegendPriv(ImagenEjesLocales)
	}
    }

}

proc PostLegendResizeCanvas { width height } {
    global GIDDEFAULT PLegendPriv GidPriv

    set PLegendPriv(CanvasWidth) [ expr $width - 10]
    set PLegendPriv(CanvasHeight) [ expr $height - 10 - [ winfo reqheight $PLegendPriv(CanvasLabel)] - 4]
    $PLegendPriv(Canvas) configure -width $PLegendPriv(CanvasWidth) -height $PLegendPriv(CanvasHeight)

    FillPostLegendInfo
}

proc ExistPostLegend { } {
    global PLegendPriv
    set ret 0
    if { [ info exists PLegendPriv(window)] && [ winfo exists $PLegendPriv(window)]} {
	set ret 1
    } else {
	set ret 0
    }
    return $ret
}

proc PostLegendInside { } {
    global PLegendPriv

    GiD_Process Mescape Hardcopy Options ShowLegends yes
    destroy $PLegendPriv(window)
}

proc PostLegend { { w .gid.wPostLegend } } {
    global GIDDEFAULT PLegendPriv

    set PLegendPriv(window) $w

    InitWindow $w [_ "Legend"] PostLegendWindowGeom PostLegend
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    wm minsize $w 160 110

    frame $w.f1 -relief ridge -bd 2
    label $w.f1.l

    canvas $w.f1.c -width 128 -height 200
    set PLegendPriv(CanvasWidth) 128
    set PLegendPriv(CanvasHeight) 200
    grid $w.f1.l -sticky ew -padx 4 -pady 2
    grid $w.f1.c -sticky news -padx 2 -pady 2
    set PLegendPriv(Canvas) $w.f1.c
    set PLegendPriv(CanvasLabel) $w.f1.l

    frame $w.but
    # button $w.but.accept -text [_ "Accept"] -bd 1 -command PostPointAccept
    # button $w.but.original -text [_ "Original"] -bd 1 -command PostPointOriginal
    button $w.but.inside -text [_ "Inside"] -bd 1 -command PostLegendInside
    button $w.but.close -text [_ "Close"] -bd 1 -command "destroy $w"
    SetWidgetsWidthFromText $w.but.inside $w.but.close

    # grid $w.but.accept -padx 4 -pady 2 -sticky ew
    # grid $w.but.original -padx 4 -pady 2 -sticky ew
    grid $w.but.inside $w.but.close -padx 4 -pady 2 -sticky ew

    grid $w.f1 -sticky nsew -padx 3 -pady 3
    grid $w.but -sticky nsew -padx 3 -pady 3
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }
    
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    update
    set width [ winfo reqwidth $w.f1]
    set height [ winfo reqheight $w.f1]
    set PLegendPriv(CanvasWidth) [ expr $width - 10]
    set PLegendPriv(CanvasHeight) [ expr $height - 20 - [ winfo reqheight $PLegendPriv(CanvasLabel)] - 4]
    $PLegendPriv(Canvas) configure -width $PLegendPriv(CanvasWidth) -height $PLegendPriv(CanvasHeight)
    update idletasks

    bind $w.f1 <Configure> "PostLegendResizeCanvas %w %h"
    FillPostLegendInfo

    GiD_Process Mescape Hardcopy Options ShowLegends no
}
