
package require snit

#package provide verifp 1.3 
#now the package number is provided inside the .dll/.so

namespace eval verifp_top {
    variable topdir
    set topdir [file normalize [file dirname [info script]]]
}

#load [file join $::verifp_top::topdir verifp[info sharedlibextension]]

snit::type verifp {
    option -program
    option -version
    option -module
    option -key 
    option -password_dir
    option -web_page_show "http://www.compassis.com"
    option -web_page "http://www.compassis.com/compass/Productos/Contrase%C3%B1as"
    option -versionkeys

    variable name_op_sysinfo
    
    constructor args {
	$self configurelist $args
    }
    onconfigure -versionkeys { value } {
	set options(-versionkeys) $value
	
	deprecated_set_versionkeys {*}$value
    }
    method test_password {} {
	set file [file join $options(-password_dir) password.txt]
	return [vp_getauthorization $options(-program) $options(-version) \
		$options(-module) $options(-key) $file]
    }
    method enter_password { wp } {
	
	package require dialogwin
	package require fulltktree
	package require compass_utils

	set list [vp_getsysinfo]
	if { [llength $list] > 1 } {
	    set w $wp.pass
	    destroy $w
	    dialogwin_snit $w -title [_ "Select local or USB password"]
	    set f [$w giveframe]
	    
	    set columns [list \
		    [list 15 [_ "Type"] left text 1] \
		    [list 15 [_ "Name"] left text 1] \
		    [list 20 [_ "Description"] left text 1] \
		    ]
	    
	    fulltktree $f.tree -selecthandler2 \
		"[list $w invokeok];#" \
		-columns $columns -expand 1 -compass_background 1 \
		-selectmode browse -showlines 0 -showbuttons 0 \
		-indent 0 -width 300
	    
	    set idx 0
	    foreach i $list {
		set l ""
		if { $idx == 0 } {
		    lappend l [_ "Local machine"] [lindex $i 0] ""
		} else {
		    lappend l usb {*}[lrange $i 0 1]
		}
		$f.tree insert end $l
		incr idx
	    }
	    grid $f.tree -sticky nsew
	    grid columnconfigure $f 0 -weight 1
	    grid rowconfigure $f 0 -weight 1
	    
	    tk::TabToWindow $f.tree
	    bind [winfo toplevel $f] <Return> [list $w invokeok]
	    set action [$w createwindow]
	    set item [$f.tree selection get]
	    set type ""
	    if { [llength $item] == 1 && $action == 1 } {
		set type [$f.tree item text $item 0]
		set name [$f.tree item text $item 1]
		set name_op_sysinfo [lindex $list $item-1]
	    }
	    destroy $w
	    if { $type eq "" } { return "" }
	} else {
	    set type [_ "Local machine"]
	    set name_op_sysinfo [lindex $list 0]
	}
	set w $wp.pass
	destroy $w
	package require dialogwin
	dialogwin_snit $w -title [_ "Enter password"]
	set f [$w giveframe]
	text $f.t -bg white -width 40 -height 10 -padx 4 -pady 4 -wrap word
	
	if { $type eq [_ "Local machine"] } {
	    foreach "name os sysinfo" [lindex $list 0] break
	    set usb_file ""
	} else {
	    set os [lindex $list 0 1]
	    foreach i [lrange $list 1 end] {
		if { [lindex $i 0] eq $name } {
		    foreach "name - sysinfo usb_file" $i break
		}
	    }
	}
	set d [list \
		"[_ "Contact your Software dealer to obtain the key for this host:"]\n\n" ""\
		"[_ Name]: " "" $name bold\
		"\n[_ "Operating System"]: " "" $os bold\
		"\n[_ "sysinfo"]: " "" $sysinfo bold\
		"\n\n[_ "or get it from"]:\n\n" ""\
		$options(-web_page_show) "link"\
		]
	eval [list $f.t insert end] $d
	
	set font [font actual [$f.t cget -font]]
	set bfont [concat $font -weight bold]
	set ufont [concat $font -underline 1]
	$f.t tag configure bold -font $bfont
	$f.t tag configure link -foreground blue
	$f.t tag bind link <Enter> "
	    [list $f.t tag configure link -font $ufont]
	    [list $f.t configure -cursor hand2]
	    [list tooltip::show $f.t $options(-web_page)]
	    "
	$f.t tag bind link <Leave> "
	    [list $f.t tag configure link -font $font]
	    [list $f.t configure -cursor ""]
	    [list tooltip::hide]
	    "
	$f.t tag bind link <1> [list cu::file::execute url $options(-web_page)]
	
	$f.t configure -state disabled
	bind $f.t <1> [list focus $f.t]
	bind $f.t <3> [mymethod _contextual_text $f.t %X %Y]
	
	ttk::label $f.l1 -text [_ "Enter the password:"]
	ttk::entry $f.e1 -textvariable [$w give_uservar password ""] -width 5
	bind $f.e1 <3> [mymethod _contextual_entry $f.e1 %X %Y]
	
	grid $f.t - -sticky nsew -padx 2 -pady 2
	grid $f.l1 $f.e1 -sticky w -padx 2 -pady 2
	grid configure $f.e1 -sticky ew
	
	grid columnconfigure $f 1 -weight 1
	grid rowconfigure $f 0 -weight 1
	
	tk::TabToWindow $f.e1
	bind [winfo toplevel $f] <Return> [list $w invokeok]
	set action [$w createwindow]
	while 1 {
	    if { $action <= 0 } { 
		destroy $w
		return ""
	    }
	    set password [string trim [$w give_uservar_value password]]
	    regsub -all -- {-} $password {} password
	    set ret [vp_verifypassword $options(-program) $options(-version) \
		    $options(-module) $options(-key) {*}$name_op_sysinfo $password]

	    if { [lindex $ret 0] eq "BAD" } {
		snit_messageBox -message [_ "Password is not correct (%s)" \
		        [lindex $ret 1]] -parent $w
	    } else {
		set err [catch { $self _copy_password_to_file \
		            $name $password $usb_file } errstring]
		if { $err } {
		    snit_messageBox -message [_ "It is necessary to have 'Administrator permissions' in order to enter a password (%s)" \
		            $errstring] -parent $w
		} else {
		    destroy $w
		    return $password
		}
	    }
	    set action [$w waitforwindow]
	}
    }
    method _copy_password_to_file { name password usb_file } {
	set file [file join $options(-password_dir) password.txt]
#         if { [file exists $file] } {
#             file copy -force $file $file~
#         }

	set d [clock format [clock seconds] -format "%Y-%m-%d"]
	set txt "$name $password $options(-program) $options(-version)\
	    $options(-module) # $d Password for module '$options(-module)'"

	set fout [open $file a]
	puts $fout $txt
	close $fout

	if { $usb_file ne "" } {
	    set fout [open $usb_file a]
	    puts $fout $txt
	    close $fout
	}
    }
    method _contextual_text { text x y } {
	destroy $text.menu
	set menu [menu $text.menu -tearoff 0]
	$menu add command -label [_ "Copy"] -command \
	    [mymethod _copy_text $text]
	tk_popup $menu $x $y
    }
    method _copy_text { text } {
	set err [catch { $text get sel.first sel.last } data]
	if { $err } {
	    set data [$text get 1.0 end-1c]
	}
	clipboard clear
	clipboard append $data
    }
    method _contextual_entry { entry x y } {
	destroy $entry.menu
	set menu [menu $entry.menu -tearoff 0]
	$menu add command -label [_ "Paste"] -command \
	    [mymethod _paste_entry $entry]
	tk_popup $menu $x $y
    }
    method _paste_entry { entry } {
	set err [catch {clipboard get} data]
	if { !$err } {
	    $entry delete 0 end
	    $entry insert end $data
	}
    }
}


